import { EuiTooltipInterface } from '../models/eui-tooltip.config';
import * as i0 from "@angular/core";
export declare class EuiTooltipContainerComponent {
    /**
     * Configuration provided by euiTooltip directive at instantiation.
     *
     * @type {EuiTooltipInterface} A config object containing e2eAttr, tooltipContent, position, contentAlign, colorClass.
     */
    config: EuiTooltipInterface;
    /**
     * Sets the `data-e2e` attribute for the host element.
     *
     * @default 'eui-tooltip'
     */
    e2e: string;
    /**
     * @description
     * Computes and returns the CSS classes for the component based on its current state.
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    get showHide(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTooltipContainerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiTooltipContainerComponent, "eui-tooltip-container.component", never, { "config": { "alias": "config"; "required": false; }; }, {}, never, never, true, never>;
}
//# sourceMappingURL=eui-tooltip-container.component.d.ts.map