import { CdkAccordionItem } from '@angular/cdk/accordion';
import { BaseStatesDirective } from '@eui/components/shared';
import * as i0 from "@angular/core";
import * as i1 from "@angular/cdk/accordion";
import * as i2 from "@eui/components/shared";
/**
 * Individual accordion item component that can be expanded/collapsed.
 * Uses Angular CDK's accordion item functionality for managing expansion state
 * and includes collapse animation.
 *
 * @property {boolean} isExpanded - Controls whether the item is expanded or collapsed
 */
export declare class EuiAccordionItemComponent {
    /**
     * @description
     * Computes and returns the CSS classes for the component based on its current state.
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    /** @description Instance of BaseStatesDirective for managing component states */
    protected baseStatesDirective: BaseStatesDirective;
    protected accItem: CdkAccordionItem;
    /**
     * Handles the toggle event for expanding/collapsing the accordion item
     * Prevents event propagation to avoid interfering with parent handlers
     *
     * @param event - The toggle event
     */
    onToggle(event: Event): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAccordionItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiAccordionItemComponent, "eui-accordion-item", never, {}, {}, never, ["eui-accordion-item-header", "*"], true, [{ directive: typeof i1.CdkAccordionItem; inputs: { "expanded": "isExpanded"; }; outputs: {}; }, { directive: typeof i2.BaseStatesDirective; inputs: { "euiSizeS": "euiSizeS"; "euiSizeM": "euiSizeM"; "euiSizeL": "euiSizeL"; "euiSizeVariant": "euiSizeVariant"; }; outputs: {}; }]>;
}
/**
 * Directive for customizing the header content of an accordion item.
 *
 */
export declare class EuiAccordionItemHeaderDirective {
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAccordionItemHeaderDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiAccordionItemHeaderDirective, "eui-accordion-item-header", never, {}, {}, never, never, true, never>;
}
//# sourceMappingURL=eui-accordion-item.component.d.ts.map