import * as i0 from "@angular/core";
import * as i1 from "@angular/cdk/accordion";
/**
 * Accordion container component that manages expandable items.
 * Uses Angular CDK's accordion functionality for managing expansion state.
 *
 * @property {boolean} isMulti - When true, allows multiple items to be expanded simultaneously.
 *                              When false (default), only one item can be expanded at a time.
 */
export declare class EuiAccordionComponent {
    /**
     * @description
     * Computes and returns the CSS classes for the component based on its current state.
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAccordionComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiAccordionComponent, "eui-accordion", never, {}, {}, never, ["*"], true, [{ directive: typeof i1.CdkAccordion; inputs: { "multi": "isMulti"; }; outputs: {}; }]>;
}
//# sourceMappingURL=eui-accordion.component.d.ts.map