import * as i0 from "@angular/core";
/**
 * @description
 * Component used internally by `eui-autocomplete` with the option `groupBy`. It allows to display the options in groups.
 */
export declare class EuiAutocompleteOptionGroupComponent {
    /**
     * ARIA role for the host element to ensure proper accessibility.
     * @default 'optgroup'
     */
    role: string;
    /**
     * @description
     * Computes and returns the CSS classes for the component based on its current state.
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    /**
     * Sets the label of the group.
     */
    label: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAutocompleteOptionGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiAutocompleteOptionGroupComponent, "eui-autocomplete-option-group", never, { "label": { "alias": "label"; "required": false; }; }, {}, never, ["*"], true, never>;
}
//# sourceMappingURL=eui-autocomplete-option-group.component.d.ts.map