import * as i0 from "@angular/core";
import * as i1 from "@eui/components/shared";
/**
 * @description
 * Component used internally by `eui-autocomplete` to display the options in the panel.
 */
export declare class EuiAutocompleteOptionComponent {
    /**
     * ARIA role for the host element to ensure proper accessibility.
     * @default 'option'
     */
    role: string;
    /**
     * @description
     * Computes and returns the CSS classes for the component based on its current state.
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    /**
     * Whether the option is active in the panel.
     *
     * @default false
     */
    isActive: boolean;
    /**
     * Whether the option is disabled in the panel.
     *
     * @default false
     */
    isDisabled: boolean;
    /**
     * Whether the option is displayed inside a group.
     *
     * @default false
     */
    isGroupItem: boolean;
    private baseStatesDirective;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAutocompleteOptionComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiAutocompleteOptionComponent, "eui-autocomplete-option", never, { "isActive": { "alias": "isActive"; "required": false; }; "isDisabled": { "alias": "isDisabled"; "required": false; }; "isGroupItem": { "alias": "isGroupItem"; "required": false; }; }, {}, never, ["*"], true, [{ directive: typeof i1.BaseStatesDirective; inputs: { "euiVariant": "euiVariant"; }; outputs: {}; }]>;
    static ngAcceptInputType_isActive: unknown;
    static ngAcceptInputType_isDisabled: unknown;
    static ngAcceptInputType_isGroupItem: unknown;
}
//# sourceMappingURL=eui-autocomplete-option.component.d.ts.map