import * as i0 from "@angular/core";
/**
 * Component representing an avatar badge.
 * This badge can be positioned at the top or bottom of the avatar and is used
 * to display additional information or status indicators.
 *
 * The component uses content projection to allow any content to be displayed inside the badge.
 *
 */
export declare class EuiAvatarBadgeComponent {
    /**
     * Gets the CSS classes to be applied to the host element.
     * Combines the base class with a modifier class based on the position.
     * @returns {string} The combined CSS classes.
     */
    get cssClasses(): string;
    /**
     * Whether the avatar should have a shadow effect
     * @default false
     */
    isPositionBottom: boolean;
    /**
     * The position of the badge relative to the avatar.
     * Can be either 'top' or 'bottom'.
     * @default 'top'
     * @deprecated use isPositionBottom instead
     */
    position: 'top' | 'bottom';
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAvatarBadgeComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiAvatarBadgeComponent, "eui-avatar-badge", never, { "isPositionBottom": { "alias": "isPositionBottom"; "required": false; }; "position": { "alias": "position"; "required": false; }; }, {}, never, ["*"], true, never>;
    static ngAcceptInputType_isPositionBottom: unknown;
}
//# sourceMappingURL=avatar-badge.component.d.ts.map