import { OnInit } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * Component representing an avatar image.
 * Displays an image for an avatar with fallback to a default image when none is provided.
 * Uses the application's configured assets base URL for the default image path.
 *
 *
 */
export declare class EuiAvatarImageComponent implements OnInit {
    /** CSS class applied to the host element */
    string: string;
    /**
     * URL of the image to be displayed in the avatar.
     * If not provided, a default image will be used.
     */
    imageUrl: any;
    /**
     * The final image URL to be used in the template.
     * This will be either the provided imageUrl or a default image URL.
     */
    imageUrlGenerated: string;
    private config;
    /**
     * Initializes the component by setting the image URL.
     * Uses the provided imageUrl if available, otherwise falls back to a default avatar image.
     */
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAvatarImageComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiAvatarImageComponent, "eui-avatar-image", never, { "imageUrl": { "alias": "imageUrl"; "required": false; }; }, {}, never, ["*"], true, never>;
}
//# sourceMappingURL=avatar-image.component.d.ts.map