import * as i0 from "@angular/core";
/**
 * @description
 * Component for displaying a list of avatars.
 * This component serves as a container that arranges multiple avatars in a visually
 * coherent group, typically with slight overlapping to save space.
 *
 * The component uses content projection to allow placing multiple avatar components
 * within it and applies appropriate styling via the 'eui-avatar-list' CSS class.
 */
export declare class EuiAvatarListComponent {
    /**
     * Binds the CSS class 'eui-avatar-list' to the host element.
     * This class provides the styling necessary for arranging avatars in a list.
     * @returns {string} The CSS class name
     */
    get cssClasses(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAvatarListComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiAvatarListComponent, "eui-avatar-list", never, {}, {}, never, ["*"], true, never>;
}
//# sourceMappingURL=avatar-list.component.d.ts.map