import * as i0 from "@angular/core";
/**
 * @description
 * Component for displaying text content within an avatar.
 * This component serves as a container for text that appears inside an avatar,
 * such as initials or short text identifiers.
 *
 * The component applies the 'eui-avatar-text' class to provide appropriate styling
 * for text displayed within an avatar context. It uses content projection to allow
 * any text content to be displayed inside.
 *
 */
export declare class EuiAvatarTextComponent {
    /**
     * Binds the CSS class 'eui-avatar-text' to the host element.
     * This class provides the styling necessary for text content within an avatar.
     */
    string: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiAvatarTextComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiAvatarTextComponent, "eui-avatar-text", never, {}, {}, never, ["*"], true, never>;
}
//# sourceMappingURL=avatar-text.component.d.ts.map