import { BaseStatesDirective } from '@eui/components/shared';
import * as i0 from "@angular/core";
import * as i1 from "@eui/components/shared";
/**
 * @description
 * A badge component that can display text, numbers, or icons with various states and styles.
 * Supports content truncation, empty states, and icon-only modes.
 *
 */
export declare class EuiBannerComponent {
    /**
     * @description
     * Computes and returns the CSS classes for the badge based on its current state
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    /** @description ARIA role for accessibility */
    role: string;
    /** @description Data attribute for e2e testing */
    e2eAttr: string;
    /**
     * @description Whether as position top
     * @default false
     */
    euiPositionTop: boolean;
    /**
     * @description Whether as position center
     * @default false
     */
    euiPositionCenter: boolean;
    /**
     * @description Whether as position bottom
     * @default false
     */
    euiInverse: boolean;
    /**
     * @description Whether as position bottom
     * @default false
     */
    isVideoBanner: boolean;
    imageUrl: string;
    /** @description Instance of BaseStatesDirective for managing component states */
    protected baseStatesDirective: BaseStatesDirective;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiBannerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiBannerComponent, "eui-banner", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "euiPositionTop": { "alias": "euiPositionTop"; "required": false; }; "euiPositionCenter": { "alias": "euiPositionCenter"; "required": false; }; "euiInverse": { "alias": "euiInverse"; "required": false; }; "isVideoBanner": { "alias": "isVideoBanner"; "required": false; }; "imageUrl": { "alias": "imageUrl"; "required": false; }; }, {}, never, ["eui-banner-video", "eui-banner-title", "eui-banner-description", "eui-banner-cta"], true, [{ directive: typeof i1.BaseStatesDirective; inputs: { "euiSizeS": "euiSizeS"; "euiSizeM": "euiSizeM"; "euiSizeL": "euiSizeL"; "euiSizeVariant": "euiSizeVariant"; "euiOutline": "euiOutline"; }; outputs: {}; }]>;
    static ngAcceptInputType_euiPositionTop: unknown;
    static ngAcceptInputType_euiPositionCenter: unknown;
    static ngAcceptInputType_euiInverse: unknown;
    static ngAcceptInputType_isVideoBanner: unknown;
}
//# sourceMappingURL=eui-banner.component.d.ts.map