import * as i0 from "@angular/core";
/**
 * @description
 * EuiBlockDocumentComponent creates a document overlay that can be toggled into
 * a blocked state. When blocked, a loading indicator is displayed.
 * Uses OnPush change detection strategy for better performance.
 */
export declare class EuiBlockDocumentComponent {
    /**
     * Applies CSS classes to the host element.
     * Always includes 'eui-block-document' and conditionally adds
     * 'eui-block-document--blocked' when isBlocked is true.
     *
     * @returns String of space-separated CSS classes
     */
    get cssClasses(): string;
    /**
     * Controls whether the document is in blocked state.
     * When true, displays the loading indicator.
     *
     * @default false
     */
    isBlocked: boolean;
    /**
     * ARIA role for the document component.
     *
     * @default 'region'
     */
    role: string;
    /**
     * ARIA label for the document component.
     *
     * @default 'eUI Block Document'
     */
    ariaLabel: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiBlockDocumentComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiBlockDocumentComponent, "eui-block-document", never, { "isBlocked": { "alias": "isBlocked"; "required": false; }; "ariaLabel": { "alias": "ariaLabel"; "required": false; }; }, {}, never, never, true, never>;
    static ngAcceptInputType_isBlocked: unknown;
}
//# sourceMappingURL=eui-block-document.component.d.ts.map