import { AfterContentInit, OnDestroy } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * Component that provides a breadcrumb navigation.
 */
export declare class EuiBreadcrumbComponent implements AfterContentInit, OnDestroy {
    string: string;
    /** Query list of breadcrumb items occurrences on the content */
    private breadcrumbItems;
    private vcr;
    private destroy$;
    /** Observable emitting when the breadcrumb Items List has changed */
    private breadcrumbItemsListChanged;
    private viewContainerRef;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    /**
     * Adds a crumb in the chain
     *
     * @param crumb It can either be a Component reference or BreadCrumbItem object
     * @throws Will throw an error if given ID already exists.
     */
    private add;
    /**
     * Removes a crumb from the chain
     *
     * @param crumb Can be either a crumb instance or a crumb ID
     * @throws Will throw an error if given ID is not found.
     */
    private remove;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiBreadcrumbComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiBreadcrumbComponent, "eui-breadcrumb", never, {}, {}, ["breadcrumbItems"], ["*"], true, never>;
}
//# sourceMappingURL=breadcrumb.component.d.ts.map