import { ElementRef, OnDestroy, OnInit } from '@angular/core';
import { NavigationExtras } from '@angular/router';
import * as i0 from "@angular/core";
export declare class EuiBreadcrumbItemComponent implements OnDestroy, OnInit {
    string: string;
    /**
     * A unique id for the breadcrumb
     */
    id: string;
    /**
     * The label of the breadcrumbItem. It might get truncated if it's too long.
     */
    label: string;
    /**
     * Commands to pass to {@link Router#createUrlTree Router#createUrlTree}.
     *   - **array**: commands to pass to {@link Router#createUrlTree Router#createUrlTree}.
     *   - **string**: shorthand for an array of commands with just the string, i.e. `['/route']`
     *   - **null|undefined**: Disables the link by removing the `href`
     */
    link: string | any[];
    /**
     * A fragment
     */
    navigationExtras: NavigationExtras;
    /** calculated item width */
    width: number;
    hasPrevious: boolean;
    hasNext: boolean;
    /** state of breadcrumb item in case of collapsed */
    collapsed: boolean;
    elementRef: ElementRef<any>;
    private previousCrumb;
    private nextCrumb;
    private host;
    private router;
    private cdr;
    private logService;
    ngOnInit(): void;
    ngOnDestroy(): void;
    destroy(): void;
    /**
     * set the previous breadcrumb item
     *
     * @param  breadcrumbItem The previous item to point to.
     */
    setPrevious(breadcrumbItem: EuiBreadcrumbItemComponent): void;
    /**
     * set the next breadcrumb item
     *
     * @param breadcrumbItem The next item to point to.
     */
    setNext(breadcrumbItem: EuiBreadcrumbItemComponent): void;
    /**
     * A callback to navigate to the given link using ng-router.
     *
     * @param event
     */
    onClick(): boolean;
    /**
     * get the next breadcrumb item
     */
    private getNext;
    /**
     * get the previous breadcrumb item
     */
    private getPrevious;
    private rendererIconBefore;
    private isLast;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiBreadcrumbItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiBreadcrumbItemComponent, "eui-breadcrumb-item", never, { "id": { "alias": "id"; "required": false; }; "label": { "alias": "label"; "required": false; }; "link": { "alias": "link"; "required": false; }; "navigationExtras": { "alias": "navigationExtras"; "required": false; }; }, {}, never, never, true, never>;
}
//# sourceMappingURL=breadcrumb-item.component.d.ts.map