import { CdkDropList } from '@angular/cdk/drag-drop';
import { BehaviorSubject } from 'rxjs';
import * as i0 from "@angular/core";
/**
 * @description
 * Service used internally by `eui-chip-list` for the drag and drop feature.
 */
export declare class EuiChipListDragService {
    componentConnector: CdkDropList[];
    droppableArea: CdkDropList[];
    removedFromDroppable: BehaviorSubject<any>;
    /**
     * Creates a source with a name provided in chip-list component
     *
     * @param sourceName Name of the source
     */
    setComponentConnector(sourceName: string): void;
    /**
     * Creates an area in which the chips can be dropped.
     *
     * @param componentRef Reference to the area.
     * @param sourceNames Possible source that can be dropped.
     */
    setDroppableArea(componentRef: CdkDropList, sourceNames: string[]): void;
    removeFromDroppable(item: any | null): void;
    /**
     * Reset the service when `OnDestroy` hook of the component is called.
     */
    resetConnector(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiChipListDragService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<EuiChipListDragService>;
}
//# sourceMappingURL=eui-chip-list-drag.service.d.ts.map