import { BaseStatesDirective } from '@eui/components/shared';
import { LocaleService, LocaleState } from '@eui/core';
import * as i0 from "@angular/core";
import * as i1 from "@eui/components/shared";
/**
 * @description
 * A badge component that can display text, numbers, or icons with various states and styles.
 * Supports content truncation, empty states, and icon-only modes.
 *
 */
export declare class EuiDateBlockComponent {
    /**
     * @description
     * Computes and returns the CSS classes for the badge based on its current state
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    /** @description ARIA role for accessibility */
    role: string;
    /** @description Data attribute for e2e testing */
    e2eAttr: string;
    dateFormat: string;
    blockDate: Date;
    /** @description Instance of BaseStatesDirective for managing component states */
    protected baseStatesDirective: BaseStatesDirective;
    protected locale: LocaleService<LocaleState>;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiDateBlockComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiDateBlockComponent, "eui-date-block", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "dateFormat": { "alias": "dateFormat"; "required": false; }; "blockDate": { "alias": "blockDate"; "required": false; }; }, {}, never, never, true, [{ directive: typeof i1.BaseStatesDirective; inputs: { "euiPrimary": "euiPrimary"; "euiSecondary": "euiSecondary"; }; outputs: {}; }]>;
}
//# sourceMappingURL=eui-date-block.component.d.ts.map