import { ValidatorFn } from '@angular/forms';
import { DateAdapter } from '@angular/material/core';
/**
 * @description
 * Validator that checks that the start date isn't after the end date.
 *
 * @usageNotes
 * If the user types a value in the input field that is not aligned with the provided format the component propagates a null value that
 * can be used to validate the input field.
 *
 * @returns An error map with the
 * `euiDateRangeInvalid` if the validation check fails, otherwise `null`.
 */
export declare const euiStartEndDateValidator: (adapter: DateAdapter<any>) => ValidatorFn;
//# sourceMappingURL=eui-date-range-selector.validators.d.ts.map