import { OnInit, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { CdkPortalOutletAttachedRef, ComponentPortal, TemplatePortal } from '@angular/cdk/portal';
import { BehaviorSubject } from 'rxjs';
import { EuiDialogInterface, EuiDialogComponentInstances } from '../models/eui-dialog.config';
import * as i0 from "@angular/core";
export declare class EuiDialogContainerComponent<HC, HCC, BC, BCC, FC, FCC> implements OnInit, OnDestroy {
    cd: ChangeDetectorRef;
    dialogContainerConfig: EuiDialogInterface<HC, HCC, BC, BCC, FC, FCC>;
    isHeaderTemplatePortal: boolean;
    isBodyTemplatePortal: boolean;
    isFooterTemplatePortal: boolean;
    isHeaderComponentPortal: boolean;
    isBodyComponentPortal: boolean;
    isFooterComponentPortal: boolean;
    headerComponentPortal: ComponentPortal<HC>;
    bodyComponentPortal: ComponentPortal<BC>;
    footerComponentPortal: ComponentPortal<FC>;
    componentInstances: EuiDialogComponentInstances<HC, BC, FC>;
    acceptButtonDisabled$: BehaviorSubject<boolean>;
    dismissButtonDisabled$: BehaviorSubject<boolean>;
    string: string;
    ariaModal: boolean;
    private destroy$;
    private injector;
    ngOnInit(): void;
    ngOnDestroy(): void;
    get getComponentInstances(): EuiDialogComponentInstances<HC, BC, FC>;
    get getPortalOutlet(): TemplatePortal | null;
    get dialogContainerConfigContent(): string;
    portalAttached(attachedRef: CdkPortalOutletAttachedRef, component: 'headerComponent' | 'bodyComponent' | 'footerComponent'): void;
    closeDialog(): void;
    onDismiss(): void;
    onAccept(): void;
    /**
     * Based on certain conditions returns the id of the body content to the aria-describedby attr of the container
     */
    getContentId(): string;
    /**
     * Disable Accept button of default eui-dialog footer.
     */
    disableAcceptButton(): void;
    /**
     * Enable Accept button of default eui-dialog footer.
     */
    enableAcceptButton(): void;
    /**
     * Disable Dismiss button of default eui-dialog footer.
     */
    disableDismissButton(): void;
    /**
     * Enable Dismiss button of default eui-dialog footer.
     */
    enableDismissButton(): void;
    onScroll(): void;
    private createComponentPortal;
    private createInjector;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiDialogContainerComponent<any, any, any, any, any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiDialogContainerComponent<any, any, any, any, any, any>, "eui-dialog-container", never, {}, {}, never, never, true, never>;
}
//# sourceMappingURL=eui-dialog-container.component.d.ts.map