import { PipeTransform } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * A pipe that transforms a file size in bytes into a human-readable format (e.g., KB, MB, GB).
 *
 * @example
 * {{ 1024 | filesize }}  // Outputs: "1.00 KB"
 * {{ 1048576 | filesize:1 }}  // Outputs: "1.0 MB"
 *
 * @param {number} bytes - The file size in bytes.
 * @param {number} [precision=2] - The number of decimal places to include in the output.
 * @returns {string} The formatted file size with the appropriate unit.
 */
export declare class EuiFileSizePipe implements PipeTransform {
    private units;
    /**
     * Method used to format a size.
     *
     * @param bytes Bytes to format.
     * @param precision Number of decimal
     * @returns String with formated size and unit.
     */
    transform(bytes?: number, precision?: number): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiFileSizePipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<EuiFileSizePipe, "filesize", true>;
}
//# sourceMappingURL=filesize.pipe.d.ts.map