import { DoCheck, ElementRef, EventEmitter, OnDestroy } from '@angular/core';
import { EuiGrowlMessage } from '@eui/core';
import * as i0 from "@angular/core";
export declare class EuiGrowlComponent implements DoCheck, OnDestroy {
    el: ElementRef<any>;
    titleId: string;
    contentId: string;
    get cssClasses(): string;
    e2eAttr: string;
    protected role: string;
    protected ariaLive: string;
    protected ariaLabelledBy: string;
    protected ariaDescribedBy: string;
    sticky: boolean;
    life: number;
    value: EuiGrowlMessage[];
    closeAllSticky: boolean;
    position: string;
    growlClick: EventEmitter<void>;
    private differ;
    constructor();
    ngDoCheck(): void;
    /**
     * @param msg The text message to appear in the container
     */
    remove(msg: EuiGrowlMessage): void;
    /**
     * Removes all growl messages from the stack
     */
    removeAll(): void;
    ngOnDestroy(): void;
    onClick(): void;
    /**
     * check whether sticky growls are greater than two
     */
    isGrowlMoreThanTwo(): boolean;
    /**
     * Removes all growl messages from the stack
     *
     * @param value
     */
    private createRemovalTimeout;
    /**
     * Finds UxMessage index of the array otherwise returns -1
     *
     * @param msg UxMessage
     */
    private findMessageIndex;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiGrowlComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiGrowlComponent, "eui-growl", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "sticky": { "alias": "sticky"; "required": false; }; "life": { "alias": "life"; "required": false; }; "value": { "alias": "value"; "required": false; }; "closeAllSticky": { "alias": "closeAllSticky"; "required": false; }; "position": { "alias": "position"; "required": false; }; }, { "growlClick": "growlClick"; }, never, never, true, never>;
    static ngAcceptInputType_sticky: unknown;
}
//# sourceMappingURL=eui-growl.component.d.ts.map