import { OnInit, OnChanges, SimpleChanges, AfterContentInit } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * The EuiIconSvgComponent is used to display SVG icons in the application.
 * It allows for customization of the icon's size, color, and other properties.
 *
 */
export declare class EuiIconSvgComponent implements AfterContentInit, OnChanges, OnInit {
    ariaRole: string;
    icon: string;
    fillColor: string;
    set: string;
    size: '2xs' | 'xs' | 's' | 'm' | 'l' | 'xl' | '2xl' | '3xl' | '4xl' | string;
    style: string;
    iconUrl: string;
    transform: string;
    /**
     * @deprecated euiVariant is not used and will be removed in v20.
     */
    euiVariant: string;
    get cssClasses(): string;
    ariaLabel: string;
    iconName: string;
    assetsBaseUrl: string;
    iconStyle: string;
    ariaHidden: boolean;
    focusable: boolean;
    isLoading: boolean;
    isInputIcon: boolean;
    euiStart: boolean;
    euiEnd: boolean;
    private config;
    ngOnInit(): void;
    ngOnChanges(c: SimpleChanges): void;
    ngAfterContentInit(): void;
    private _setIconAndSet;
    private _setStyle;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiIconSvgComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiIconSvgComponent, "eui-icon-svg, span[euiIconSvg], i[euiIconSvg]", never, { "icon": { "alias": "icon"; "required": false; }; "fillColor": { "alias": "fillColor"; "required": false; }; "set": { "alias": "set"; "required": false; }; "size": { "alias": "size"; "required": false; }; "style": { "alias": "style"; "required": false; }; "iconUrl": { "alias": "iconUrl"; "required": false; }; "transform": { "alias": "transform"; "required": false; }; "euiVariant": { "alias": "euiVariant"; "required": false; }; "ariaLabel": { "alias": "aria-label"; "required": false; }; "ariaHidden": { "alias": "ariaHidden"; "required": false; }; "focusable": { "alias": "focusable"; "required": false; }; "isLoading": { "alias": "isLoading"; "required": false; }; "isInputIcon": { "alias": "isInputIcon"; "required": false; }; "euiStart": { "alias": "euiStart"; "required": false; }; "euiEnd": { "alias": "euiEnd"; "required": false; }; }, {}, never, ["*"], true, never>;
    static ngAcceptInputType_ariaHidden: unknown;
    static ngAcceptInputType_focusable: unknown;
    static ngAcceptInputType_isLoading: unknown;
    static ngAcceptInputType_isInputIcon: unknown;
    static ngAcceptInputType_euiStart: unknown;
    static ngAcceptInputType_euiEnd: unknown;
}
/**
 * @description
 * A module for the icon component. This module imports the
 *
 * @deprecated Use the {@link EUI_ICON} instead
 */
export declare class EuiIconModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiIconModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<EuiIconModule, never, [typeof EuiIconSvgComponent], [typeof EuiIconSvgComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<EuiIconModule>;
}
//# sourceMappingURL=eui-icon-svg.component.d.ts.map