import * as i0 from "@angular/core";
/**
 * @description
 * A component that represents an individual item within an input group add-on.
 * Can be used either as an attribute selector on a div or as a custom element.
 */
export declare class EuiInputGroupAddOnItemComponent {
    /**
     * @description
     * Input property for setting the data-e2e attribute value.
     * Used for end-to-end testing purposes.
     *
     * @default 'eui-input-group-addon-item'
     */
    e2eAttr: string;
    /**
     * @description
     * Getter that returns the CSS class for the component.
     * Bound to the host element's class attribute.
     *
     * @returns {string} The CSS class name
     */
    get cssClasses(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiInputGroupAddOnItemComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiInputGroupAddOnItemComponent, "div[euiInputGroupAddOnItem], eui-input-group-addon-item", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; }, {}, never, ["*"], true, never>;
}
//# sourceMappingURL=eui-input-group-addon-item.component.d.ts.map