import * as i0 from "@angular/core";
/**
 * @description
 * A component that serves as a container for input group add-on items.
 * Can be used either as an attribute selector on a div or as a custom element.
 */
export declare class EuiInputGroupAddOnComponent {
    /**
     * @description
     * Input property for setting the data-e2e attribute value.
     * Used for end-to-end testing purposes.
     *
     * @default 'eui-input-group-addon'
     */
    e2eAttr: string; /**
     * @description
     * Getter that returns the CSS class for the component.
     * Bound to the host element's class attribute.
     *
     * @returns {string} The CSS class name
     */
    get cssClasses(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiInputGroupAddOnComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiInputGroupAddOnComponent, "div[euiInputGroupAddOn], eui-input-group-addon", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; }, {}, never, ["*"], true, never>;
}
//# sourceMappingURL=eui-input-group-addon.component.d.ts.map