import * as i0 from "@angular/core";
/**
 * @description
 * A component that serves as the main container for input group elements.
 * Can only be used as an attribute selector on a div element.
 */
export declare class EuiInputGroupComponent {
    /**
     * @description
     * Input property for setting the data-e2e attribute value.
     * Used for end-to-end testing purposes.
     *
     * @default 'eui-input-group'
     */
    e2eAttr: string;
    /**
     * @description
     * Getter that returns the CSS class for the component.
     * Bound to the host element's class attribute.
     *
     * @returns {string} The CSS class name
     */
    get cssClasses(): string;
    /**
     * @description
     * Protected property that defines the type of the input group.
     * Bound to the host element's type attribute.
     *
     * @protected
     * @default 'inputGroup'
     */
    protected type: string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiInputGroupComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiInputGroupComponent, "div[euiInputGroup]", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; }, {}, never, ["*"], true, never>;
}
//# sourceMappingURL=eui-input-group.component.d.ts.map