import { OnDestroy, OnInit, EventEmitter, AfterViewInit, SimpleChanges, OnChanges } from '@angular/core';
import { EuiLanguage } from '@eui/core';
import { EuiAppShellService } from '@eui/core';
import * as i0 from "@angular/core";
export declare class EuiLanguageSelectorComponent implements OnInit, AfterViewInit, OnDestroy, OnChanges {
    get cssClasses(): string;
    languages: EuiLanguage[];
    selectedLanguage: EuiLanguage;
    hasLanguageSelection: boolean;
    isToolbarSelector: boolean;
    euiPrimary: boolean;
    ariaLabel: string;
    languageSelectorClick: EventEmitter<null>;
    appShellService: EuiAppShellService;
    private destroy$;
    private isAriaLabelChanged;
    private cd;
    private euiDialogService;
    private translateService;
    private elRef;
    /**
     * returns true if there are at least one and max four languages.
     */
    get isShowDropDown(): boolean;
    /**
     * returns true if there are at least five languages.
     */
    get isShowModal(): boolean;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onLanguageChanged(language: EuiLanguage): void;
    /**
     * Opens the modal that renders the UxLanguage array with modal actions bindings to this Component
     */
    onOpen(titleLabel?: string): void;
    onClick(): void;
    /**
     * returns the UxLanguage Object from a given language code
     *
     * @param languageCode two char language code
     * @protected
     */
    protected getLanguage(languageCode: string): EuiLanguage;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiLanguageSelectorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiLanguageSelectorComponent, "eui-language-selector", never, { "hasLanguageSelection": { "alias": "hasLanguageSelection"; "required": false; }; "isToolbarSelector": { "alias": "isToolbarSelector"; "required": false; }; "euiPrimary": { "alias": "euiPrimary"; "required": false; }; "ariaLabel": { "alias": "aria-label"; "required": false; }; }, { "languageSelectorClick": "languageSelectorClick"; }, never, never, true, never>;
    static ngAcceptInputType_hasLanguageSelection: unknown;
    static ngAcceptInputType_isToolbarSelector: unknown;
    static ngAcceptInputType_euiPrimary: unknown;
}
//# sourceMappingURL=language-selector.component.d.ts.map