import { OnInit, QueryList, EventEmitter, OnDestroy } from '@angular/core';
import { EuiAppShellService } from '@eui/core';
import { BaseStatesDirective } from '@eui/components/shared';
import * as i0 from "@angular/core";
import * as i1 from "@eui/components/shared";
export declare class EuiPageColumnComponent implements OnInit, OnDestroy {
    get cssClasses(): string;
    label: any;
    subLabel: any;
    autocloseContainerWidth: number;
    expandAriaLabel: string;
    collapseAriaLabel: string;
    isCollapsible: boolean;
    isCollapsed: boolean;
    isRightCollapsible: boolean;
    isHighlighted: boolean;
    isCollapsedWithIcons: boolean;
    hasSidebarMenu: boolean;
    hasHeaderBodyShrinkable: boolean;
    isAutocloseOnContainerResize: boolean;
    isAutocloseOnMobile: boolean;
    collapse: EventEmitter<any>;
    headerCollapse: EventEmitter<any>;
    isActive: boolean;
    isHeaderBodyShrinked: boolean;
    hasPreventMobileRendering: boolean;
    customHeaderBodyContent: QueryList<EuiPageColumnHeaderBodyContentDirective>;
    customHeaderLeftContent: QueryList<EuiPageColumnHeaderLeftContentDirective>;
    customHeaderRightContent: QueryList<EuiPageColumnHeaderRightContentDirective>;
    customHeaderCollapsedContent: QueryList<EuiPageColumnHeaderCollapsedContentDirective>;
    customFooterContent: QueryList<EuiPageColumnFooterContentDirective>;
    currentOffset: number;
    previousOffset: number;
    treshHold: number;
    asService: EuiAppShellService;
    protected baseStatesDirective: BaseStatesDirective;
    private pageColumnsParent;
    private destroy$;
    ngOnInit(): void;
    ngOnDestroy(): void;
    onToggle(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiPageColumnComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiPageColumnComponent, "eui-page-column", never, { "label": { "alias": "label"; "required": false; }; "subLabel": { "alias": "subLabel"; "required": false; }; "autocloseContainerWidth": { "alias": "autocloseContainerWidth"; "required": false; }; "expandAriaLabel": { "alias": "expandAriaLabel"; "required": false; }; "collapseAriaLabel": { "alias": "collapseAriaLabel"; "required": false; }; "isCollapsible": { "alias": "isCollapsible"; "required": false; }; "isCollapsed": { "alias": "isCollapsed"; "required": false; }; "isRightCollapsible": { "alias": "isRightCollapsible"; "required": false; }; "isHighlighted": { "alias": "isHighlighted"; "required": false; }; "isCollapsedWithIcons": { "alias": "isCollapsedWithIcons"; "required": false; }; "hasSidebarMenu": { "alias": "hasSidebarMenu"; "required": false; }; "hasHeaderBodyShrinkable": { "alias": "hasHeaderBodyShrinkable"; "required": false; }; "isAutocloseOnContainerResize": { "alias": "isAutocloseOnContainerResize"; "required": false; }; "isAutocloseOnMobile": { "alias": "isAutocloseOnMobile"; "required": false; }; }, { "collapse": "collapse"; "headerCollapse": "headerCollapse"; }, ["customHeaderBodyContent", "customHeaderLeftContent", "customHeaderRightContent", "customHeaderCollapsedContent", "customFooterContent"], ["eui-page-column-header-collapsed-content", "eui-page-column-header-left-content", "eui-page-column-header-right-content", "eui-page-column-header-body", "*", "eui-page-column-footer", "eui-page-column-body"], true, [{ directive: typeof i1.BaseStatesDirective; inputs: { "euiSizeS": "euiSizeS"; "euiSizeM": "euiSizeM"; "euiSizeL": "euiSizeL"; "euiSizeXL": "euiSizeXL"; "euiSize2XL": "euiSize2XL"; "euiSize3XL": "euiSize3XL"; "euiSize4XL": "euiSize4XL"; "euiSizeVariant": "euiSizeVariant"; "euiHighlighted": "euiHighlighted"; }; outputs: {}; }]>;
    static ngAcceptInputType_isCollapsible: unknown;
    static ngAcceptInputType_isCollapsed: unknown;
    static ngAcceptInputType_isRightCollapsible: unknown;
    static ngAcceptInputType_isHighlighted: unknown;
    static ngAcceptInputType_isCollapsedWithIcons: unknown;
    static ngAcceptInputType_hasSidebarMenu: unknown;
    static ngAcceptInputType_hasHeaderBodyShrinkable: unknown;
    static ngAcceptInputType_isAutocloseOnContainerResize: unknown;
    static ngAcceptInputType_isAutocloseOnMobile: unknown;
}
export declare class EuiPageColumnHeaderBodyContentDirective {
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiPageColumnHeaderBodyContentDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiPageColumnHeaderBodyContentDirective, "eui-page-column-header-body", never, {}, {}, never, never, true, never>;
}
export declare class EuiPageColumnHeaderLeftContentDirective {
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiPageColumnHeaderLeftContentDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiPageColumnHeaderLeftContentDirective, "eui-page-column-header-left-content", never, {}, {}, never, never, true, never>;
}
export declare class EuiPageColumnHeaderRightContentDirective {
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiPageColumnHeaderRightContentDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiPageColumnHeaderRightContentDirective, "eui-page-column-header-right-content", never, {}, {}, never, never, true, never>;
}
export declare class EuiPageColumnHeaderCollapsedContentDirective {
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiPageColumnHeaderCollapsedContentDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiPageColumnHeaderCollapsedContentDirective, "eui-page-column-header-collapsed-content", never, {}, {}, never, never, true, never>;
}
export declare class EuiPageColumnBodyContentDirective {
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiPageColumnBodyContentDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiPageColumnBodyContentDirective, "eui-page-column-body", never, {}, {}, never, never, true, never>;
}
export declare class EuiPageColumnFooterContentDirective {
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiPageColumnFooterContentDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiPageColumnFooterContentDirective, "eui-page-column-footer", never, {}, {}, never, never, true, never>;
}
//# sourceMappingURL=eui-page-column.component.d.ts.map