import { SimpleChanges, OnChanges } from '@angular/core';
import { BooleanInput, NumberInput } from '@angular/cdk/coercion';
import { BaseStatesDirective } from '@eui/components/shared';
import * as i0 from "@angular/core";
import * as i1 from "@eui/components/shared";
/**
 * Progress bar component that displays a horizontal progress indicator
 * with optional label and status icon.
 */
export declare class EuiProgressBarComponent implements OnChanges {
    /** Element attribute for e2e testing */
    e2eAttr: string;
    /** CSS classes applied to the host element */
    get cssClasses(): string;
    /** Optional label displayed above the progress bar */
    label: string;
    /**
     * Current progress value (0-100)
     * Values greater than 100 will be capped at 100
     */
    progress: NumberInput;
    /**
     * When true, shows an indeterminate progress animation
     * instead of a specific progress value
     */
    isIndeterminate: BooleanInput;
    /**
     * When true, displays a status icon based on the current state
     * (success, warning, error, etc.)
     */
    hasStatusIcon: BooleanInput;
    /**
     * Reference to the BaseStatesDirective for managing component states
     */
    baseStatesDirective: BaseStatesDirective;
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * Generates CSS classes for the component based on current state
     * @returns Space-separated string of CSS class names
     */
    private getCssClasses;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiProgressBarComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiProgressBarComponent, "eui-progress-bar", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "label": { "alias": "label"; "required": false; }; "progress": { "alias": "progress"; "required": false; }; "isIndeterminate": { "alias": "isIndeterminate"; "required": false; }; "hasStatusIcon": { "alias": "hasStatusIcon"; "required": false; }; }, {}, never, never, true, [{ directive: typeof i1.BaseStatesDirective; inputs: { "euiSecondary": "euiSecondary"; "euiSuccess": "euiSuccess"; "euiInfo": "euiInfo"; "euiWarning": "euiWarning"; "euiDanger": "euiDanger"; "euiAccent": "euiAccent"; "euiSize2XS": "euiSize2XS"; "euiSizeXS": "euiSizeXS"; "euiSizeS": "euiSizeS"; "euiSizeM": "euiSizeM"; "euiSizeL": "euiSizeL"; "euiSizeXL": "euiSizeXL"; "euiVariant": "euiVariant"; "euiSizeVariant": "euiSizeVariant"; }; outputs: {}; }]>;
    static ngAcceptInputType_progress: unknown;
    static ngAcceptInputType_isIndeterminate: unknown;
    static ngAcceptInputType_hasStatusIcon: unknown;
}
//# sourceMappingURL=eui-progress-bar.component.d.ts.map