import { OnDestroy } from '@angular/core';
import { ɵNgSelectMultipleOption as NgSelectMultipleOption } from '@angular/forms';
import * as i0 from "@angular/core";
/**
 * @description
 * Marks `<option>` as dynamic, so Angular can be notified when options change.
 *
 * @see `EuiSelectMultipleControlValueAccessor`
 *
 * @ngModule ReactiveFormsModule
 * @ngModule FormsModule
 * @publicApi
 */
export declare class EuiSelectMultipleOption extends NgSelectMultipleOption implements OnDestroy {
    id: string;
    /** @internal */
    _value: any;
    private element;
    private renderer;
    private select;
    constructor();
    /**
     * @description
     * Tracks the value bound to the option element. Unlike the value binding,
     * ngValue supports binding to objects.
     */
    set ngValue(value: any);
    /**
     * @description
     * Tracks simple string values bound to the option element.
     * For objects, use the `ngValue` input binding.
     */
    set value(value: any);
    /** @internal */
    _setElementValue(value: string): void;
    /** @internal */
    _setSelected(selected: boolean): void;
    /** @nodoc */
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiSelectMultipleOption, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiSelectMultipleOption, "option, option[euiOption]", never, { "ngValue": { "alias": "ngValue"; "required": false; }; "value": { "alias": "value"; "required": false; }; }, {}, never, never, true, never>;
}
//# sourceMappingURL=eui-select-mutli-option.directive.d.ts.map