import { AfterViewInit, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { NgSelectOption } from '@angular/forms';
import * as i0 from "@angular/core";
/**
 * @description
 * Marks `<option>` as dynamic, so Angular can be notified when options change.
 *
 * @see `EuiSelectControlValueAccessor`
 *
 * @ngModule ReactiveFormsModule
 * @ngModule FormsModule
 * @publicApi
 */
export declare class EuiNgSelectOptionDirective extends NgSelectOption implements OnDestroy, OnChanges, AfterViewInit {
    selected: boolean;
    label: string;
    private readonly select;
    private readonly selectNative;
    private readonly selectComponent;
    private element;
    private renderer;
    constructor();
    ngAfterViewInit(): void;
    /**
     * @description
     * Tracks the value bound to the option element. Unlike the value binding,
     * ngValue supports binding to objects.
     */
    set ngValue(value: any);
    ngOnChanges(changes: SimpleChanges): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiNgSelectOptionDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<EuiNgSelectOptionDirective, "option:not([eclSelectOption]):not([eclMultiselectOption]), option[euiOption]", never, { "selected": { "alias": "selected"; "required": false; }; "label": { "alias": "label"; "required": false; }; "ngValue": { "alias": "ngValue"; "required": false; }; }, {}, never, never, true, never>;
    static ngAcceptInputType_selected: unknown;
}
//# sourceMappingURL=eui-select-option.directive.d.ts.map