import { BaseStatesDirective } from '@eui/components/shared';
import * as i0 from "@angular/core";
import * as i1 from "@eui/components/shared";
/**
 * @description
 * A badge component that can display text, numbers, or icons with various states and styles.
 * Supports content truncation, empty states, and icon-only modes.
 *
 */
export declare class EuiStatusBadgeComponent {
    /**
     * @description
     * Computes and returns the CSS classes for the badge based on its current state
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    /** @description Data attribute for e2e testing */
    e2eAttr: string;
    /** @description ARIA role for accessibility */
    role: string;
    /** @description ARIA label for accessibility */
    ariaLabel: string | null;
    /**
     * @description Whether to display the badge as a dot
     * @default false
     */
    euiDottedBadge: boolean;
    /** @description Instance of BaseStatesDirective for managing component states */
    protected baseStatesDirective: BaseStatesDirective;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiStatusBadgeComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiStatusBadgeComponent, "div[euiStatusBadge], span[euiStatusBadge], eui-status-badge", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "ariaLabel": { "alias": "aria-label"; "required": false; }; "euiDottedBadge": { "alias": "euiDottedBadge"; "required": false; }; }, {}, never, ["*"], true, [{ directive: typeof i1.BaseStatesDirective; inputs: { "euiPrimary": "euiPrimary"; "euiSecondary": "euiSecondary"; "euiSuccess": "euiSuccess"; "euiInfo": "euiInfo"; "euiWarning": "euiWarning"; "euiDanger": "euiDanger"; "euiAccent": "euiAccent"; "euiVariant": "euiVariant"; "euiSizeS": "euiSizeS"; "euiSizeM": "euiSizeM"; "euiSizeVariant": "euiSizeVariant"; }; outputs: {}; }]>;
    static ngAcceptInputType_euiDottedBadge: unknown;
}
//# sourceMappingURL=eui-status-badge.component.d.ts.map