import { OnInit, OnDestroy } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * Component used internally by `eui-table-v2` to add a 'select all' checkbox in the header of the table.
 */
export declare class EuiTableV2SelectableHeaderComponent<DATA> implements OnInit, OnDestroy {
    /**
     * Whether select all features are available in the header.
     *
     * @default false
     */
    isHeaderSelectable: boolean;
    isCheckedIndeterminate: boolean;
    isChecked: boolean;
    private destroy$;
    private euiDataTableSelectableRowService;
    ngOnInit(): void;
    ngOnDestroy(): void;
    /**
     * Gets the `aria-label` attribute for the checkbox element.
     *
     * @default `Unchecked`
     */
    get ariaLabel(): string;
    /**
     * Handle the change of the selected status.
     *
     * @param e Change Event
     */
    toggleCheckedState(e: Event): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTableV2SelectableHeaderComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiTableV2SelectableHeaderComponent<any>, "tr[isHeaderSelectable]", never, { "isHeaderSelectable": { "alias": "isHeaderSelectable"; "required": false; }; }, {}, never, ["*"], true, never>;
    static ngAcceptInputType_isHeaderSelectable: unknown;
}
//# sourceMappingURL=eui-table-v2-selectable-header.component.d.ts.map