import { OnInit, OnDestroy, OnChanges, SimpleChanges } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * Component used internally by `eui-table-v2` to make a row selectable.
 */
export declare class EuiTableV2SelectableRowComponent<DATA> implements OnInit, OnDestroy, OnChanges {
    /**
     * Data of the row.
     */
    isDataSelectable: DATA;
    /**
     * Wheter the row is selected.
     *
     * @default false
     */
    isChecked: boolean;
    /**
     * Wheter the selection can be done with the keyboard.
     *
     * @default false
     */
    isKeyboardSelectable: boolean;
    private propId;
    private destroy$;
    /**
     * @description
     * Computes and returns the CSS classes for the component based on its current state.
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    private euiDataTableSelectableRowService;
    private elementRef;
    ngOnChanges(c: SimpleChanges): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    /**
     * Handle the change of the selected status.
     *
     * @param e Change Event
     */
    toggleCheckedState(e: Event): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTableV2SelectableRowComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiTableV2SelectableRowComponent<any>, "tr[isDataSelectable]", never, { "isDataSelectable": { "alias": "isDataSelectable"; "required": false; }; "isChecked": { "alias": "isChecked"; "required": false; }; "isKeyboardSelectable": { "alias": "isKeyboardSelectable"; "required": false; }; }, {}, never, ["*"], true, never>;
    static ngAcceptInputType_isChecked: unknown;
    static ngAcceptInputType_isKeyboardSelectable: unknown;
}
//# sourceMappingURL=eui-table-v2-selectable-row.component.d.ts.map