import { PipeTransform } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * Pipe used to highlight the matching string in the data of the table when used with filter feature.
 *
 * @example
 * ```
 * <td><span [innerHTML]="row.year | euiTableHighlightFilter: strFilter"></span></td>
 *
 * strFilter = '19'
 * ```
 */
export declare class EuiTableHighlightFilterPipe implements PipeTransform {
    /**
     * Wrap a matching string with a span element with a class name in the data of the table
     *
     * @param value Data displayed in a cell.
     * @param strFilter Search string to highlight.
     * @param className CSS class to add to the span element. Default: 'eui-table--highlighted'
     * @returns
     */
    transform(value: string, strFilter: string, className?: string): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTableHighlightFilterPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<EuiTableHighlightFilterPipe, "euiTableHighlightFilter", true>;
}
//# sourceMappingURL=eui-table-highlight-filter.pipe.d.ts.map