import { OnInit, OnDestroy, ElementRef } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * Component used internally by `eui-table-v2` to add a 'select all' checkbox in the header of the table.
 */
export declare class EuiTableSelectableHeaderComponent implements OnInit, OnDestroy {
    checkbox: ElementRef<HTMLInputElement>;
    isCheckedIndeterminate: boolean;
    /**
     * Whether a "select all" feature is available in the header.
     *
     * @default false
     */
    isSelectableHeader: boolean;
    isChecked: boolean;
    private destroy$;
    private euiTableSelectableRowService;
    ngOnInit(): void;
    ngOnDestroy(): void;
    /**
     * Handle the change of the selected status.
     *
     * @param value true when checked otherwise false.
     */
    toggleCheckedState(value: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTableSelectableHeaderComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiTableSelectableHeaderComponent, "tr[isSelectableHeader]", never, { "isSelectableHeader": { "alias": "isSelectableHeader"; "required": false; }; "isChecked": { "alias": "isChecked"; "required": false; }; }, {}, never, ["*"], true, never>;
    static ngAcceptInputType_isSelectableHeader: unknown;
    static ngAcceptInputType_isChecked: unknown;
}
//# sourceMappingURL=eui-table-selectable-header.component.d.ts.map