import { OnInit, OnDestroy, OnChanges } from '@angular/core';
import * as i0 from "@angular/core";
/**
 * @description
 * Component used internally by `eui-table` to make a row selectable.
 */
export declare class EuiTableSelectableRowComponent implements OnInit, OnDestroy, OnChanges {
    /**
     * Data of the row.
     */
    isSelectable: any;
    /**
     * Wheter the row is selected.
     *
     * @default false
     */
    isChecked: boolean;
    /**
     * Wheter the selection can be done with the keyboard.
     *
     * @default false
     */
    isKeyboardSelectable: boolean;
    private propId;
    private destroy$;
    /**
     * @description
     * Computes and returns the CSS classes for the component based on its current state.
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    private euiTableSelectableRowService;
    /**
     * Keyboard event handler for selecting rows.
     *
     * @param event Keyboard event
     */
    onClickRow(event: PointerEvent): void;
    ngOnChanges(): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    /**
     * Handle the change of the selected status.
     *
     * @param e Change Event
     */
    toggleCheckedState(e: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTableSelectableRowComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiTableSelectableRowComponent, "tr[isSelectable]", never, { "isSelectable": { "alias": "isSelectable"; "required": false; }; "isChecked": { "alias": "isChecked"; "required": false; }; "isKeyboardSelectable": { "alias": "isKeyboardSelectable"; "required": false; }; }, {}, never, ["*"], true, never>;
    static ngAcceptInputType_isChecked: unknown;
    static ngAcceptInputType_isKeyboardSelectable: unknown;
}
//# sourceMappingURL=eui-table-selectable-row.component.d.ts.map