import { BaseStatesDirective } from '@eui/components/shared';
import { EuiTabContentComponent } from '../eui-tab-content/eui-tab-content.component';
import { EuiTabLabelComponent } from '../eui-tab-label/eui-tab-label.component';
import * as i0 from "@angular/core";
import * as i1 from "@eui/components/shared";
/**
 * @description
 * Component used to display a tab item.
 */
export declare class EuiTabComponent {
    /**
     * URL of the tab if used with the router. Click on the tab header will navigate to this value.
     */
    url: string;
    /**
     * e2e attribute.
     *
     * @default 'eui-tab'
     */
    e2eAttr: string;
    /**
     * Tooltip to display when the tab header is hovered.
     */
    tooltip: string;
    /**
     * Whether the tab can be closed.
     *
     * @default false
     */
    isClosable: boolean;
    /**
     * Whether the tab is visible.
     *
     * @default true
     */
    isVisible: boolean;
    /**
     * Whether the tab is active.
     *
     * @default false
     */
    isActive: boolean;
    /**
     * Whether the tab is disabled.
     *
     * @default false
     */
    isDisabled: boolean;
    /**
     * Whether the close is handled on application side.
     *
     *
     * @default false
     */
    isHandleCloseOnClose: boolean;
    get templateLabel(): EuiTabLabelComponent;
    set templateLabel(value: EuiTabLabelComponent);
    protected _templateLabel: EuiTabLabelComponent;
    get templateContent(): EuiTabContentComponent;
    set templateContent(value: EuiTabContentComponent);
    protected _templateContent: EuiTabContentComponent;
    baseStatesDirective: BaseStatesDirective;
    protected setTemplateLabelInput(value: EuiTabLabelComponent): void;
    protected setTemplateContentInput(value: EuiTabContentComponent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTabComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiTabComponent, "eui-tab", never, { "url": { "alias": "url"; "required": false; }; "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "tooltip": { "alias": "tooltip"; "required": false; }; "isClosable": { "alias": "isClosable"; "required": false; }; "isVisible": { "alias": "isVisible"; "required": false; }; "isActive": { "alias": "isActive"; "required": false; }; "isDisabled": { "alias": "isDisabled"; "required": false; }; "isHandleCloseOnClose": { "alias": "isHandleCloseOnClose"; "required": false; }; }, {}, ["templateLabel", "templateContent"], ["*"], true, [{ directive: typeof i1.BaseStatesDirective; inputs: { "euiDisabled": "euiDisabled"; "euiPrimary": "euiPrimary"; "euiSecondary": "euiSecondary"; "euiInfo": "euiInfo"; "euiSuccess": "euiSuccess"; "euiWarning": "euiWarning"; "euiDanger": "euiDanger"; "euiAccent": "euiAccent"; "euiVariant": "euiVariant"; }; outputs: {}; }]>;
    static ngAcceptInputType_isClosable: unknown;
    static ngAcceptInputType_isVisible: unknown;
    static ngAcceptInputType_isActive: unknown;
    static ngAcceptInputType_isDisabled: unknown;
    static ngAcceptInputType_isHandleCloseOnClose: unknown;
}
//# sourceMappingURL=eui-tab.component.d.ts.map