/**
 * Represents a single item in the TimeBar component.
 * Used to define the data points that will be displayed on the timeline.
 */
export interface EuiTimebarItem {
    /**
     * The date to be displayed on the timeline.
     * Used to calculate the item's position in chronological order.
     */
    date: Date;
    /**
     * The text label that appears below the timeline marker.
     * Can be a string, a Date or a formatted number value.
     */
    label: string;
    /**
     * Optional visual style indicator for the timeline marker.
     * Supported values: 'info', 'success', 'warning', 'danger'
     */
    stepType?: 'info' | 'success' | 'warning' | 'danger' | string;
}
/**
 * @deprecated use the {@link EuiTimebarItem} interface instead.
 */
export declare class EuiTimebarItem implements EuiTimebarItem {
    date: Date;
    label: string;
    stepType?: string;
    constructor(values?: {});
}
//# sourceMappingURL=eui-timebar-item.model.d.ts.map