import * as i0 from "@angular/core";
/**
 * @description
 * A timeline component that displays a vertical list of events or activities in chronological order.
 * Can be configured to align items on the left side instead of centered.
 */
export declare class EuiTimelineComponent {
    /**
     * @description
     * Computes and returns the CSS classes for the timeline component
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses(): string;
    /**
     * @description Data attribute for e2e testing
     * @default 'eui-timeline'
     */
    e2eAttr: string;
    /**
     * @description
     * When true, aligns timeline items to the left side instead of center
     * @default false
     */
    isLeftAligned: boolean;
    /**
     * @description
     * Combines CSS classes based on the component's current state
     *
     * @private
     * @returns {string} Space-separated string of CSS class names
     */
    private getCssClasses;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTimelineComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiTimelineComponent, "eui-timeline", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "isLeftAligned": { "alias": "isLeftAligned"; "required": false; }; }, {}, never, ["*"], true, never>;
    static ngAcceptInputType_isLeftAligned: unknown;
}
//# sourceMappingURL=eui-timeline.component.d.ts.map