import { EventEmitter, OnInit, OnChanges, SimpleChanges } from '@angular/core';
import * as i0 from "@angular/core";
export declare class EuiTreeListToolbarComponent implements OnInit, OnChanges {
    classes: string;
    e2eAttr: string;
    /**
     * Shows or hides the toolbar
     * @default false
     */
    isVisible: boolean;
    /**
     * The value of the filter placeholder
     * @type {string}
     */
    filterLabel: string;
    /**
     * The label for the expand all button
     * @type {string}
     */
    expandAllLabel: string;
    /**
     * The label for the collapse all button
     * @type {string}
     */
    collapseAllLabel: string;
    /**
     * @deprecated This property is not used anymore and will be removed in the next major version.
     */
    isFilterVisible: boolean;
    /**
     * @deprecated This property is not used anymore and will be removed in the next major version.
     */
    isToggleVisible: boolean;
    /**
     * Option that toggles the expanded/collapsed state of the corresponding button
     * @default false
     */
    isToggleExpanded: boolean;
    /**
     * The value of the filter input
     * @default ''
     */
    filterValue: string;
    /**
     * @deprecated This property is not used anymore and will be removed in the next major version.
     */
    hasLabels: boolean;
    /**
     * Event emitted if there is or if a filter value changes.
     */
    filter: EventEmitter<string>;
    /**
     * Event emitted when the expand all button is clicked.
     */
    expandAll: EventEmitter<MouseEvent>;
    /**
     * Event emitted when the collapse all button is clicked.
     */
    collapseAll: EventEmitter<MouseEvent>;
    ngOnInit(): void;
    ngOnChanges(c: SimpleChanges): void;
    /**
     * This method is called when the filter input value changes.
     * It emits the filter value to the parent component.
     * @protected
     */
    protected onFilter(): void;
    /**
     * This method is called when the expand all button is clicked.
     * It emits the expand all event to the parent component.
     * @param event The mouse event
     * @protected
     */
    protected onExpandAll(event: MouseEvent): void;
    /**
     * This method is called when the collapse all button is clicked.
     * It emits the collapse all event to the parent component.
     * @param event The mouse event
     * @protected
     */
    protected onCollapseAll(event: MouseEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiTreeListToolbarComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiTreeListToolbarComponent, "eui-tree-list-toolbar", never, { "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "isVisible": { "alias": "isVisible"; "required": false; }; "filterLabel": { "alias": "filterLabel"; "required": false; }; "expandAllLabel": { "alias": "expandAllLabel"; "required": false; }; "collapseAllLabel": { "alias": "collapseAllLabel"; "required": false; }; "isFilterVisible": { "alias": "isFilterVisible"; "required": false; }; "isToggleVisible": { "alias": "isToggleVisible"; "required": false; }; "isToggleExpanded": { "alias": "isToggleExpanded"; "required": false; }; "filterValue": { "alias": "filterValue"; "required": false; }; "hasLabels": { "alias": "hasLabels"; "required": false; }; }, { "filter": "filter"; "expandAll": "expandAll"; "collapseAll": "collapseAll"; }, never, never, true, never>;
    static ngAcceptInputType_isVisible: unknown;
    static ngAcceptInputType_isFilterVisible: unknown;
    static ngAcceptInputType_isToggleVisible: unknown;
    static ngAcceptInputType_isToggleExpanded: unknown;
    static ngAcceptInputType_hasLabels: unknown;
}
//# sourceMappingURL=toolbar.component.d.ts.map