import { OnInit, EventEmitter, Signal } from '@angular/core';
import { UserProfile } from '../user-profile.component';
import * as i0 from "@angular/core";
export declare class EuiUserProfileCardComponent implements OnInit {
    get cssClasses(): string;
    avatarInitials: Signal<string>;
    /**
     * Holds the full name of the user and the impersonated user
     */
    fullName: Signal<{
        user: string;
        impersonated: string;
    }>;
    userState: Signal<UserProfile>;
    /**
     * If true, the user is online
     * @deprecated This property is not used anymore
     */
    isOnline: boolean;
    impersonateLabel: string;
    showDetailsLabel: string;
    avatarUrl: string;
    isShowAvatarInitials: boolean;
    /**
     * If true, the name will be displayed in reverse order (first name, first)
     */
    reverseNameOrder: boolean;
    showProfileInfo: EventEmitter<void>;
    closeProfileMenu: EventEmitter<void>;
    ngOnInit(): void;
    onShowInfoClick(): void;
    onClose(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiUserProfileCardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiUserProfileCardComponent, "eui-user-profile-card", never, { "impersonateLabel": { "alias": "impersonateLabel"; "required": false; }; "showDetailsLabel": { "alias": "showDetailsLabel"; "required": false; }; "avatarUrl": { "alias": "avatarUrl"; "required": false; }; "isShowAvatarInitials": { "alias": "isShowAvatarInitials"; "required": false; }; "reverseNameOrder": { "alias": "reverseNameOrder"; "required": false; }; }, { "showProfileInfo": "showProfileInfo"; "closeProfileMenu": "closeProfileMenu"; }, never, never, true, never>;
    static ngAcceptInputType_isShowAvatarInitials: unknown;
}
//# sourceMappingURL=user-profile-card.component.d.ts.map