import { AfterContentInit, ElementRef, EventEmitter, OnChanges, QueryList, SimpleChanges } from '@angular/core';
import { EuiWizardStepComponent } from './eui-wizard-step.component';
import { EuiWizardStep } from './models/eui-wizard-step';
import * as i0 from "@angular/core";
export declare class EuiWizardComponent implements AfterContentInit, OnChanges {
    activeStepIndex: number;
    steps: Array<EuiWizardStep>;
    tabindex: number;
    e2eAttr: string;
    selectStep: EventEmitter<EuiWizardStep>;
    childrenSteps: QueryList<EuiWizardStepComponent>;
    canBeFocused: QueryList<ElementRef>;
    stepContentId: string;
    stepIds: string;
    isCustomContent: boolean;
    isShowStepTitle: boolean;
    isNavigationAllowed: boolean;
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onSelectStep(step: EuiWizardStep, index: number): void;
    onKeyDown(event: KeyboardEvent): void;
    /** @deprecated This will be removed in next version of eUI */
    protected trackByFn(index: number, item: EuiWizardStep): string;
    protected selectPreviousStep(): void;
    protected selectNextStep(): void;
    private _selectStep;
    private _getStep;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiWizardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiWizardComponent, "eui-wizard", never, { "activeStepIndex": { "alias": "activeStepIndex"; "required": false; }; "steps": { "alias": "steps"; "required": false; }; "tabindex": { "alias": "tabindex"; "required": false; }; "e2eAttr": { "alias": "e2eAttr"; "required": false; }; "isCustomContent": { "alias": "isCustomContent"; "required": false; }; "isShowStepTitle": { "alias": "isShowStepTitle"; "required": false; }; "isNavigationAllowed": { "alias": "isNavigationAllowed"; "required": false; }; }, { "selectStep": "selectStep"; }, ["childrenSteps"], ["*"], true, never>;
    static ngAcceptInputType_isCustomContent: unknown;
    static ngAcceptInputType_isShowStepTitle: unknown;
    static ngAcceptInputType_isNavigationAllowed: unknown;
}
//# sourceMappingURL=eui-wizard.component.d.ts.map