import { InjectionToken } from '@angular/core';
export type QuillToolbarConfig = Array<Array<string | {
    indent?: string;
    list?: string;
    direction?: string;
    header?: number | Array<boolean | number>;
    color?: string[];
    background?: string[];
    align?: string[];
    script?: string;
    font?: string[];
    size?: Array<boolean | string>;
}>>;
export interface QuillModules {
    [key: string]: any;
    clipboard?: {
        mathers?: any[];
        matchVisual?: boolean;
    } | boolean;
    history?: {
        delay?: number;
        maxStack?: number;
        userOnly?: boolean;
    } | boolean;
    keyboard?: {
        bindings?: any;
    } | boolean;
    syntax?: boolean;
    table?: boolean;
    toolbar?: QuillToolbarConfig | string | {
        container?: string | string[] | QuillToolbarConfig;
        handlers?: {
            [key: string]: any;
        };
    } | boolean;
}
export type QuillFormat = 'object' | 'json' | 'html' | 'text';
export interface QuillConfig {
    bounds?: HTMLElement | string;
    debug?: 'error' | 'warn' | 'log' | false;
    format?: QuillFormat;
    formats?: any;
    modules?: QuillModules;
    placeholder?: string;
    readOnly?: boolean;
    scrollingContainer?: HTMLElement | string | null;
    theme?: string;
    trackChanges?: 'user' | 'all';
}
export interface QuillDynamicConfig {
    /** path for scripts and css e.g. '/assets/quill/' */
    path: string;
}
export declare const QUILL_CONFIG_TOKEN: InjectionToken<QuillConfig>;
export declare const QUILL_DYNAMIC_CONFIG_TOKEN: InjectionToken<QuillDynamicConfig>;
//# sourceMappingURL=quill-editor.interfaces.d.ts.map