import * as i0 from '@angular/core';
import { HostBinding, ChangeDetectionStrategy, Component, Input, forwardRef, ContentChild, Injectable, inject, EventEmitter, booleanAttribute, Output, NgModule } from '@angular/core';
import { EuiTooltipDirective } from '@eui/components/directives';
import * as i1 from '@eui/components/eui-dropdown';
import { EUI_DROPDOWN } from '@eui/components/eui-dropdown';
import * as i2 from '@eui/components/eui-button';
import { EUI_BUTTON } from '@eui/components/eui-button';
import * as i3 from '@eui/components/eui-icon';
import { EUI_ICON } from '@eui/components/eui-icon';
import { BehaviorSubject, Subject } from 'rxjs';
import { NgTemplateOutlet, AsyncPipe } from '@angular/common';
import * as i2$1 from '@eui/components/eui-icon-button-expander';
import { EUI_ICON_BUTTON_EXPANDER } from '@eui/components/eui-icon-button-expander';
import { RouterLink } from '@angular/router';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { map, skip, takeUntil } from 'rxjs/operators';
import * as i1$1 from '@eui/components/shared';
import { BaseStatesDirective } from '@eui/components/shared';

/**
 * @description
 * The eui-card-content component projects the content for eui-card.
 */
class EuiCardContentComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-content'
         */
        this.string = 'eui-card-content';
        /**
         * Binds the tabindex attribute to the component.
         *
         * @default 0
         */
        this.tabindex = 0;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardContentComponent, isStandalone: true, selector: "eui-card-content", host: { properties: { "class": "this.string", "attr.tabindex": "this.tabindex" } }, ngImport: i0, template: '<ng-content/>', isInline: true, styles: [".eui-19 .eui-card :host.eui-card-content{background:var(--eui-c-white);cursor:auto;flex:0 1 auto;font:var(--eui-f-m);height:auto;overflow-x:hidden;overflow-y:auto;padding:var(--eui-s-m);position:relative;margin-bottom:0}.eui-19 .eui-card :host.eui-card-content::-webkit-scrollbar{display:inherit;height:6px;width:6px;background-color:var(--eui-c-neutral-bg-light)}.eui-19 .eui-card :host.eui-card-content::-webkit-scrollbar-thumb{background-color:var(--_eui-scrollbars-foreground-color);border-radius:5rem}.eui-19 .eui-card :host.eui-card-content::-webkit-scrollbar-thumb:hover{background-color:var(--eui-c-neutral-lighter)}.eui-19 .eui-card :host.eui-card-content::-webkit-scrollbar-track{background-color:var(--eui-c-neutral-bg-light);border-radius:0}@-moz-document url-prefix(){.eui-19 .eui-card :host.eui-card-content{scrollbar-color:var(--eui-c-neutral-lighter) var(--eui-c-neutral-bg-light);scrollbar-width:auto}}.eui-19 .eui-card :host.eui-card-content p:first-of-type{margin-top:0}.eui-19 .eui-card--no-content-padding :host.eui-card-content{padding:0}.eui-19 .eui-card--no-content-padding :host.eui-card-content ::ng-deep .eui-paginator{padding:var(--eui-s-s)}.eui-19 .eui-card--selected :host.eui-card-content{background:var(--eui-c-white);color:var(--eui-c-text)}.eui-19 .eui-card--collapsed :host.eui-card-content{height:0!important;padding:0 var(--eui-s-m)}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-content', template: '<ng-content/>', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 .eui-card :host.eui-card-content{background:var(--eui-c-white);cursor:auto;flex:0 1 auto;font:var(--eui-f-m);height:auto;overflow-x:hidden;overflow-y:auto;padding:var(--eui-s-m);position:relative;margin-bottom:0}.eui-19 .eui-card :host.eui-card-content::-webkit-scrollbar{display:inherit;height:6px;width:6px;background-color:var(--eui-c-neutral-bg-light)}.eui-19 .eui-card :host.eui-card-content::-webkit-scrollbar-thumb{background-color:var(--_eui-scrollbars-foreground-color);border-radius:5rem}.eui-19 .eui-card :host.eui-card-content::-webkit-scrollbar-thumb:hover{background-color:var(--eui-c-neutral-lighter)}.eui-19 .eui-card :host.eui-card-content::-webkit-scrollbar-track{background-color:var(--eui-c-neutral-bg-light);border-radius:0}@-moz-document url-prefix(){.eui-19 .eui-card :host.eui-card-content{scrollbar-color:var(--eui-c-neutral-lighter) var(--eui-c-neutral-bg-light);scrollbar-width:auto}}.eui-19 .eui-card :host.eui-card-content p:first-of-type{margin-top:0}.eui-19 .eui-card--no-content-padding :host.eui-card-content{padding:0}.eui-19 .eui-card--no-content-padding :host.eui-card-content ::ng-deep .eui-paginator{padding:var(--eui-s-s)}.eui-19 .eui-card--selected :host.eui-card-content{background:var(--eui-c-white);color:var(--eui-c-text)}.eui-19 .eui-card--collapsed :host.eui-card-content{height:0!important;padding:0 var(--eui-s-m)}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }], tabindex: [{
                type: HostBinding,
                args: ['attr.tabindex']
            }] } });

/**
 * @description
 * The eui-card-footer-action-buttons component projects the action buttons content for eui-card.
 */
class EuiCardFooterActionButtonsComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-footer-actions__buttons'
         */
        this.string = 'eui-card-footer-actions__buttons';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterActionButtonsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardFooterActionButtonsComponent, isStandalone: true, selector: "eui-card-footer-action-buttons", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content/>', isInline: true, styles: [".eui-19 :host.eui-card-footer-actions__buttons{align-items:center;display:flex;width:100%}.eui-19 :host.eui-card-footer-actions__buttons ::ng-deep .eui-button{margin-right:var(--eui-s-xs)}.eui-19 :host.eui-card-footer-actions__buttons .eui-input-checkbox{margin-bottom:0!important}.eui-19 :host.eui-card-footer-actions__buttons .eui-input-checkbox+label{margin-bottom:0!important}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterActionButtonsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-footer-action-buttons', template: '<ng-content/>', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 :host.eui-card-footer-actions__buttons{align-items:center;display:flex;width:100%}.eui-19 :host.eui-card-footer-actions__buttons ::ng-deep .eui-button{margin-right:var(--eui-s-xs)}.eui-19 :host.eui-card-footer-actions__buttons .eui-input-checkbox{margin-bottom:0!important}.eui-19 :host.eui-card-footer-actions__buttons .eui-input-checkbox+label{margin-bottom:0!important}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card-footer-action-icons component projects the action icons content for eui-card.
 */
class EuiCardFooterActionIconsComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-footer-actions__icons'
         */
        this.string = 'eui-card-footer-actions__icons';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterActionIconsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardFooterActionIconsComponent, isStandalone: true, selector: "eui-card-footer-action-icons", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content />', isInline: true, styles: [".eui-19 :host.eui-card-footer-actions__icons{align-items:center;display:flex;width:100%}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterActionIconsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-footer-action-icons', template: '<ng-content />', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 :host.eui-card-footer-actions__icons{align-items:center;display:flex;width:100%}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card-footer-menu-content component projects the content of the actions menu of the eui-card.
 */
class EuiCardFooterMenuContentComponent {
    constructor() {
        /**
         * Sets the tooltipText Input property.
         *
         * @default 'More options'
         */
        this.tooltipText = 'More options';
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-footer-menu-content'
         */
        this.string = 'eui-card-footer-menu-content';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterMenuContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardFooterMenuContentComponent, isStandalone: true, selector: "eui-card-footer-menu-content", inputs: { tooltipText: "tooltipText" }, host: { properties: { "class": "this.string" } }, ngImport: i0, template: "<eui-dropdown>\n    <button\n        euiButton\n        euiRounded\n        euiIconButton\n        euiBasicButton\n        euiSecondary\n        type=\"button\"\n        euiTooltip=\"{{ tooltipText }}\"\n        [attr.aria-label]=\"tooltipText\">\n        <eui-icon-svg icon=\"ellipsis-vertical:sharp\"></eui-icon-svg>\n    </button>\n    <eui-dropdown-content>\n        <ng-content />\n    </eui-dropdown-content>\n</eui-dropdown>\n", dependencies: [{ kind: "component", type: i1.EuiDropdownComponent, selector: "eui-dropdown", inputs: ["e2eAttr", "tabIndex", "width", "height", "position", "subDropdownPosition", "isBlock", "isDropDownRightAligned", "hasClosedOnClickInside", "isLabelUpdatedFromSelectedItem", "isExpandOnHover", "hasTabNavigation", "isRightClickEnabled", "euiDisabled"], outputs: ["expand"] }, { kind: "directive", type: i1.EuiDropdownContentDirective, selector: "eui-dropdown-content" }, { kind: "component", type: i2.EuiButtonComponent, selector: "button[euiButton], a[euiButton]", inputs: ["e2eAttr", "id", "euiBasicButton", "euiButtonCall", "euiCTAButton", "euiBlockButton", "euiIconButton", "euiAvatarButton", "euiLineWrap", "isCompact", "hasNoFocusRing", "isChecked", "euiDisabled"], outputs: ["buttonClick"] }, { kind: "component", type: i3.EuiIconSvgComponent, selector: "eui-icon-svg, span[euiIconSvg], i[euiIconSvg]", inputs: ["icon", "fillColor", "set", "size", "style", "iconUrl", "transform", "euiVariant", "aria-label", "ariaHidden", "focusable", "isLoading", "isInputIcon", "euiStart", "euiEnd"] }, { kind: "directive", type: EuiTooltipDirective, selector: "[euiTooltip]", inputs: ["e2eAttr", "showDelay", "hideDelay", "contentAlignment", "position", "isDisabled", "euiTooltip", "euiTooltipPrimary", "euiTooltipSecondary", "euiTooltipInfo", "euiTooltipSuccess", "euiTooltipWarning", "euiTooltipDanger", "euiTooltipAccent"], exportAs: ["euiTooltip"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterMenuContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-footer-menu-content', imports: [
                        ...EUI_DROPDOWN,
                        ...EUI_BUTTON,
                        ...EUI_ICON,
                        EuiTooltipDirective,
                    ], changeDetection: ChangeDetectionStrategy.OnPush, template: "<eui-dropdown>\n    <button\n        euiButton\n        euiRounded\n        euiIconButton\n        euiBasicButton\n        euiSecondary\n        type=\"button\"\n        euiTooltip=\"{{ tooltipText }}\"\n        [attr.aria-label]=\"tooltipText\">\n        <eui-icon-svg icon=\"ellipsis-vertical:sharp\"></eui-icon-svg>\n    </button>\n    <eui-dropdown-content>\n        <ng-content />\n    </eui-dropdown-content>\n</eui-dropdown>\n" }]
        }], propDecorators: { tooltipText: [{
                type: Input
            }], string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card-footer-menu component provides menu options for the footer of the eui-card.
 */
class EuiCardFooterMenuComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-footer-menu'
         */
        this.string = 'eui-card-footer-menu';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterMenuComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardFooterMenuComponent, isStandalone: true, selector: "eui-card-footer-menu", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content/>', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterMenuComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'eui-card-footer-menu',
                    template: '<ng-content/>',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card-footer component projects the footer of the eui-card.
 */
class EuiCardFooterComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-footer'
         */
        this.string = 'eui-card-footer';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.12", type: EuiCardFooterComponent, isStandalone: true, selector: "eui-card-footer", host: { properties: { "class": "this.string" } }, queries: [{ propertyName: "actionButtons", first: true, predicate: i0.forwardRef(() => EuiCardFooterActionButtonsComponent), descendants: true }, { propertyName: "actionIcons", first: true, predicate: i0.forwardRef(() => EuiCardFooterActionIconsComponent), descendants: true }, { propertyName: "actionMenu", first: true, predicate: i0.forwardRef(() => EuiCardFooterMenuContentComponent), descendants: true }, { propertyName: "actionMenuWrapper", first: true, predicate: i0.forwardRef(() => EuiCardFooterMenuComponent), descendants: true }], ngImport: i0, template: "<div class=\"eui-card-footer-container\">\n    @if (actionButtons || actionIcons || actionMenu || actionMenuWrapper) {\n        <div class=\"eui-card-footer-actions\">\n            @if (actionButtons) {\n                <ng-content select=\"eui-card-footer-action-buttons\"></ng-content>\n            }\n            @if (actionIcons || actionMenu) {\n                <div class=\"eui-card-footer-actions__icons-container\">\n                    @if (actionIcons) {\n                        <ng-content select=\"eui-card-footer-action-icons\"></ng-content>\n                    }\n                    @if (actionMenu) {\n                        <ng-content select=\"eui-card-footer-menu-content\"></ng-content>\n                    }\n                    @if (actionMenuWrapper) {\n                        <ng-content select=\"eui-card-footer-menu\"></ng-content>\n                    }\n                </div>\n            }\n        </div>\n    }\n</div>\n", styles: [".eui-19 :host.eui-card-footer{background:var(--eui-c-white);border-top:1px solid var(--eui-c-divider);border-radius:0 0 var(--eui-br-m) var(--eui-br-m);display:flex;margin-top:-1px;position:relative}.eui-19 :host.eui-card-footer .eui-card-footer-container{display:flex;margin:var(--eui-s-s) var(--eui-s-m);width:100%}.eui-19 :host.eui-card-footer .eui-card-footer-actions{margin-bottom:0;margin-left:0;margin-right:0;padding:0;align-items:center;display:flex;width:100%}.eui-19 :host.eui-card-footer .eui-card-footer-actions__icons-container{align-items:center;display:flex;margin-left:auto}.eui-19 :host.eui-card-footer .eui-card-footer-menu-content{margin-right:calc(-.5 * var(--eui-s-m))}.eui-19 .eui-card--selected :host.eui-card-footer{background:var(--eui-c-white);border-radius:0 0 var(--eui-br-m) var(--eui-br-m);color:var(--eui-c-text)}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardFooterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-footer', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"eui-card-footer-container\">\n    @if (actionButtons || actionIcons || actionMenu || actionMenuWrapper) {\n        <div class=\"eui-card-footer-actions\">\n            @if (actionButtons) {\n                <ng-content select=\"eui-card-footer-action-buttons\"></ng-content>\n            }\n            @if (actionIcons || actionMenu) {\n                <div class=\"eui-card-footer-actions__icons-container\">\n                    @if (actionIcons) {\n                        <ng-content select=\"eui-card-footer-action-icons\"></ng-content>\n                    }\n                    @if (actionMenu) {\n                        <ng-content select=\"eui-card-footer-menu-content\"></ng-content>\n                    }\n                    @if (actionMenuWrapper) {\n                        <ng-content select=\"eui-card-footer-menu\"></ng-content>\n                    }\n                </div>\n            }\n        </div>\n    }\n</div>\n", styles: [".eui-19 :host.eui-card-footer{background:var(--eui-c-white);border-top:1px solid var(--eui-c-divider);border-radius:0 0 var(--eui-br-m) var(--eui-br-m);display:flex;margin-top:-1px;position:relative}.eui-19 :host.eui-card-footer .eui-card-footer-container{display:flex;margin:var(--eui-s-s) var(--eui-s-m);width:100%}.eui-19 :host.eui-card-footer .eui-card-footer-actions{margin-bottom:0;margin-left:0;margin-right:0;padding:0;align-items:center;display:flex;width:100%}.eui-19 :host.eui-card-footer .eui-card-footer-actions__icons-container{align-items:center;display:flex;margin-left:auto}.eui-19 :host.eui-card-footer .eui-card-footer-menu-content{margin-right:calc(-.5 * var(--eui-s-m))}.eui-19 .eui-card--selected :host.eui-card-footer{background:var(--eui-c-white);border-radius:0 0 var(--eui-br-m) var(--eui-br-m);color:var(--eui-c-text)}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }], actionButtons: [{
                type: ContentChild,
                args: [forwardRef(() => EuiCardFooterActionButtonsComponent), { static: false }]
            }], actionIcons: [{
                type: ContentChild,
                args: [forwardRef(() => EuiCardFooterActionIconsComponent), { static: false }]
            }], actionMenu: [{
                type: ContentChild,
                args: [forwardRef(() => EuiCardFooterMenuContentComponent), { static: false }]
            }], actionMenuWrapper: [{
                type: ContentChild,
                args: [forwardRef(() => EuiCardFooterMenuComponent), { static: false }]
            }] } });

/**
 * @description
 * The eui-card-header-body component projects the body for eui-card-header.
 */
class EuiCardHeaderBodyComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-header-body'
         */
        this.string = 'eui-card-header-body';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderBodyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardHeaderBodyComponent, isStandalone: true, selector: "eui-card-header-body", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content/>', isInline: true, styles: [".eui-19 .eui-card :host.eui-card-header-body{align-items:center;background:var(--eui-c-white);display:flex;padding:var(--eui-s-s) var(--eui-s-m);width:100%;font:var(--eui-f-m)}.eui-19 .eui-card--selected :host.eui-card-header-body{background-color:var(--eui-c-active-bg);border-radius:var(--eui-br-m) var(--eui-br-m) 0 0}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderBodyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-header-body', template: '<ng-content/>', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 .eui-card :host.eui-card-header-body{align-items:center;background:var(--eui-c-white);display:flex;padding:var(--eui-s-s) var(--eui-s-m);width:100%;font:var(--eui-f-m)}.eui-19 .eui-card--selected :host.eui-card-header-body{background-color:var(--eui-c-active-bg);border-radius:var(--eui-br-m) var(--eui-br-m) 0 0}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card-header-left-content component projects the left content for eui-card-header.
 */
class EuiCardHeaderLeftContentComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-header__left-content'
         */
        this.string = 'eui-card-header__left-content';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderLeftContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardHeaderLeftContentComponent, isStandalone: true, selector: "eui-card-header-left-content", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content/>', isInline: true, styles: [".eui-19 :host{align-items:center;display:flex;height:100%;margin-right:var(--eui-s-m)}.eui-19 :host ::ng-deep .eui-input-checkbox{margin:0!important;position:relative!important}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderLeftContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-header-left-content', template: '<ng-content/>', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 :host{align-items:center;display:flex;height:100%;margin-right:var(--eui-s-m)}.eui-19 :host ::ng-deep .eui-input-checkbox{margin:0!important;position:relative!important}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card-header-right-content component projects the right content for eui-card-header.
 */
class EuiCardHeaderRightContentComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-header__right-content'
         */
        this.string = 'eui-card-header__right-content';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderRightContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardHeaderRightContentComponent, isStandalone: true, selector: "eui-card-header-right-content", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content/>', isInline: true, styles: [".eui-19 :host{align-items:center;display:flex;flex-shrink:0;justify-content:flex-end;margin-left:auto}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderRightContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-header-right-content', template: '<ng-content/>', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 :host{align-items:center;display:flex;flex-shrink:0;justify-content:flex-end;margin-left:auto}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card-header-subtitle component projects the subtitle for eui-card-header.
 */
class EuiCardHeaderSubtitleComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-header__title-container-subtitle'
         */
        this.string = 'eui-card-header__title-container-subtitle';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderSubtitleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardHeaderSubtitleComponent, isStandalone: true, selector: "eui-card-header-subtitle", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content/>', isInline: true, styles: [".eui-19 :host{display:block;width:100%;color:var(--eui-c-neutral-light);font:var(--eui-f-m);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 :host>*{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 .eui-card-header__title-container--multilines :host{white-space:unset!important}.eui-19 .eui-card-header__title-container--multilines :host>*{white-space:unset!important}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderSubtitleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-header-subtitle', template: '<ng-content/>', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 :host{display:block;width:100%;color:var(--eui-c-neutral-light);font:var(--eui-f-m);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 :host>*{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 .eui-card-header__title-container--multilines :host{white-space:unset!important}.eui-19 .eui-card-header__title-container--multilines :host>*{white-space:unset!important}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card-header-title component projects the title for eui-card-header.
 */
class EuiCardHeaderTitleComponent {
    constructor() {
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-header__title-container-title'
         */
        this.string = 'eui-card-header__title-container-title';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderTitleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiCardHeaderTitleComponent, isStandalone: true, selector: "eui-card-header-title", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content/>', isInline: true, styles: [".eui-19 :host{display:initial;color:var(--eui-c-neutral-light);font:var(--eui-f-m-bold);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 :host>*{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 .eui-card-header__title-container--multilines :host{white-space:unset!important}.eui-19 .eui-card-header__title-container--multilines :host>*{white-space:unset!important}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderTitleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-header-title', template: '<ng-content/>', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 :host{display:initial;color:var(--eui-c-neutral-light);font:var(--eui-f-m-bold);overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 :host>*{overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 .eui-card-header__title-container--multilines :host{white-space:unset!important}.eui-19 .eui-card-header__title-container--multilines :host>*{white-space:unset!important}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

const initialState = {
    isCollapsible: false,
    isCollapsed: false,
    isUrgent: false,
};
class UiStateService {
    constructor() {
        this._state$ = new BehaviorSubject(initialState);
    }
    // -------------------
    // exposed observables
    // -------------------
    get state$() {
        return this._state$.asObservable();
    }
    // ----------------
    // state operations
    // ----------------
    get state() {
        return this._state$.getValue();
    }
    // -----------------
    // getters & setters
    // -----------------
    setState(nextState) {
        this._state$.next({
            ...this.state,
            ...nextState,
        });
    }
    set isCollapsed(isActive) {
        this.setState({
            ...this.state,
            isCollapsed: isActive,
        });
    }
    set isCollapsible(isActive) {
        this.setState({
            ...this.state,
            isCollapsible: isActive,
        });
    }
    toggleCollapsed() {
        this.isCollapsed = !this.state.isCollapsed;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: UiStateService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: UiStateService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: UiStateService, decorators: [{
            type: Injectable
        }] });

/**
 * @description
 * The eui-card-header component provides the header options of the eui-card.
 */
class EuiCardHeaderComponent {
    constructor() {
        this.uiStateService = inject(UiStateService);
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-header'
         */
        this.string = 'eui-card-header';
        /**
         * Sets the expandLabel Input property.
         *
         * @default 'expand'
         */
        this.expandLabel = 'expand';
        /**
         * Sets the collapseLabel Input property.
         *
         * @default 'collapse'
         */
        this.collapseLabel = 'collapse';
        /**
         * Input property to enable/disable the header click toggle.
         *
         * @default true
         */
        this.hasHeaderClickToggle = true;
        /**
         * Input property to expand the bottom part of the card header.
         *
         * @default false
         */
        this.hasBottomExpander = false;
        /**
         * Input property to display the title within the full card container's width.
         *
         * @default false
         */
        this.hasFullTitle = false;
        /**
         * Input property to display the title & subtitle content in multiple lines.
         *
         * @default false
         */
        this.isHeaderMultilines = false;
        /**
         * Event emitted when the card header collapses.
         */
        this.collapse = new EventEmitter();
    }
    /**
     * Fires when the icon button expander is clicked/pressed to expand/collapse the bottom expander.
     *
     * @param event The event that fires the toggle.
     */
    onToggle(event) {
        this.uiStateService.toggleCollapsed();
        this.collapse.emit(this.uiStateService.state.isCollapsed);
        event.stopPropagation();
    }
    /**
     * Toggles the header when the header is clicked and emits the isCollapsed state.
     *
     */
    onToggleHeader() {
        if (this.hasHeaderClickToggle && this.uiStateService.state.isCollapsible) {
            this.uiStateService.toggleCollapsed();
            this.collapse.emit(this.uiStateService.state.isCollapsed);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.12", type: EuiCardHeaderComponent, isStandalone: true, selector: "eui-card-header", inputs: { expandLabel: "expandLabel", collapseLabel: "collapseLabel", hasHeaderClickToggle: ["hasHeaderClickToggle", "hasHeaderClickToggle", booleanAttribute], hasBottomExpander: ["hasBottomExpander", "hasBottomExpander", booleanAttribute], hasFullTitle: ["hasFullTitle", "hasFullTitle", booleanAttribute], isHeaderMultilines: ["isHeaderMultilines", "isHeaderMultilines", booleanAttribute] }, outputs: { collapse: "collapse" }, host: { properties: { "class": "this.string" } }, ngImport: i0, template: "<button type=\"button\" class=\"eui-card-header__container\" (click)=\"onToggleHeader()\"\n        [attr.tabindex]=\"(uiStateService.state$ | async).isCollapsible && hasHeaderClickToggle ? '0' : '-1'\">\n\n    <ng-content select=\"eui-card-header-left-content\"></ng-content>\n\n    @if (!hasFullTitle) {\n        <div class=\"eui-card-header__title-container\" [class.eui-card-header__title-container--multilines]=\"isHeaderMultilines\">\n            <ng-content *ngTemplateOutlet=\"title\"></ng-content>\n            <ng-content *ngTemplateOutlet=\"subtitle\"></ng-content>\n        </div>\n        <ng-content *ngTemplateOutlet=\"rightContent\"></ng-content>\n}\n\n    @if (hasFullTitle) {\n        <div class=\"eui-card-header__middle-container\">\n            <div class=\"eui-card-header__title-container\" [class.eui-card-header__title-container--multilines]=\"isHeaderMultilines\">\n                <ng-content *ngTemplateOutlet=\"title\"></ng-content>\n            </div>\n            <div class=\"eui-card-header__middle-content\">\n                <ng-content *ngTemplateOutlet=\"subtitle\"></ng-content>\n                <ng-content *ngTemplateOutlet=\"rightContent\"></ng-content>\n            </div>\n        </div>\n}\n\n    @if ((uiStateService.state$ | async).isCollapsible) {\n        <div\n            class=\"eui-card-header__expander\"\n            [class.eui-card-header__expander--bottom]=\"hasBottomExpander\"\n            [class.eui-card-header__expander--top]=\"isHeaderMultilines\">\n            <eui-icon-button-expander class=\"eui-card-header__expander-icon\"\n                [isExpanded]=\"!(uiStateService.state$ | async).isCollapsed\" (buttonClick)=\"onToggle($event)\">\n            </eui-icon-button-expander>\n        </div>\n    }\n</button>\n\n@if ((uiStateService.state$ | async).isUrgent) {\n    <div class=\"eui-card-header__urgent-indicator\">\n        <eui-icon-svg icon=\"alert:sharp\" fillColor=\"white\"></eui-icon-svg>\n    </div>\n}\n<ng-content select=\"eui-card-header-body\" />\n\n<ng-template #title>\n    <ng-content select=\"eui-card-header-title\" />\n</ng-template>\n\n<ng-template #subtitle>\n    <ng-content select=\"eui-card-header-subtitle\" />\n</ng-template>\n\n<ng-template #rightContent>\n    <ng-content select=\"eui-card-header-right-content\" />\n</ng-template>\n", styles: [".eui-19 :host.eui-card-header{align-items:center;background:var(--eui-c-white);border-bottom:1px solid var(--eui-c-divider);border-radius:var(--eui-br-m) var(--eui-br-m) 0 0;flex-direction:row;display:flex;flex-wrap:wrap;width:100%}.eui-19 :host.eui-card-header .eui-card-header__container{align-items:center;border-bottom:1px solid var(--eui-c-divider);display:flex;margin-bottom:-1px;min-height:calc(3 * var(--eui-s-m));padding:var(--eui-s-m);width:100%;outline:none;border:var(--eui-bw-none);background-color:initial;text-align:start;-webkit-user-select:text;user-select:text}.eui-19 :host.eui-card-header .eui-card-header__container+.eui-card-header-body{border-bottom:1px solid var(--eui-c-divider);margin-bottom:-1px}.eui-19 :host.eui-card-header .eui-card-header__urgent-indicator{background:var(--eui-c-s-danger);border-radius:var(--eui-br-max);position:absolute;right:calc(-1 * var(--eui-s-s));top:calc(-1 * var(--eui-s-s));height:var(--eui-s-xl)}.eui-19 :host.eui-card-header .eui-card-header__title-container{display:flex;flex-direction:column;justify-content:center;margin-right:var(--eui-s-s);margin-top:var(--eui-s-2xs);width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 :host.eui-card-header .eui-card-header__title-container--multilines{overflow:visible;text-overflow:unset;white-space:unset!important}.eui-19 :host.eui-card-header .eui-card-header__middle-container{display:flex;flex-direction:column;justify-content:flex-start;width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 :host.eui-card-header .eui-card-header__middle-content{display:flex;flex-direction:row;justify-content:flex-start;margin-top:var(--eui-s-s);width:100%}.eui-19 :host.eui-card-header .eui-card-header__middle-content .eui-card-header__title-container-subtitle{display:flex;flex-direction:column;margin-right:var(--eui-s-m);width:100%}.eui-19 :host.eui-card-header .eui-card-header__expander.eui-card-header__expander--bottom{background-color:var(--eui-c-white);border-radius:var(--eui-br-max);bottom:calc(-.75 * var(--eui-s-m));box-shadow:var(--eui-sh-1);justify-content:center;position:absolute;right:50%;transform:translate(50%);width:calc(2 * var(--eui-s-m));z-index:1}.eui-19 :host.eui-card-header .eui-card-header__expander.eui-card-header__expander--top{align-self:flex-start}.eui-19 .eui-card--selected :host.eui-card-header{background-color:var(--eui-c-active-bg);border-radius:var(--eui-br-m) var(--eui-br-m) 0 0}.eui-19 .eui-card--collapsible :host.eui-card-header .eui-card-header__container:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-19 .eui-card--collapsible :host.eui-card-header .eui-card-header__container:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 .eui-card--collapsible :host.eui-card-header .eui-card-header__container [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 .eui-card--collapsible :host.eui-card-header .eui-card-header__expander{align-items:center;display:inline-flex;margin-left:var(--eui-s-xs);margin-right:calc(-1 * var(--eui-s-xs))}.eui-19 .eui-card--collapsed :host.eui-card-header{border-radius:var(--eui-br-m)}.eui-19 .eui-card--collapsed :host.eui-card-header .eui-card-header__expander .eui-button.eui-card-header__expander-icon{transform:rotate(180deg)!important}.eui-19 .eui-card--collapsed :host.eui-card-header .eui-card-header__container{border-bottom:1px solid transparent}\n"], dependencies: [{ kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "pipe", type: AsyncPipe, name: "async" }, { kind: "component", type: i3.EuiIconSvgComponent, selector: "eui-icon-svg, span[euiIconSvg], i[euiIconSvg]", inputs: ["icon", "fillColor", "set", "size", "style", "iconUrl", "transform", "euiVariant", "aria-label", "ariaHidden", "focusable", "isLoading", "isInputIcon", "euiStart", "euiEnd"] }, { kind: "component", type: i2$1.EuiIconButtonExpanderComponent, selector: "eui-icon-button-expander", inputs: ["fillColor", "size", "ariaLabel", "isExpanded", "isDirectionForward", "euiDisabled"], outputs: ["buttonClick"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-header', imports: [
                        NgTemplateOutlet,
                        AsyncPipe,
                        ...EUI_ICON,
                        ...EUI_ICON_BUTTON_EXPANDER,
                    ], changeDetection: ChangeDetectionStrategy.OnPush, template: "<button type=\"button\" class=\"eui-card-header__container\" (click)=\"onToggleHeader()\"\n        [attr.tabindex]=\"(uiStateService.state$ | async).isCollapsible && hasHeaderClickToggle ? '0' : '-1'\">\n\n    <ng-content select=\"eui-card-header-left-content\"></ng-content>\n\n    @if (!hasFullTitle) {\n        <div class=\"eui-card-header__title-container\" [class.eui-card-header__title-container--multilines]=\"isHeaderMultilines\">\n            <ng-content *ngTemplateOutlet=\"title\"></ng-content>\n            <ng-content *ngTemplateOutlet=\"subtitle\"></ng-content>\n        </div>\n        <ng-content *ngTemplateOutlet=\"rightContent\"></ng-content>\n}\n\n    @if (hasFullTitle) {\n        <div class=\"eui-card-header__middle-container\">\n            <div class=\"eui-card-header__title-container\" [class.eui-card-header__title-container--multilines]=\"isHeaderMultilines\">\n                <ng-content *ngTemplateOutlet=\"title\"></ng-content>\n            </div>\n            <div class=\"eui-card-header__middle-content\">\n                <ng-content *ngTemplateOutlet=\"subtitle\"></ng-content>\n                <ng-content *ngTemplateOutlet=\"rightContent\"></ng-content>\n            </div>\n        </div>\n}\n\n    @if ((uiStateService.state$ | async).isCollapsible) {\n        <div\n            class=\"eui-card-header__expander\"\n            [class.eui-card-header__expander--bottom]=\"hasBottomExpander\"\n            [class.eui-card-header__expander--top]=\"isHeaderMultilines\">\n            <eui-icon-button-expander class=\"eui-card-header__expander-icon\"\n                [isExpanded]=\"!(uiStateService.state$ | async).isCollapsed\" (buttonClick)=\"onToggle($event)\">\n            </eui-icon-button-expander>\n        </div>\n    }\n</button>\n\n@if ((uiStateService.state$ | async).isUrgent) {\n    <div class=\"eui-card-header__urgent-indicator\">\n        <eui-icon-svg icon=\"alert:sharp\" fillColor=\"white\"></eui-icon-svg>\n    </div>\n}\n<ng-content select=\"eui-card-header-body\" />\n\n<ng-template #title>\n    <ng-content select=\"eui-card-header-title\" />\n</ng-template>\n\n<ng-template #subtitle>\n    <ng-content select=\"eui-card-header-subtitle\" />\n</ng-template>\n\n<ng-template #rightContent>\n    <ng-content select=\"eui-card-header-right-content\" />\n</ng-template>\n", styles: [".eui-19 :host.eui-card-header{align-items:center;background:var(--eui-c-white);border-bottom:1px solid var(--eui-c-divider);border-radius:var(--eui-br-m) var(--eui-br-m) 0 0;flex-direction:row;display:flex;flex-wrap:wrap;width:100%}.eui-19 :host.eui-card-header .eui-card-header__container{align-items:center;border-bottom:1px solid var(--eui-c-divider);display:flex;margin-bottom:-1px;min-height:calc(3 * var(--eui-s-m));padding:var(--eui-s-m);width:100%;outline:none;border:var(--eui-bw-none);background-color:initial;text-align:start;-webkit-user-select:text;user-select:text}.eui-19 :host.eui-card-header .eui-card-header__container+.eui-card-header-body{border-bottom:1px solid var(--eui-c-divider);margin-bottom:-1px}.eui-19 :host.eui-card-header .eui-card-header__urgent-indicator{background:var(--eui-c-s-danger);border-radius:var(--eui-br-max);position:absolute;right:calc(-1 * var(--eui-s-s));top:calc(-1 * var(--eui-s-s));height:var(--eui-s-xl)}.eui-19 :host.eui-card-header .eui-card-header__title-container{display:flex;flex-direction:column;justify-content:center;margin-right:var(--eui-s-s);margin-top:var(--eui-s-2xs);width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 :host.eui-card-header .eui-card-header__title-container--multilines{overflow:visible;text-overflow:unset;white-space:unset!important}.eui-19 :host.eui-card-header .eui-card-header__middle-container{display:flex;flex-direction:column;justify-content:flex-start;width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap}.eui-19 :host.eui-card-header .eui-card-header__middle-content{display:flex;flex-direction:row;justify-content:flex-start;margin-top:var(--eui-s-s);width:100%}.eui-19 :host.eui-card-header .eui-card-header__middle-content .eui-card-header__title-container-subtitle{display:flex;flex-direction:column;margin-right:var(--eui-s-m);width:100%}.eui-19 :host.eui-card-header .eui-card-header__expander.eui-card-header__expander--bottom{background-color:var(--eui-c-white);border-radius:var(--eui-br-max);bottom:calc(-.75 * var(--eui-s-m));box-shadow:var(--eui-sh-1);justify-content:center;position:absolute;right:50%;transform:translate(50%);width:calc(2 * var(--eui-s-m));z-index:1}.eui-19 :host.eui-card-header .eui-card-header__expander.eui-card-header__expander--top{align-self:flex-start}.eui-19 .eui-card--selected :host.eui-card-header{background-color:var(--eui-c-active-bg);border-radius:var(--eui-br-m) var(--eui-br-m) 0 0}.eui-19 .eui-card--collapsible :host.eui-card-header .eui-card-header__container:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-19 .eui-card--collapsible :host.eui-card-header .eui-card-header__container:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 .eui-card--collapsible :host.eui-card-header .eui-card-header__container [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 .eui-card--collapsible :host.eui-card-header .eui-card-header__expander{align-items:center;display:inline-flex;margin-left:var(--eui-s-xs);margin-right:calc(-1 * var(--eui-s-xs))}.eui-19 .eui-card--collapsed :host.eui-card-header{border-radius:var(--eui-br-m)}.eui-19 .eui-card--collapsed :host.eui-card-header .eui-card-header__expander .eui-button.eui-card-header__expander-icon{transform:rotate(180deg)!important}.eui-19 .eui-card--collapsed :host.eui-card-header .eui-card-header__container{border-bottom:1px solid transparent}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }], expandLabel: [{
                type: Input
            }], collapseLabel: [{
                type: Input
            }], hasHeaderClickToggle: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasBottomExpander: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasFullTitle: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], isHeaderMultilines: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], collapse: [{
                type: Output
            }] } });

/**
 * @description
 * The eui-card-header-body component projects the body for eui-card-header.
 */
class EuiCardMediaComponent {
    constructor() {
        /**
         * Option to specify an image description.
         * @default 'eUI Card Image'
         */
        this.imageDescription = 'eUI Card Image';
        /**
         * Option to specify the image height.
         * @default 'auto'
         */
        this.imageHeight = 'auto';
        /**
         * Binds the class to the component.
         *
         * @default 'eui-card-media'
         */
        this.string = 'eui-card-media';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardMediaComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.12", type: EuiCardMediaComponent, isStandalone: true, selector: "eui-card-media", inputs: { imageUrl: "imageUrl", imageLegend: "imageLegend", imageClickUrl: "imageClickUrl", imageClickUrlExternal: "imageClickUrlExternal", imageDescription: "imageDescription", imageHeight: "imageHeight" }, host: { properties: { "class": "this.string" } }, ngImport: i0, template: "<div class=\"eui-card-media__container\">\n    @if (imageClickUrl) {\n        <a routerLink=\"{{ imageClickUrl }}\" class=\"eui-card-media__container-content\">\n            <ng-content *ngTemplateOutlet=\"mediacontent\"></ng-content>\n        </a>\n    }\n    @if (imageClickUrlExternal) {\n        <a href=\"{{ imageClickUrlExternal }}\" target=\"_blank\" class=\"eui-card-media__container-content\">\n            <ng-content *ngTemplateOutlet=\"mediacontent\"></ng-content>\n        </a>\n    }\n    @if (!imageClickUrl && !imageClickUrlExternal) {\n        <ng-content *ngTemplateOutlet=\"mediacontent\"></ng-content>\n    }\n</div>\n<ng-template #mediacontent>\n    <img class=\"eui-card-media__image\" [src]=\"imageUrl\" [height]=\"imageHeight\" alt=\"{{ !imageLegend ? imageDescription : '' }}\" />\n    @if (imageLegend) {\n        <div class=\"eui-card-media__legend\">{{ imageLegend }}</div>\n    }\n</ng-template>\n", styles: [".eui-19 .eui-card :host.eui-card-media{display:flex}.eui-19 .eui-card :host.eui-card-media .eui-card-media__image{height:auto;margin:0;object-fit:cover;width:100%}.eui-19 .eui-card :host.eui-card-media .eui-card-media__image:first-child{margin-top:0}.eui-19 .eui-card :host.eui-card-media .eui-card-media__container{overflow:hidden;position:relative;width:100%}.eui-19 .eui-card :host.eui-card-media .eui-card-media__container-content{width:100%}.eui-19 .eui-card :host.eui-card-media .eui-card-media__container .eui-card-media__legend{background:linear-gradient(rgba(0,0,0,0) 0%,var(--eui-c-neutral-bg-light) 100%);bottom:0;color:var(--eui-c-white);left:0;min-height:3rem;padding:var(--eui-s-m);position:absolute;text-shadow:0 1px 0 var(--eui-c-black);font:var(--eui-f-xl-bold);align-items:center;display:flex;width:100%}.eui-19 .eui-card--collapsed :host.eui-card-media{height:0!important;padding:0 var(--eui-s-m)}\n"], dependencies: [{ kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "info", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardMediaComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card-media', imports: [
                        NgTemplateOutlet,
                        RouterLink,
                    ], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"eui-card-media__container\">\n    @if (imageClickUrl) {\n        <a routerLink=\"{{ imageClickUrl }}\" class=\"eui-card-media__container-content\">\n            <ng-content *ngTemplateOutlet=\"mediacontent\"></ng-content>\n        </a>\n    }\n    @if (imageClickUrlExternal) {\n        <a href=\"{{ imageClickUrlExternal }}\" target=\"_blank\" class=\"eui-card-media__container-content\">\n            <ng-content *ngTemplateOutlet=\"mediacontent\"></ng-content>\n        </a>\n    }\n    @if (!imageClickUrl && !imageClickUrlExternal) {\n        <ng-content *ngTemplateOutlet=\"mediacontent\"></ng-content>\n    }\n</div>\n<ng-template #mediacontent>\n    <img class=\"eui-card-media__image\" [src]=\"imageUrl\" [height]=\"imageHeight\" alt=\"{{ !imageLegend ? imageDescription : '' }}\" />\n    @if (imageLegend) {\n        <div class=\"eui-card-media__legend\">{{ imageLegend }}</div>\n    }\n</ng-template>\n", styles: [".eui-19 .eui-card :host.eui-card-media{display:flex}.eui-19 .eui-card :host.eui-card-media .eui-card-media__image{height:auto;margin:0;object-fit:cover;width:100%}.eui-19 .eui-card :host.eui-card-media .eui-card-media__image:first-child{margin-top:0}.eui-19 .eui-card :host.eui-card-media .eui-card-media__container{overflow:hidden;position:relative;width:100%}.eui-19 .eui-card :host.eui-card-media .eui-card-media__container-content{width:100%}.eui-19 .eui-card :host.eui-card-media .eui-card-media__container .eui-card-media__legend{background:linear-gradient(rgba(0,0,0,0) 0%,var(--eui-c-neutral-bg-light) 100%);bottom:0;color:var(--eui-c-white);left:0;min-height:3rem;padding:var(--eui-s-m);position:absolute;text-shadow:0 1px 0 var(--eui-c-black);font:var(--eui-f-xl-bold);align-items:center;display:flex;width:100%}.eui-19 .eui-card--collapsed :host.eui-card-media{height:0!important;padding:0 var(--eui-s-m)}\n"] }]
        }], propDecorators: { imageUrl: [{
                type: Input
            }], imageLegend: [{
                type: Input
            }], imageClickUrl: [{
                type: Input
            }], imageClickUrlExternal: [{
                type: Input
            }], imageDescription: [{
                type: Input
            }], imageHeight: [{
                type: Input
            }], string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * The eui-card component is based on Material Design and provides a content container for text, photos and actions in the context of a single subject.
 */
class EuiCardComponent {
    constructor() {
        /**
         * Sets the `data-e2e` attribute at the host element.
         *
         * @default 'eui-card'
         */
        this.e2eAttr = 'eui-card';
        /**
         * Sets the `euiSelected` attribute in order to show the card header as selected.
         *
         * @default false
         */
        this.euiSelected = false;
        /**
         * Sets the `euiCollapsible` attribute which shows the collapsible toggle in the header.
         *
         * @default false
         */
        this.euiCollapsible = false;
        /**
         * Sets the `euiCollapsed` attribute which collapses the card content.
         *
         * @default false
         */
        this.euiCollapsed = false;
        /**
         * Sets the `euiUrgent` attribute in order to show the card header as urgent.
         *
         * @default false
         */
        this.euiUrgent = false;
        /**
         * Sets the `euiNoShadow` attribute in order to remove the shadow from the card.
         *
         * @default false
         */
        this.euiNoShadow = false;
        /**
         * Sets the `euiNoContentPadding` attribute in order to remove the padding from the card content.
         *
         * @default false
         */
        this.euiNoContentPadding = false;
        /**
         * Sets the `euiHoverable` attribute in order to show the hover effect on the card.
         *
         * @default false
         */
        this.euiHoverable = false;
        /**
         * Event emitted when the card collapses.
         */
        this.collapse = new EventEmitter();
        this.uiStateService = inject(UiStateService);
        this.destroy$ = new Subject();
        this.baseStatesDirective = inject(BaseStatesDirective);
    }
    /**
     * @description
     * Computes and returns the CSS classes for the component based on its current state.
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses() {
        return [
            this.baseStatesDirective.getCssClasses('eui-card'),
            this.euiCollapsible ? 'eui-card--collapsible' : '',
            this.euiCollapsed ? 'eui-card--collapsed' : '',
            this.euiSelected ? 'eui-card--selected' : '',
            this.euiUrgent ? 'eui-card--urgent' : '',
            this.euiNoShadow ? 'eui-card--no-shadow' : '',
            this.euiNoContentPadding ? 'eui-card--no-content-padding' : '',
            this.euiHoverable ? 'eui-card--hoverable' : '',
        ]
            .join(' ')
            .trim();
    }
    ngOnChanges(changes) {
        if (changes?.euiCollapsible && !changes?.euiCollapsible.firstChange) {
            this._setCardState();
        }
        if (changes?.euiCollapsed && !changes?.euiCollapsed.firstChange) {
            this._setCardState();
        }
        if (changes?.euiUrgent && !changes?.euiUrgent.firstChange) {
            this._setCardState();
        }
    }
    ngOnInit() {
        this._setCardState();
    }
    ngAfterContentInit() {
        this.uiStateService.state$
            .pipe(map((state) => state.isCollapsed), skip(1), takeUntil(this.destroy$))
            .subscribe((isCollapsed) => {
            this.euiCollapsed = isCollapsed;
            this.collapse.emit(isCollapsed);
        });
        this.uiStateService.state$
            .pipe(map((state) => state.isCollapsible), skip(1), takeUntil(this.destroy$))
            .subscribe((isCollapsible) => {
            this.euiCollapsible = isCollapsible;
        });
    }
    ngOnDestroy() {
        this.destroy$.next(true);
        this.destroy$.unsubscribe();
    }
    /**
     * Sets the card state in the UIStateService.
     * This method is called when the component is initialized and when the input properties change.
     */
    _setCardState() {
        const nextState = {
            ...this.uiStateService.state,
            isCollapsible: coerceBooleanProperty(this.euiCollapsible),
            isCollapsed: coerceBooleanProperty(this.euiCollapsed),
            isUrgent: coerceBooleanProperty(this.euiUrgent),
        };
        this.uiStateService.setState(nextState);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "16.1.0", version: "19.2.12", type: EuiCardComponent, isStandalone: true, selector: "eui-card", inputs: { e2eAttr: "e2eAttr", euiSelected: ["euiSelected", "euiSelected", booleanAttribute], euiCollapsible: ["euiCollapsible", "euiCollapsible", booleanAttribute], euiCollapsed: ["euiCollapsed", "euiCollapsed", booleanAttribute], euiUrgent: ["euiUrgent", "euiUrgent", booleanAttribute], euiNoShadow: ["euiNoShadow", "euiNoShadow", booleanAttribute], euiNoContentPadding: ["euiNoContentPadding", "euiNoContentPadding", booleanAttribute], euiHoverable: ["euiHoverable", "euiHoverable", booleanAttribute] }, outputs: { collapse: "collapse" }, host: { properties: { "class": "this.cssClasses", "attr.data-e2e": "this.e2eAttr" } }, providers: [UiStateService], usesOnChanges: true, hostDirectives: [{ directive: i1$1.BaseStatesDirective, inputs: ["euiPrimary", "euiPrimary", "euiSecondary", "euiSecondary", "euiInfo", "euiInfo", "euiSuccess", "euiSuccess", "euiWarning", "euiWarning", "euiDanger", "euiDanger", "euiAccent", "euiAccent", "euiHighlighted", "euiHighlighted", "euiDisabled", "euiDisabled", "euiLoading", "euiLoading", "euiSizeXS", "euiSizeXS", "euiSizeS", "euiSizeS", "euiSizeM", "euiSizeM", "euiSizeL", "euiSizeL", "euiSizeXL", "euiSizeXL", "euiSize2XL", "euiSize2XL", "euiSizeVariant", "euiSizeVariant"] }], ngImport: i0, template: "<ng-content select=\"eui-card-header\" />\n<ng-content select=\"eui-card-media\" />\n<ng-content select=\"eui-card-content\" />\n<ng-content select=\"eui-card-footer\" />\n", styles: [".eui-19 :host.eui-card{border:var(--eui-bw-xs) solid var(--eui-c-divider);border-radius:var(--eui-br-m);box-shadow:var(--eui-sh-card);display:flex;flex-direction:column;height:auto;padding:0;position:relative;transition:box-shadow .28s cubic-bezier(.4,0,.2,1);width:100%;font:var(--eui-f-m)}.eui-19 :host.eui-card.eui-card--no-shadow{box-shadow:none!important}.eui-19 :host.eui-card.eui-card--hoverable:hover{box-shadow:var(--eui-sh-2)}.eui-19 :host.eui-card.eui-card--disabled,.eui-19 :host.eui-card.eui-card--is-loading,.eui-19 :host.eui-card[disabled],.eui-19 :host.eui-card.disabled{opacity:.45;pointer-events:none}.eui-19 :host.eui-card.eui-card--primary{border-left:6px solid var(--eui-c-s-primary-base)}.eui-19 :host.eui-card.eui-card--secondary{border-left:6px solid var(--eui-c-s-secondary-base)}.eui-19 :host.eui-card.eui-card--info{border-left:6px solid var(--eui-c-s-info-base)}.eui-19 :host.eui-card.eui-card--success{border-left:6px solid var(--eui-c-s-success-base)}.eui-19 :host.eui-card.eui-card--warning{border-left:6px solid var(--eui-c-s-warning-base)}.eui-19 :host.eui-card.eui-card--danger{border-left:6px solid var(--eui-c-s-danger-base)}.eui-19 :host.eui-card.eui-card--accent{border-left:6px solid var(--eui-c-s-accent-base)}.eui-19 :host.eui-card--highlighted{z-index:var(--eui-zi-highlighted)}.eui-19 :host.eui-card.eui-card--no-border{border:var(--eui-bw-none)}.eui-19[euiresizable]{position:relative;min-width:var(--eui-card-resizable-min-width)}@media screen and (max-width: 767px){.eui-19 :host.eui-card .eui-card-header__left-content button{flex-wrap:wrap}.eui-19 :host.eui-card .eui-card-header__right-content{flex-wrap:wrap}.eui-19 :host.eui-card .eui-card-header__right-content *[style*=\"visibility: hidden\"]{display:none}.eui-19 :host.eui-card .eui-card-header__title-container-title{white-space:normal}.eui-19 :host.eui-card .eui-card-header__title-container-subtitle{white-space:normal}}@media screen and (min-width: 768px) and (max-width: 995px){.eui-19 :host.eui-card .eui-card-header__left-content button{flex-wrap:wrap}.eui-19 :host.eui-card .eui-card-header__right-content{flex-wrap:wrap}.eui-19 :host.eui-card .eui-card-header__right-content *[style*=\"visibility: hidden\"]{display:none}}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-card', changeDetection: ChangeDetectionStrategy.OnPush, providers: [UiStateService], hostDirectives: [
                        {
                            directive: BaseStatesDirective,
                            inputs: [
                                'euiPrimary',
                                'euiSecondary',
                                'euiInfo',
                                'euiSuccess',
                                'euiWarning',
                                'euiDanger',
                                'euiAccent',
                                'euiHighlighted',
                                'euiDisabled',
                                'euiLoading',
                                'euiSizeXS',
                                'euiSizeS',
                                'euiSizeM',
                                'euiSizeL',
                                'euiSizeXL',
                                'euiSize2XL',
                                'euiSizeVariant',
                            ],
                        },
                    ], template: "<ng-content select=\"eui-card-header\" />\n<ng-content select=\"eui-card-media\" />\n<ng-content select=\"eui-card-content\" />\n<ng-content select=\"eui-card-footer\" />\n", styles: [".eui-19 :host.eui-card{border:var(--eui-bw-xs) solid var(--eui-c-divider);border-radius:var(--eui-br-m);box-shadow:var(--eui-sh-card);display:flex;flex-direction:column;height:auto;padding:0;position:relative;transition:box-shadow .28s cubic-bezier(.4,0,.2,1);width:100%;font:var(--eui-f-m)}.eui-19 :host.eui-card.eui-card--no-shadow{box-shadow:none!important}.eui-19 :host.eui-card.eui-card--hoverable:hover{box-shadow:var(--eui-sh-2)}.eui-19 :host.eui-card.eui-card--disabled,.eui-19 :host.eui-card.eui-card--is-loading,.eui-19 :host.eui-card[disabled],.eui-19 :host.eui-card.disabled{opacity:.45;pointer-events:none}.eui-19 :host.eui-card.eui-card--primary{border-left:6px solid var(--eui-c-s-primary-base)}.eui-19 :host.eui-card.eui-card--secondary{border-left:6px solid var(--eui-c-s-secondary-base)}.eui-19 :host.eui-card.eui-card--info{border-left:6px solid var(--eui-c-s-info-base)}.eui-19 :host.eui-card.eui-card--success{border-left:6px solid var(--eui-c-s-success-base)}.eui-19 :host.eui-card.eui-card--warning{border-left:6px solid var(--eui-c-s-warning-base)}.eui-19 :host.eui-card.eui-card--danger{border-left:6px solid var(--eui-c-s-danger-base)}.eui-19 :host.eui-card.eui-card--accent{border-left:6px solid var(--eui-c-s-accent-base)}.eui-19 :host.eui-card--highlighted{z-index:var(--eui-zi-highlighted)}.eui-19 :host.eui-card.eui-card--no-border{border:var(--eui-bw-none)}.eui-19[euiresizable]{position:relative;min-width:var(--eui-card-resizable-min-width)}@media screen and (max-width: 767px){.eui-19 :host.eui-card .eui-card-header__left-content button{flex-wrap:wrap}.eui-19 :host.eui-card .eui-card-header__right-content{flex-wrap:wrap}.eui-19 :host.eui-card .eui-card-header__right-content *[style*=\"visibility: hidden\"]{display:none}.eui-19 :host.eui-card .eui-card-header__title-container-title{white-space:normal}.eui-19 :host.eui-card .eui-card-header__title-container-subtitle{white-space:normal}}@media screen and (min-width: 768px) and (max-width: 995px){.eui-19 :host.eui-card .eui-card-header__left-content button{flex-wrap:wrap}.eui-19 :host.eui-card .eui-card-header__right-content{flex-wrap:wrap}.eui-19 :host.eui-card .eui-card-header__right-content *[style*=\"visibility: hidden\"]{display:none}}\n"] }]
        }], propDecorators: { cssClasses: [{
                type: HostBinding,
                args: ['class']
            }], e2eAttr: [{
                type: HostBinding,
                args: ['attr.data-e2e']
            }, {
                type: Input
            }], euiSelected: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], euiCollapsible: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], euiCollapsed: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], euiUrgent: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], euiNoShadow: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], euiNoContentPadding: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], euiHoverable: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], collapse: [{
                type: Output
            }] } });

/**
 * EuiCardModule is the main module for the EuiCard component.
 * It imports and exports all the necessary components for the EuiCard to work.
 * It also provides the EuiCardComponent as a standalone component.
 *
 * @deprecated Use {@link EUI_CARD} instead.
 */
class EuiCardModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.12", ngImport: i0, type: EuiCardModule, imports: [EuiCardComponent,
            EuiCardHeaderComponent,
            EuiCardHeaderTitleComponent,
            EuiCardContentComponent,
            EuiCardHeaderLeftContentComponent,
            EuiCardHeaderRightContentComponent,
            EuiCardHeaderSubtitleComponent,
            EuiCardHeaderBodyComponent,
            EuiCardFooterActionButtonsComponent,
            EuiCardFooterActionIconsComponent,
            EuiCardMediaComponent,
            EuiCardFooterComponent,
            EuiCardFooterMenuContentComponent,
            EuiCardFooterMenuComponent], exports: [EuiCardComponent,
            EuiCardHeaderComponent,
            EuiCardHeaderTitleComponent,
            EuiCardContentComponent,
            EuiCardHeaderLeftContentComponent,
            EuiCardHeaderRightContentComponent,
            EuiCardHeaderSubtitleComponent,
            EuiCardHeaderBodyComponent,
            EuiCardFooterActionButtonsComponent,
            EuiCardFooterActionIconsComponent,
            EuiCardMediaComponent,
            EuiCardFooterComponent,
            EuiCardFooterMenuContentComponent,
            EuiCardFooterMenuComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardModule, imports: [EuiCardHeaderComponent,
            EuiCardFooterMenuContentComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiCardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        EuiCardComponent,
                        EuiCardHeaderComponent,
                        EuiCardHeaderTitleComponent,
                        EuiCardContentComponent,
                        EuiCardHeaderLeftContentComponent,
                        EuiCardHeaderRightContentComponent,
                        EuiCardHeaderSubtitleComponent,
                        EuiCardHeaderBodyComponent,
                        EuiCardFooterActionButtonsComponent,
                        EuiCardFooterActionIconsComponent,
                        EuiCardMediaComponent,
                        EuiCardFooterComponent,
                        EuiCardFooterMenuContentComponent,
                        EuiCardFooterMenuComponent,
                    ],
                    exports: [
                        EuiCardComponent,
                        EuiCardHeaderComponent,
                        EuiCardHeaderTitleComponent,
                        EuiCardContentComponent,
                        EuiCardHeaderLeftContentComponent,
                        EuiCardHeaderRightContentComponent,
                        EuiCardHeaderSubtitleComponent,
                        EuiCardHeaderBodyComponent,
                        EuiCardFooterActionButtonsComponent,
                        EuiCardFooterActionIconsComponent,
                        EuiCardMediaComponent,
                        EuiCardFooterComponent,
                        EuiCardFooterMenuContentComponent,
                        EuiCardFooterMenuComponent,
                    ],
                }]
        }] });

const EUI_CARD = [
    EuiCardComponent,
    EuiCardHeaderComponent,
    EuiCardHeaderTitleComponent,
    EuiCardContentComponent,
    EuiCardHeaderLeftContentComponent,
    EuiCardHeaderRightContentComponent,
    EuiCardHeaderSubtitleComponent,
    EuiCardHeaderBodyComponent,
    EuiCardFooterActionButtonsComponent,
    EuiCardFooterActionIconsComponent,
    EuiCardMediaComponent,
    EuiCardFooterComponent,
    EuiCardFooterMenuContentComponent,
    EuiCardFooterMenuComponent,
];

/**
 * Generated bundle index. Do not edit.
 */

export { EUI_CARD, EuiCardComponent, EuiCardContentComponent, EuiCardFooterActionButtonsComponent, EuiCardFooterActionIconsComponent, EuiCardFooterComponent, EuiCardFooterMenuComponent, EuiCardFooterMenuContentComponent, EuiCardHeaderBodyComponent, EuiCardHeaderComponent, EuiCardHeaderLeftContentComponent, EuiCardHeaderRightContentComponent, EuiCardHeaderSubtitleComponent, EuiCardHeaderTitleComponent, EuiCardMediaComponent, EuiCardModule };
//# sourceMappingURL=eui-components-eui-card.mjs.map
