import * as i0 from '@angular/core';
import { HostBinding, ChangeDetectionStrategy, Component, NgModule } from '@angular/core';

/**
 * A component that groups chip elements together.
 *
 */
class EuiChipGroupComponent {
    /**
     * Returns the CSS classes for the component.
     * This binds the 'eui-chip-group' class to the host element.
     *
     * @returns {string} The CSS class name
     */
    get cssClasses() {
        return 'eui-chip-group';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiChipGroupComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiChipGroupComponent, isStandalone: true, selector: "eui-chip-group", host: { properties: { "class": "this.cssClasses" } }, ngImport: i0, template: '<ng-content/>', isInline: true, styles: [".eui-19 :host.eui-chip-group{align-items:center;display:inline-flex;flex-wrap:nowrap;position:relative}.eui-19 :host.eui-chip-group ::ng-deep .eui-chip:first-child{border-bottom-right-radius:0;border-top-right-radius:0;margin-right:0}.eui-19 :host.eui-chip-group ::ng-deep .eui-chip:last-child{border-bottom-left-radius:0;border-top-left-radius:0;margin-left:0}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiChipGroupComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-chip-group', template: '<ng-content/>', changeDetection: ChangeDetectionStrategy.OnPush, styles: [".eui-19 :host.eui-chip-group{align-items:center;display:inline-flex;flex-wrap:nowrap;position:relative}.eui-19 :host.eui-chip-group ::ng-deep .eui-chip:first-child{border-bottom-right-radius:0;border-top-right-radius:0;margin-right:0}.eui-19 :host.eui-chip-group ::ng-deep .eui-chip:last-child{border-bottom-left-radius:0;border-top-left-radius:0;margin-left:0}\n"] }]
        }], propDecorators: { cssClasses: [{
                type: HostBinding,
                args: ['class']
            }] } });
/**
 * Module that exports the EuiChipGroupComponent.
 * Import this module to use the chip group component in your application.
 *
 * @deprecated Use {@link EUI_CHIP_GROUP} instead.
 */
class EuiChipGroupModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiChipGroupModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.12", ngImport: i0, type: EuiChipGroupModule, imports: [EuiChipGroupComponent], exports: [EuiChipGroupComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiChipGroupModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiChipGroupModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [EuiChipGroupComponent],
                    exports: [EuiChipGroupComponent],
                }]
        }] });

const EUI_CHIP_GROUP = [
    EuiChipGroupComponent,
];
// export { EuiChipGroupComponent as EuiChipGroup } from './eui-chip-group.component';

/**
 * Generated bundle index. Do not edit.
 */

export { EUI_CHIP_GROUP, EuiChipGroupComponent, EuiChipGroupModule };
//# sourceMappingURL=eui-components-eui-chip-group.mjs.map
