import * as i0 from '@angular/core';
import { HostBinding, Component, Input, EventEmitter, inject, booleanAttribute, HostListener, forwardRef, ContentChild, Output, ChangeDetectionStrategy, NgModule } from '@angular/core';
import * as i1 from '@eui/components/eui-icon';
import { EUI_ICON } from '@eui/components/eui-icon';
import * as i2 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i1$1 from '@eui/components/shared';
import { BaseStatesDirective } from '@eui/components/shared';
import * as i3 from '@eui/components/eui-avatar';
import { EUI_AVATAR } from '@eui/components/eui-avatar';
import * as i4 from '@eui/components/eui-label';
import { EUI_LABEL } from '@eui/components/eui-label';
import { NgClass, NgTemplateOutlet } from '@angular/common';

/**
 * @description
 * Content container component for EuiDashboardCard.
 * Provides content projection and applies consistent styling.
 */
class EuiDashboardCardContentComponent {
    constructor() {
        /** CSS class applied to the host element */
        this.string = 'eui-dashboard-card-content';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiDashboardCardContentComponent, isStandalone: true, selector: "eui-dashboard-card-content", host: { properties: { "class": "this.string" } }, ngImport: i0, template: "<ng-content select=\"eui-dashboard-card-content-header\"/>\n<ng-content select=\"eui-dashboard-card-content-body\"/>\n<ng-content select=\"eui-dashboard-card-content-footer\"/>\n\n<ng-content/>", styles: [".eui-19 :host{display:block;width:100%}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-dashboard-card-content', template: "<ng-content select=\"eui-dashboard-card-content-header\"/>\n<ng-content select=\"eui-dashboard-card-content-body\"/>\n<ng-content select=\"eui-dashboard-card-content-footer\"/>\n\n<ng-content/>", styles: [".eui-19 :host{display:block;width:100%}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * Content container component for EuiDashboardCard.
 * Provides content projection and applies consistent styling.
 */
class EuiDashboardCardContentBodyComponent {
    constructor() {
        /** CSS class applied to the host element */
        this.string = 'eui-dashboard-card-content-body';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentBodyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiDashboardCardContentBodyComponent, isStandalone: true, selector: "eui-dashboard-card-content-body", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content />', isInline: true, styles: [".eui-19 :host{display:flex;flex-direction:column;width:100%;padding-top:var(--eui-s-s)}.eui-19 .eui-dashboard-card--stacked :host{padding-top:0}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentBodyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-dashboard-card-content-body', template: '<ng-content />', styles: [".eui-19 :host{display:flex;flex-direction:column;width:100%;padding-top:var(--eui-s-s)}.eui-19 .eui-dashboard-card--stacked :host{padding-top:0}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * Content container component for EuiDashboardCard.
 * Provides content projection and applies consistent styling.
 */
class EuiDashboardCardContentFooterComponent {
    constructor() {
        /** CSS class applied to the host element */
        this.string = 'eui-dashboard-card-content-footer';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentFooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiDashboardCardContentFooterComponent, isStandalone: true, selector: "eui-dashboard-card-content-footer", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content />', isInline: true, styles: [".eui-19 :host{display:flex;width:calc(100% + var(--eui-s-xl));padding:var(--eui-s-xs) var(--eui-s-s) 0 var(--eui-s-xs);margin-left:calc(-1 * var(--eui-s-s));margin-top:var(--eui-s-s);border-top:1px solid var(--eui-c-neutral-bg)}.eui-19 .eui-dashboard-card--stacked :host{margin-top:0}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentFooterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-dashboard-card-content-footer', template: '<ng-content />', styles: [".eui-19 :host{display:flex;width:calc(100% + var(--eui-s-xl));padding:var(--eui-s-xs) var(--eui-s-s) 0 var(--eui-s-xs);margin-left:calc(-1 * var(--eui-s-s));margin-top:var(--eui-s-s);border-top:1px solid var(--eui-c-neutral-bg)}.eui-19 .eui-dashboard-card--stacked :host{margin-top:0}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * Content container component for EuiDashboardCard.
 * Provides content projection and applies consistent styling.
 */
class EuiDashboardCardContentHeaderComponent {
    constructor() {
        /** CSS class applied to the host element */
        this.string = 'eui-dashboard-card-content-header';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentHeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiDashboardCardContentHeaderComponent, isStandalone: true, selector: "eui-dashboard-card-content-header", host: { properties: { "class": "this.string" } }, ngImport: i0, template: "<div class=\"eui-dashboard-card-content-header-start\">\n    <ng-content select=\"eui-dashboard-card-content-header-icon\"/>\n    <ng-content select=\"eui-dashboard-card-content-header-title\"/>\n</div>\n<div class=\"eui-dashboard-card-content-header-end\">\n    <ng-content select=\"eui-dashboard-card-content-header-action\"/>\n</div>\n\n<ng-content/>", styles: [".eui-19 :host{display:flex;align-items:center;width:calc(100% + var(--eui-s-xl));border-bottom:1px solid var(--eui-c-divider);padding:0 var(--eui-s-s) var(--eui-s-xs) var(--eui-s-s);margin-left:calc(-1 * var(--eui-s-s));min-height:var(--eui-s-4xl)}.eui-19 :host .eui-dashboard-card-content-header-start{display:flex;align-items:center;gap:var(--eui-s-s)}.eui-19 :host .eui-dashboard-card-content-header-end{display:flex;margin-left:auto;align-items:center}.eui-19 .eui-dashboard-card--stacked :host{border:none;padding-bottom:0}.eui-19 .eui-dashboard-card--stacked :host .eui-dashboard-card-content-header-start{display:flex;align-items:start;flex-direction:column;gap:var(--eui-s-xs)}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-dashboard-card-content-header', template: "<div class=\"eui-dashboard-card-content-header-start\">\n    <ng-content select=\"eui-dashboard-card-content-header-icon\"/>\n    <ng-content select=\"eui-dashboard-card-content-header-title\"/>\n</div>\n<div class=\"eui-dashboard-card-content-header-end\">\n    <ng-content select=\"eui-dashboard-card-content-header-action\"/>\n</div>\n\n<ng-content/>", styles: [".eui-19 :host{display:flex;align-items:center;width:calc(100% + var(--eui-s-xl));border-bottom:1px solid var(--eui-c-divider);padding:0 var(--eui-s-s) var(--eui-s-xs) var(--eui-s-s);margin-left:calc(-1 * var(--eui-s-s));min-height:var(--eui-s-4xl)}.eui-19 :host .eui-dashboard-card-content-header-start{display:flex;align-items:center;gap:var(--eui-s-s)}.eui-19 :host .eui-dashboard-card-content-header-end{display:flex;margin-left:auto;align-items:center}.eui-19 .eui-dashboard-card--stacked :host{border:none;padding-bottom:0}.eui-19 .eui-dashboard-card--stacked :host .eui-dashboard-card-content-header-start{display:flex;align-items:start;flex-direction:column;gap:var(--eui-s-xs)}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * Content container component for EuiDashboardCard.
 * Provides content projection and applies consistent styling.
 */
class EuiDashboardCardContentHeaderActionComponent {
    constructor() {
        /** CSS class applied to the host element */
        this.string = 'eui-dashboard-card-content-header-action';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentHeaderActionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiDashboardCardContentHeaderActionComponent, isStandalone: true, selector: "eui-dashboard-card-content-header-action", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content />', isInline: true, styles: [".eui-19 :host{display:flex;width:100%}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentHeaderActionComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-dashboard-card-content-header-action', template: '<ng-content />', styles: [".eui-19 :host{display:flex;width:100%}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * Content container component for EuiDashboardCard.
 * Provides content projection and applies consistent styling.
 */
class EuiDashboardCardContentHeaderIconComponent {
    constructor() {
        /** CSS class applied to the host element */
        this.string = 'eui-dashboard-card-content-header-icon';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentHeaderIconComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiDashboardCardContentHeaderIconComponent, isStandalone: true, selector: "eui-dashboard-card-content-header-icon", inputs: { icon: "icon" }, host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<eui-icon-svg [icon]="icon" size="s"/>', isInline: true, styles: [".eui-19 :host{--_bg-color: var(--eui-c-s-primary-surface-light);--_border-color: var(--eui-c-s-primary-border-light);--_icon-color: var(--eui-c-s-primary)}.eui-19 .eui-dashboard-card--primary :host{--_bg-color: var(--eui-c-s-primary-surface-light);--_border-color: var(--eui-c-s-primary-border-light);--_icon-color: var(--eui-c-s-primary)}.eui-19 .eui-dashboard-card--secondary :host{--_bg-color: var(--eui-c-s-secondary-surface-light);--_border-color: var(--eui-c-s-secondary-border-light);--_icon-color: var(--eui-c-s-secondary)}.eui-19 .eui-dashboard-card--info :host{--_bg-color: var(--eui-c-s-info-surface-light);--_border-color: var(--eui-c-s-info-border-light);--_icon-color: var(--eui-c-s-info)}.eui-19 .eui-dashboard-card--success :host{--_bg-color: var(--eui-c-s-success-surface-light);--_border-color: var(--eui-c-s-success-border-light);--_icon-color: var(--eui-c-s-success)}.eui-19 .eui-dashboard-card--warning :host{--_bg-color: var(--eui-c-s-warning-surface-light);--_border-color: var(--eui-c-s-warning-border-light);--_icon-color: var(--eui-c-s-warning)}.eui-19 .eui-dashboard-card--danger :host{--_bg-color: var(--eui-c-s-danger-surface-light);--_border-color: var(--eui-c-s-danger-border-light);--_icon-color: var(--eui-c-s-danger)}.eui-19 :host{display:inline-flex;padding:var(--eui-s-2xs);background-color:var(--_bg-color);border:1px solid var(--_border-color);border-radius:var(--eui-br-m)}.eui-19 :host ::ng-deep .eui-icon-svg svg{fill:var(--_icon-color);color:var(--_icon-color)}\n"], dependencies: [{ kind: "component", type: i1.EuiIconSvgComponent, selector: "eui-icon-svg, span[euiIconSvg], i[euiIconSvg]", inputs: ["icon", "fillColor", "set", "size", "style", "iconUrl", "transform", "euiVariant", "aria-label", "ariaHidden", "focusable", "isLoading", "isInputIcon", "euiStart", "euiEnd"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentHeaderIconComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-dashboard-card-content-header-icon', template: '<eui-icon-svg [icon]="icon" size="s"/>', imports: [
                        ...EUI_ICON,
                    ], styles: [".eui-19 :host{--_bg-color: var(--eui-c-s-primary-surface-light);--_border-color: var(--eui-c-s-primary-border-light);--_icon-color: var(--eui-c-s-primary)}.eui-19 .eui-dashboard-card--primary :host{--_bg-color: var(--eui-c-s-primary-surface-light);--_border-color: var(--eui-c-s-primary-border-light);--_icon-color: var(--eui-c-s-primary)}.eui-19 .eui-dashboard-card--secondary :host{--_bg-color: var(--eui-c-s-secondary-surface-light);--_border-color: var(--eui-c-s-secondary-border-light);--_icon-color: var(--eui-c-s-secondary)}.eui-19 .eui-dashboard-card--info :host{--_bg-color: var(--eui-c-s-info-surface-light);--_border-color: var(--eui-c-s-info-border-light);--_icon-color: var(--eui-c-s-info)}.eui-19 .eui-dashboard-card--success :host{--_bg-color: var(--eui-c-s-success-surface-light);--_border-color: var(--eui-c-s-success-border-light);--_icon-color: var(--eui-c-s-success)}.eui-19 .eui-dashboard-card--warning :host{--_bg-color: var(--eui-c-s-warning-surface-light);--_border-color: var(--eui-c-s-warning-border-light);--_icon-color: var(--eui-c-s-warning)}.eui-19 .eui-dashboard-card--danger :host{--_bg-color: var(--eui-c-s-danger-surface-light);--_border-color: var(--eui-c-s-danger-border-light);--_icon-color: var(--eui-c-s-danger)}.eui-19 :host{display:inline-flex;padding:var(--eui-s-2xs);background-color:var(--_bg-color);border:1px solid var(--_border-color);border-radius:var(--eui-br-m)}.eui-19 :host ::ng-deep .eui-icon-svg svg{fill:var(--_icon-color);color:var(--_icon-color)}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }], icon: [{
                type: Input
            }] } });

/**
 * @description
 * Content container component for EuiDashboardCard.
 * Provides content projection and applies consistent styling.
 */
class EuiDashboardCardContentHeaderTitleComponent {
    constructor() {
        /** CSS class applied to the host element */
        this.string = 'eui-dashboard-card-content-header-title';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentHeaderTitleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiDashboardCardContentHeaderTitleComponent, isStandalone: true, selector: "eui-dashboard-card-content-header-title", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content />', isInline: true, styles: [".eui-19 .eui-dashboard-card :host{display:flex;width:100%;font:var(--_content-title-font)}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardContentHeaderTitleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-dashboard-card-content-header-title', template: '<ng-content />', styles: [".eui-19 .eui-dashboard-card :host{display:flex;width:100%;font:var(--_content-title-font)}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * Status content container component for EuiDashboardCard.
 * Provides a dedicated area for displaying status information within a dashboard card.
 */
class EuiDashboardCardStatusContentComponent {
    constructor() {
        /** CSS class applied to the host element */
        this.string = 'eui-dashboard-card-status-content';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardStatusContentComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiDashboardCardStatusContentComponent, isStandalone: true, selector: "eui-dashboard-card-status-content", host: { properties: { "class": "this.string" } }, ngImport: i0, template: '<ng-content/>', isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardStatusContentComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'eui-dashboard-card-status-content',
                    template: '<ng-content/>',
                }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * Dashboard card component that can display content with various styling options,
 * including avatar/icon, labels, and clickable behavior.
 */
class EuiDashboardCardComponent {
    constructor() {
        /** Element attribute for e2e testing */
        this.e2eAttr = 'eui-dashboard-card';
        /**
         * Maximum number of lines for the primary label
         * @default 2
         */
        this.labelMaxLines = 2;
        /**
         * Maximum number of lines for the secondary label
         * @default 2
         */
        this.subLabelMaxLines = 2;
        /**
         * Size of the icon
         * @default 'm'
         */
        this.iconSvgSize = 'm';
        /** Target attribute for external URLs */
        this.urlExternalTarget = '_blank';
        /** Whether to display the card in horizontal layout */
        this.isHorizontal = false;
        /** Whether to display the avatar without elevation */
        this.isFlatAvatar = false;
        /** Whether to display the avatar without background */
        this.hasNoBackgroundAvatar = false;
        /** Whether the card is clickable */
        this.isClickeable = false;
        /** Whether to display the card without elevation */
        this.isFlat = false;
        /** Whether to display the card without elevation */
        this.isStacked = false;
        /** Event emitted when the card is clicked */
        this.cardClick = new EventEmitter();
        this.baseStatesDirective = inject(BaseStatesDirective);
    }
    /**
     * @description
     * Computes and returns the CSS classes for the dashboard card component based on its current state:
     * - Adds base dashboard card classes
     * - Adds horizontal layout class if isHorizontal is true
     * - Adds link class if the card is clickable or has a URL
     * - Adds flat class if isFlat is true
     *
     * @returns {string} Space-separated string of CSS class names
     */
    get cssClasses() {
        return [
            this.baseStatesDirective.getCssClasses('eui-dashboard-card'),
            this.isHorizontal ? 'eui-dashboard-card--horizontal' : '',
            this.url || this.urlExternal || this.isClickeable ? 'eui-dashboard-card--link' : '',
            this.isFlat ? 'eui-dashboard-card--flat' : '',
            this.isStacked ? 'eui-dashboard-card--stacked' : '',
        ]
            .join(' ')
            .trim();
    }
    /** Tab index for keyboard navigation */
    get tabindex() {
        if (!this.baseStatesDirective.euiDisabled) {
            if (this.url || this.urlExternal || this.isClickeable) {
                return '0';
            }
        }
        return '-1';
    }
    /** Handles card click events */
    onClick(event) {
        this.cardClick.emit(event);
    }
    /** Sets default size and variant if not provided */
    ngOnInit() {
        if (!this.baseStatesDirective.euiSizeVariant) {
            this.baseStatesDirective.euiSizeL = true;
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.12", type: EuiDashboardCardComponent, isStandalone: true, selector: "eui-dashboard-card", inputs: { e2eAttr: "e2eAttr", label: "label", subLabel: "subLabel", labelMaxLines: "labelMaxLines", subLabelMaxLines: "subLabelMaxLines", imageUrl: "imageUrl", iconSvgName: "iconSvgName", iconSvgSize: "iconSvgSize", iconLabel: "iconLabel", url: "url", urlExternal: "urlExternal", urlExternalTarget: "urlExternalTarget", isHorizontal: ["isHorizontal", "isHorizontal", booleanAttribute], isFlatAvatar: ["isFlatAvatar", "isFlatAvatar", booleanAttribute], hasNoBackgroundAvatar: ["hasNoBackgroundAvatar", "hasNoBackgroundAvatar", booleanAttribute], isClickeable: ["isClickeable", "isClickeable", booleanAttribute], isFlat: ["isFlat", "isFlat", booleanAttribute], isStacked: ["isStacked", "isStacked", booleanAttribute] }, outputs: { cardClick: "cardClick" }, host: { listeners: { "click": "onClick($event)" }, properties: { "class": "this.cssClasses", "attr.data-e2e": "this.e2eAttr", "attr.tabindex": "this.tabindex" } }, queries: [{ propertyName: "customContent", first: true, predicate: i0.forwardRef(() => EuiDashboardCardContentComponent), descendants: true }], hostDirectives: [{ directive: i1$1.BaseStatesDirective, inputs: ["euiPrimary", "euiPrimary", "euiSecondary", "euiSecondary", "euiSuccess", "euiSuccess", "euiInfo", "euiInfo", "euiWarning", "euiWarning", "euiDanger", "euiDanger", "euiAccent", "euiAccent", "euiVariant", "euiVariant", "euiSizeXS", "euiSizeXS", "euiSizeS", "euiSizeS", "euiSizeM", "euiSizeM", "euiSizeL", "euiSizeL", "euiSizeXL", "euiSizeXL", "euiSize2XL", "euiSize2XL", "euiSizeVariant", "euiSizeVariant", "euiDisabled", "euiDisabled", "euiOutline", "euiOutline"] }], ngImport: i0, template: "@if (url || urlExternal) {\n    @if (urlExternal) {\n        <a href=\"{{ urlExternal }}\" target=\"{{ urlExternalTarget }}\" class=\"eui-dashboard-card__anchor-wrapper\">\n            <ng-container *ngTemplateOutlet=\"content\"></ng-container>\n        </a>\n    } @else {\n       <a [routerLink]=\"[url]\" class=\"eui-dashboard-card__anchor-wrapper\">\n            <ng-container *ngTemplateOutlet=\"content\"></ng-container>\n       </a>\n    }\n} @else {\n    @if (customContent) {\n        <ng-content select=\"eui-dashboard-card-content\"/>\n    } @else {\n        <ng-container *ngTemplateOutlet=\"content\" />\n    }\n}\n\n<div class=\"eui-dashboard-card__status\">\n    <ng-content select=\"eui-dashboard-card-status-content\"/>\n</div>\n\n<ng-template #content>\n    @if (iconSvgName || imageUrl || iconLabel) {\n        <div class=\"eui-dashboard-card__avatar-wrapper\">\n            <eui-avatar\n                isFlat\n                [euiVariant]=\"baseStatesDirective.euiVariant\"\n                [euiSizeVariant]=\"baseStatesDirective.euiSizeVariant\"\n                [hasNoBackground]=\"hasNoBackgroundAvatar\">\n                <eui-avatar-icon>\n                    @if (iconSvgName) {\n                        <eui-icon-svg [icon]=\"iconSvgName\" [size]=\"iconSvgSize\"></eui-icon-svg>\n                    }\n                </eui-avatar-icon>\n                @if (imageUrl) {\n                    <eui-avatar-image imageUrl=\"{{ imageUrl }}\"></eui-avatar-image>\n                }\n                @if (iconLabel) {\n                    <eui-avatar-text>{{iconLabel}}</eui-avatar-text>\n                }\n            </eui-avatar>\n        </div>\n    }\n    <div class=\"eui-dashboard-card__content-wrapper\">\n        @if (label) {\n            <div class=\"eui-dashboard-card__label-content\">\n                <eui-label>\n                    <eui-label class=\"eui-dashboard-card__label eui-dashboard-card__label--max-lines-{{labelMaxLines}}\" [ngClass]=\"subLabel ? 'eui-dashboard-card__label--with-sublabel' : ''\">\n                        {{ label }}\n                    </eui-label>\n                    @if (subLabel) {\n                        <eui-label euiSublabel class=\"eui-dashboard-card__sublabel eui-dashboard-card__sublabel--max-lines-{{subLabelMaxLines}}\">\n                            {{ subLabel }}\n                        </eui-label>\n                    }\n                </eui-label>\n            </div>\n        }\n        <div class=\"eui-dashboard-card__sub-content\">\n            <ng-content></ng-content>\n        </div>\n    </div>\n</ng-template>\n", styles: [".eui-19.eui-t-ds2025 :host.eui-dashboard-card{--_content-title-font: var(--eui-f-card-title-m-medium)}.eui-19 :host.eui-dashboard-card{--_content-title-font: var(--eui-f-l)}.eui-19 :host.eui-dashboard-card{display:flex;flex-direction:column;width:100%;background-color:var(--eui-c-white);border-radius:var(--eui-br-l);border:var(--eui-bw-xs) solid var(--eui-c-divider);box-shadow:var(--eui-sh-card);padding:var(--eui-s-s);cursor:default;position:relative}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__anchor-wrapper{display:flex;width:100%;flex-direction:column}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__avatar-wrapper{padding:0 var(--eui-s-4xl)}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__avatar-wrapper,.eui-19 :host.eui-dashboard-card .eui-dashboard-card__content-wrapper{display:flex;justify-content:center;align-items:center}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__content-wrapper{display:flex;flex-direction:column;padding:var(--eui-s-s);width:100%}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content{text-align:center}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label{font:var(--eui-f-l);color:var(--eui-c-text);margin-bottom:var(--eui-s-m);display:-webkit-box;-webkit-box-orient:vertical;overflow:hidden}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--with-sublabel{margin-bottom:0}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-1{-webkit-line-clamp:1}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-2{-webkit-line-clamp:2}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-3{-webkit-line-clamp:3}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-4{-webkit-line-clamp:4}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-5{-webkit-line-clamp:5}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel{font:var(--eui-f-m);margin-bottom:var(--eui-s-m);display:-webkit-box;-webkit-box-orient:vertical;overflow:hidden}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-1{-webkit-line-clamp:1}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-2{-webkit-line-clamp:2}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-3{-webkit-line-clamp:3}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-4{-webkit-line-clamp:4}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-5{-webkit-line-clamp:5}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__sub-content{display:block;text-align:center}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__sub-content:empty{margin-top:calc(-1 * var(--eui-s-m))}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__status{position:absolute;top:-.75rem;right:var(--eui-s-m)}.eui-19 :host.eui-dashboard-card--link:not(.eui-dashboard-card--disabled){cursor:pointer}.eui-19 :host.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 :host.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):active,.eui-19 :host.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):hover{box-shadow:var(--eui-sh-3)}.eui-19 :host.eui-dashboard-card--horizontal,.eui-19 :host.eui-dashboard-card--horizontal .eui-dasbhard-card__anchor-wrapper{flex-direction:row}.eui-19 :host.eui-dashboard-card--horizontal .eui-dasbhard-card__avatar-wrapper,.eui-19 :host.eui-dashboard-card--horizontal .eui-dasbhard-card__content-wrapper{width:50%}.eui-19 :host.eui-dashboard-card--horizontal .eui-dasbhard-card__avatar-wrapper{border-right:1px solid var(--eui-c-divider);margin-right:var(--eui-s-m);padding:var(--eui-s-s) 0}.eui-19 :host.eui-dashboard-card--disabled{opacity:.65;pointer-events:none}.eui-19 :host.eui-dashboard-card--flat{box-shadow:none;border-color:var(--eui-c-divider)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):active,.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):hover{box-shadow:var(--eui-sh-2)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline{background-color:var(--eui-c-white)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--primary{border-color:var(--eui-c-s-primary-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--info{border-color:var(--eui-c-s-info-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--success{border-color:var(--eui-c-s-success-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--warning{border-color:var(--eui-c-s-warning-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--danger{border-color:var(--eui-c-s-danger-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--accent{border-color:var(--eui-c-s-accent-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--primary:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-primary-surface-light)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--success:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-success-surface-light)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--warning:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-warning-surface-light)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--danger:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-danger-surface-light)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--accent:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-accent-surface-light)}\n"], dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "ngmodule", type: RouterModule }, { kind: "directive", type: i2.RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "info", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i3.EuiAvatarComponent, selector: "div[euiAvatar], span[euiAvatar], eui-avatar", inputs: ["e2eAttr", "aria-label", "hasShadow", "isShapeSquare", "isFlat", "hasNoBackground", "isReverse"] }, { kind: "component", type: i3.EuiAvatarIconComponent, selector: "eui-avatar-icon" }, { kind: "component", type: i3.EuiAvatarTextComponent, selector: "eui-avatar-text" }, { kind: "component", type: i3.EuiAvatarImageComponent, selector: "eui-avatar-image", inputs: ["imageUrl"] }, { kind: "component", type: i4.EuiLabelComponent, selector: "label[euiLabel], span[euiLabel], div[euiLabel], a[euiLabel], eui-label,               label[euiSublabel], span[euiSublabel], div[euiSublabel], a[euiSublabel], eui-sublabel", inputs: ["euiRequired", "euiReadonly", "euiSublabel"] }, { kind: "component", type: i1.EuiIconSvgComponent, selector: "eui-icon-svg, span[euiIconSvg], i[euiIconSvg]", inputs: ["icon", "fillColor", "set", "size", "style", "iconUrl", "transform", "euiVariant", "aria-label", "ariaHidden", "focusable", "isLoading", "isInputIcon", "euiStart", "euiEnd"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-dashboard-card', changeDetection: ChangeDetectionStrategy.OnPush, imports: [
                        NgClass,
                        RouterModule,
                        NgTemplateOutlet,
                        ...EUI_AVATAR,
                        ...EUI_LABEL,
                        ...EUI_ICON,
                    ], hostDirectives: [
                        {
                            directive: BaseStatesDirective,
                            inputs: [
                                'euiPrimary',
                                'euiSecondary',
                                'euiSuccess',
                                'euiInfo',
                                'euiWarning',
                                'euiDanger',
                                'euiAccent',
                                'euiVariant',
                                'euiSizeXS',
                                'euiSizeS',
                                'euiSizeM',
                                'euiSizeL',
                                'euiSizeXL',
                                'euiSize2XL',
                                'euiSizeVariant',
                                'euiDisabled',
                                'euiOutline',
                            ],
                        },
                    ], template: "@if (url || urlExternal) {\n    @if (urlExternal) {\n        <a href=\"{{ urlExternal }}\" target=\"{{ urlExternalTarget }}\" class=\"eui-dashboard-card__anchor-wrapper\">\n            <ng-container *ngTemplateOutlet=\"content\"></ng-container>\n        </a>\n    } @else {\n       <a [routerLink]=\"[url]\" class=\"eui-dashboard-card__anchor-wrapper\">\n            <ng-container *ngTemplateOutlet=\"content\"></ng-container>\n       </a>\n    }\n} @else {\n    @if (customContent) {\n        <ng-content select=\"eui-dashboard-card-content\"/>\n    } @else {\n        <ng-container *ngTemplateOutlet=\"content\" />\n    }\n}\n\n<div class=\"eui-dashboard-card__status\">\n    <ng-content select=\"eui-dashboard-card-status-content\"/>\n</div>\n\n<ng-template #content>\n    @if (iconSvgName || imageUrl || iconLabel) {\n        <div class=\"eui-dashboard-card__avatar-wrapper\">\n            <eui-avatar\n                isFlat\n                [euiVariant]=\"baseStatesDirective.euiVariant\"\n                [euiSizeVariant]=\"baseStatesDirective.euiSizeVariant\"\n                [hasNoBackground]=\"hasNoBackgroundAvatar\">\n                <eui-avatar-icon>\n                    @if (iconSvgName) {\n                        <eui-icon-svg [icon]=\"iconSvgName\" [size]=\"iconSvgSize\"></eui-icon-svg>\n                    }\n                </eui-avatar-icon>\n                @if (imageUrl) {\n                    <eui-avatar-image imageUrl=\"{{ imageUrl }}\"></eui-avatar-image>\n                }\n                @if (iconLabel) {\n                    <eui-avatar-text>{{iconLabel}}</eui-avatar-text>\n                }\n            </eui-avatar>\n        </div>\n    }\n    <div class=\"eui-dashboard-card__content-wrapper\">\n        @if (label) {\n            <div class=\"eui-dashboard-card__label-content\">\n                <eui-label>\n                    <eui-label class=\"eui-dashboard-card__label eui-dashboard-card__label--max-lines-{{labelMaxLines}}\" [ngClass]=\"subLabel ? 'eui-dashboard-card__label--with-sublabel' : ''\">\n                        {{ label }}\n                    </eui-label>\n                    @if (subLabel) {\n                        <eui-label euiSublabel class=\"eui-dashboard-card__sublabel eui-dashboard-card__sublabel--max-lines-{{subLabelMaxLines}}\">\n                            {{ subLabel }}\n                        </eui-label>\n                    }\n                </eui-label>\n            </div>\n        }\n        <div class=\"eui-dashboard-card__sub-content\">\n            <ng-content></ng-content>\n        </div>\n    </div>\n</ng-template>\n", styles: [".eui-19.eui-t-ds2025 :host.eui-dashboard-card{--_content-title-font: var(--eui-f-card-title-m-medium)}.eui-19 :host.eui-dashboard-card{--_content-title-font: var(--eui-f-l)}.eui-19 :host.eui-dashboard-card{display:flex;flex-direction:column;width:100%;background-color:var(--eui-c-white);border-radius:var(--eui-br-l);border:var(--eui-bw-xs) solid var(--eui-c-divider);box-shadow:var(--eui-sh-card);padding:var(--eui-s-s);cursor:default;position:relative}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__anchor-wrapper{display:flex;width:100%;flex-direction:column}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__avatar-wrapper{padding:0 var(--eui-s-4xl)}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__avatar-wrapper,.eui-19 :host.eui-dashboard-card .eui-dashboard-card__content-wrapper{display:flex;justify-content:center;align-items:center}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__content-wrapper{display:flex;flex-direction:column;padding:var(--eui-s-s);width:100%}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content{text-align:center}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label{font:var(--eui-f-l);color:var(--eui-c-text);margin-bottom:var(--eui-s-m);display:-webkit-box;-webkit-box-orient:vertical;overflow:hidden}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--with-sublabel{margin-bottom:0}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-1{-webkit-line-clamp:1}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-2{-webkit-line-clamp:2}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-3{-webkit-line-clamp:3}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-4{-webkit-line-clamp:4}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__label--max-lines-5{-webkit-line-clamp:5}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel{font:var(--eui-f-m);margin-bottom:var(--eui-s-m);display:-webkit-box;-webkit-box-orient:vertical;overflow:hidden}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-1{-webkit-line-clamp:1}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-2{-webkit-line-clamp:2}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-3{-webkit-line-clamp:3}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-4{-webkit-line-clamp:4}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__label-content .eui-dashboard-card__sublabel--max-lines-5{-webkit-line-clamp:5}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__sub-content{display:block;text-align:center}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__sub-content:empty{margin-top:calc(-1 * var(--eui-s-m))}.eui-19 :host.eui-dashboard-card .eui-dashboard-card__status{position:absolute;top:-.75rem;right:var(--eui-s-m)}.eui-19 :host.eui-dashboard-card--link:not(.eui-dashboard-card--disabled){cursor:pointer}.eui-19 :host.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 :host.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):active,.eui-19 :host.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):hover{box-shadow:var(--eui-sh-3)}.eui-19 :host.eui-dashboard-card--horizontal,.eui-19 :host.eui-dashboard-card--horizontal .eui-dasbhard-card__anchor-wrapper{flex-direction:row}.eui-19 :host.eui-dashboard-card--horizontal .eui-dasbhard-card__avatar-wrapper,.eui-19 :host.eui-dashboard-card--horizontal .eui-dasbhard-card__content-wrapper{width:50%}.eui-19 :host.eui-dashboard-card--horizontal .eui-dasbhard-card__avatar-wrapper{border-right:1px solid var(--eui-c-divider);margin-right:var(--eui-s-m);padding:var(--eui-s-s) 0}.eui-19 :host.eui-dashboard-card--disabled{opacity:.65;pointer-events:none}.eui-19 :host.eui-dashboard-card--flat{box-shadow:none;border-color:var(--eui-c-divider)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):active,.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--link:not(.eui-dashboard-card--disabled):hover{box-shadow:var(--eui-sh-2)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline{background-color:var(--eui-c-white)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--primary{border-color:var(--eui-c-s-primary-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--info{border-color:var(--eui-c-s-info-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--success{border-color:var(--eui-c-s-success-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--warning{border-color:var(--eui-c-s-warning-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--danger{border-color:var(--eui-c-s-danger-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--outline.eui-dashboard-card--accent{border-color:var(--eui-c-s-accent-border)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--primary:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-primary-surface-light)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--success:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-success-surface-light)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--warning:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-warning-surface-light)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--danger:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-danger-surface-light)}.eui-19 :host.eui-dashboard-card--flat.eui-dashboard-card--accent:not(.eui-dashboard-card--outline){background-color:var(--eui-c-s-accent-surface-light)}\n"] }]
        }], propDecorators: { cssClasses: [{
                type: HostBinding,
                args: ['class']
            }], e2eAttr: [{
                type: HostBinding,
                args: ['attr.data-e2e']
            }, {
                type: Input
            }], label: [{
                type: Input
            }], subLabel: [{
                type: Input
            }], labelMaxLines: [{
                type: Input
            }], subLabelMaxLines: [{
                type: Input
            }], imageUrl: [{
                type: Input
            }], iconSvgName: [{
                type: Input
            }], iconSvgSize: [{
                type: Input
            }], iconLabel: [{
                type: Input
            }], url: [{
                type: Input
            }], urlExternal: [{
                type: Input
            }], urlExternalTarget: [{
                type: Input
            }], tabindex: [{
                type: HostBinding,
                args: ['attr.tabindex']
            }], isHorizontal: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], isFlatAvatar: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasNoBackgroundAvatar: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], isClickeable: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], isFlat: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], isStacked: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], cardClick: [{
                type: Output
            }], customContent: [{
                type: ContentChild,
                args: [forwardRef(() => EuiDashboardCardContentComponent)]
            }], onClick: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });
/**
 * @deprecated Import the standalone {@link EUI_DASHBOARD_CARD} instead.
 * This module is maintained for backward compatibility.
 */
class EuiDashboardCardModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardModule, imports: [EuiDashboardCardComponent, EuiDashboardCardContentComponent,
            EuiDashboardCardContentHeaderComponent,
            EuiDashboardCardContentHeaderIconComponent,
            EuiDashboardCardContentHeaderTitleComponent,
            EuiDashboardCardContentHeaderActionComponent,
            EuiDashboardCardContentBodyComponent,
            EuiDashboardCardStatusContentComponent], exports: [EuiDashboardCardComponent, EuiDashboardCardContentComponent,
            EuiDashboardCardContentHeaderComponent,
            EuiDashboardCardContentHeaderIconComponent,
            EuiDashboardCardContentHeaderTitleComponent,
            EuiDashboardCardContentHeaderActionComponent,
            EuiDashboardCardContentBodyComponent,
            EuiDashboardCardStatusContentComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardModule, imports: [EuiDashboardCardComponent,
            EuiDashboardCardContentHeaderIconComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiDashboardCardModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        EuiDashboardCardComponent,
                        EuiDashboardCardContentComponent,
                        EuiDashboardCardContentHeaderComponent,
                        EuiDashboardCardContentHeaderIconComponent,
                        EuiDashboardCardContentHeaderTitleComponent,
                        EuiDashboardCardContentHeaderActionComponent,
                        EuiDashboardCardContentBodyComponent,
                        EuiDashboardCardStatusContentComponent,
                    ],
                    exports: [
                        EuiDashboardCardComponent,
                        EuiDashboardCardContentComponent,
                        EuiDashboardCardContentHeaderComponent,
                        EuiDashboardCardContentHeaderIconComponent,
                        EuiDashboardCardContentHeaderTitleComponent,
                        EuiDashboardCardContentHeaderActionComponent,
                        EuiDashboardCardContentBodyComponent,
                        EuiDashboardCardStatusContentComponent,
                    ],
                }]
        }] });

const EUI_DASHBOARD_CARD = [
    EuiDashboardCardComponent,
    EuiDashboardCardContentComponent,
    EuiDashboardCardContentHeaderComponent,
    EuiDashboardCardContentHeaderIconComponent,
    EuiDashboardCardContentHeaderTitleComponent,
    EuiDashboardCardContentHeaderActionComponent,
    EuiDashboardCardContentBodyComponent,
    EuiDashboardCardContentFooterComponent,
    EuiDashboardCardStatusContentComponent,
];

/**
 * Generated bundle index. Do not edit.
 */

export { EUI_DASHBOARD_CARD, EuiDashboardCardComponent, EuiDashboardCardContentBodyComponent, EuiDashboardCardContentComponent, EuiDashboardCardContentFooterComponent, EuiDashboardCardContentHeaderActionComponent, EuiDashboardCardContentHeaderComponent, EuiDashboardCardContentHeaderIconComponent, EuiDashboardCardContentHeaderTitleComponent, EuiDashboardCardModule, EuiDashboardCardStatusContentComponent };
//# sourceMappingURL=eui-components-eui-dashboard-card.mjs.map
