import * as i0 from '@angular/core';
import { EventEmitter, booleanAttribute, Output, Input, HostBinding, ViewEncapsulation, ChangeDetectionStrategy, Component, NgModule } from '@angular/core';
import * as i1 from '@eui/components/eui-menu';
import { EUI_MENU } from '@eui/components/eui-menu';

class EuiSidebarMenuComponent {
    constructor() {
        this.string = 'eui-sidebar-menu';
        this.items = [];
        this.hasCollapsedInitials = false;
        this.isCollapsed = false;
        this.hasFilter = false;
        this.hasIcons = false;
        this.hasTooltip = true;
        this.hasTooltipOnExpanded = false;
        this.expandAllItems = false;
        this.hasBoldRootLevel = false;
        this.style = '';
        this.filterValue = '';
        this.menuClick = new EventEmitter();
        this.itemClick = new EventEmitter();
    }
    onMenuItemClicked(item) {
        this.itemClick.emit(item);
    }
    onMenuClicked(event) {
        this.menuClick.emit(event);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSidebarMenuComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "16.1.0", version: "19.2.12", type: EuiSidebarMenuComponent, isStandalone: true, selector: "eui-sidebar-menu", inputs: { items: "items", hasCollapsedInitials: ["hasCollapsedInitials", "hasCollapsedInitials", booleanAttribute], isCollapsed: ["isCollapsed", "isCollapsed", booleanAttribute], hasFilter: ["hasFilter", "hasFilter", booleanAttribute], hasIcons: ["hasIcons", "hasIcons", booleanAttribute], hasTooltip: ["hasTooltip", "hasTooltip", booleanAttribute], hasTooltipOnExpanded: ["hasTooltipOnExpanded", "hasTooltipOnExpanded", booleanAttribute], expandAllItems: ["expandAllItems", "expandAllItems", booleanAttribute], hasBoldRootLevel: ["hasBoldRootLevel", "hasBoldRootLevel", booleanAttribute], style: "style", fragmentId: "fragmentId", searchFilterLabel: "searchFilterLabel", externalTarget: "externalTarget", filterValue: "filterValue" }, outputs: { menuClick: "menuClick", itemClick: "itemClick" }, host: { properties: { "class": "this.string" } }, ngImport: i0, template: "<!--TODO: set the classes into one div container instead of two-->\n<div class=\"eui-sidebar-menu__container\" [class.eui-sidebar-menu__container--collapsed]=\"isCollapsed\" [style]=\"style\">\n    <div class=\"eui-sidebar-menu__content\">\n        <eui-menu\n            [items]=\"items\"\n            [hasFilter]=\"hasFilter\"\n            [hasIcons]=\"hasIcons\"\n            [hasTooltip]=\"hasTooltip\"\n            [hasTooltipOnExpanded]=\"hasTooltipOnExpanded\"\n            [isCollapsed]=\"isCollapsed\"\n            [hasCollapsedInitials]=\"hasCollapsedInitials\"\n            [expandAllItems]=\"expandAllItems\"\n            [fragmentId]=\"fragmentId\"\n            [searchFilterLabel]=\"searchFilterLabel\"\n            [filterValue]=\"filterValue\"\n            [hasBoldRootLevel]=\"hasBoldRootLevel\"\n            (isClick)=\"onMenuClicked($event)\"\n            (itemClick)=\"onMenuItemClicked($event)\">\n        </eui-menu>\n    </div>\n</div>\n", styles: [".eui-19 .eui-sidebar-menu{display:flex;height:100%;width:100%}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container{background-color:var(--eui-c-bg);height:100%;width:100%}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container::-webkit-scrollbar{display:inherit;height:8px;width:8px;background-color:var(--eui-c-neutral-bg-light)}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container::-webkit-scrollbar-thumb{background-color:var(--_eui-scrollbars-foreground-color);border-radius:5rem}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container::-webkit-scrollbar-thumb:hover{background-color:var(--eui-c-neutral-lighter)}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container::-webkit-scrollbar-track{background-color:var(--eui-c-neutral-bg-light);border-radius:0}@-moz-document url-prefix(){.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container{scrollbar-color:var(--eui-c-neutral-lighter) var(--eui-c-neutral-bg-light);scrollbar-width:auto}}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container .eui-sidebar-menu__content{display:flex;flex-direction:column;height:100%;position:relative}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container--collapsed{position:relative;width:var(--eui-app-sidebar-width-close-active)}\n"], dependencies: [{ kind: "component", type: i1.EuiMenuComponent, selector: "eui-menu", inputs: ["items", "searchFilterLabel", "externalLinkLabel", "fragmentId", "filterValue", "isCollapsed", "hasCollapsedInitials", "hasFilter", "hasIcons", "hasTooltip", "hasTooltipOnExpanded", "expandAllItems", "isFlat", "hasScrollToItem", "hasBoldRootLevel"], outputs: ["isClick", "itemClick", "expandToggle"] }], changeDetection: i0.ChangeDetectionStrategy.Default, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSidebarMenuComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-sidebar-menu', changeDetection: ChangeDetectionStrategy.Default, encapsulation: ViewEncapsulation.None, imports: [
                        ...EUI_MENU,
                    ], template: "<!--TODO: set the classes into one div container instead of two-->\n<div class=\"eui-sidebar-menu__container\" [class.eui-sidebar-menu__container--collapsed]=\"isCollapsed\" [style]=\"style\">\n    <div class=\"eui-sidebar-menu__content\">\n        <eui-menu\n            [items]=\"items\"\n            [hasFilter]=\"hasFilter\"\n            [hasIcons]=\"hasIcons\"\n            [hasTooltip]=\"hasTooltip\"\n            [hasTooltipOnExpanded]=\"hasTooltipOnExpanded\"\n            [isCollapsed]=\"isCollapsed\"\n            [hasCollapsedInitials]=\"hasCollapsedInitials\"\n            [expandAllItems]=\"expandAllItems\"\n            [fragmentId]=\"fragmentId\"\n            [searchFilterLabel]=\"searchFilterLabel\"\n            [filterValue]=\"filterValue\"\n            [hasBoldRootLevel]=\"hasBoldRootLevel\"\n            (isClick)=\"onMenuClicked($event)\"\n            (itemClick)=\"onMenuItemClicked($event)\">\n        </eui-menu>\n    </div>\n</div>\n", styles: [".eui-19 .eui-sidebar-menu{display:flex;height:100%;width:100%}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container{background-color:var(--eui-c-bg);height:100%;width:100%}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container::-webkit-scrollbar{display:inherit;height:8px;width:8px;background-color:var(--eui-c-neutral-bg-light)}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container::-webkit-scrollbar-thumb{background-color:var(--_eui-scrollbars-foreground-color);border-radius:5rem}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container::-webkit-scrollbar-thumb:hover{background-color:var(--eui-c-neutral-lighter)}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container::-webkit-scrollbar-track{background-color:var(--eui-c-neutral-bg-light);border-radius:0}@-moz-document url-prefix(){.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container{scrollbar-color:var(--eui-c-neutral-lighter) var(--eui-c-neutral-bg-light);scrollbar-width:auto}}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container .eui-sidebar-menu__content{display:flex;flex-direction:column;height:100%;position:relative}.eui-19 .eui-sidebar-menu .eui-sidebar-menu__container--collapsed{position:relative;width:var(--eui-app-sidebar-width-close-active)}\n"] }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }], items: [{
                type: Input
            }], hasCollapsedInitials: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], isCollapsed: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasFilter: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasIcons: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasTooltip: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasTooltipOnExpanded: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], expandAllItems: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasBoldRootLevel: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], style: [{
                type: Input
            }], fragmentId: [{
                type: Input
            }], searchFilterLabel: [{
                type: Input
            }], externalTarget: [{
                type: Input
            }], filterValue: [{
                type: Input
            }], menuClick: [{
                type: Output
            }], itemClick: [{
                type: Output
            }] } });

/**
 * @deprecated Use `EUI_SIDEBAR_MENU` instead. It will be removed in EUI 21.
 */
class EuiSidebarMenuModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSidebarMenuModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.12", ngImport: i0, type: EuiSidebarMenuModule, imports: [EuiSidebarMenuComponent], exports: [EuiSidebarMenuComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSidebarMenuModule, imports: [EuiSidebarMenuComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSidebarMenuModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [EuiSidebarMenuComponent],
                    exports: [EuiSidebarMenuComponent],
                }]
        }] });

const EUI_SIDEBAR_MENU = [
    EuiSidebarMenuComponent,
];
// export { EuiSidebarMenuComponent as EuiSidebarMenu } from './eui-sidebar-menu.component';

/**
 * Generated bundle index. Do not edit.
 */

export { EUI_SIDEBAR_MENU, EuiSidebarMenuComponent, EuiSidebarMenuModule };
//# sourceMappingURL=eui-components-eui-sidebar-menu.mjs.map
