import * as i0 from '@angular/core';
import { HostBinding, ChangeDetectionStrategy, Component, NgModule } from '@angular/core';

/**
 * @description
 * The EuiSplitButtonComponent is a wrapper for a button and a dropdown.
 * It is used to create a split button with various styles and functionalities.
 *
 */
class EuiSplitButtonComponent {
    get cssClasses() {
        return 'eui-split-button';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSplitButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiSplitButtonComponent, isStandalone: true, selector: "eui-split-button", host: { properties: { "class": "this.cssClasses" } }, ngImport: i0, template: "<ng-content select=\"button\" />\n<ng-content select=\"eui-dropdown\" />\n", styles: [".eui-19 :host.eui-split-button{align-items:center;display:inline-flex;position:relative}.eui-19 :host.eui-split-button ::ng-deep button{border-radius:var(--eui-br-m) 0 0 var(--eui-br-m);cursor:pointer}.eui-19 :host.eui-split-button ::ng-deep button:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-19 :host.eui-split-button ::ng-deep button:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 :host.eui-split-button ::ng-deep button [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 :host.eui-split-button ::ng-deep .eui-dropdown:before{content:\"\";position:absolute;border:1px solid var(--eui-c-divider);top:25%;height:50%;margin-left:-1px}.eui-19 :host.eui-split-button ::ng-deep .eui-dropdown button{border-radius:0 var(--eui-br-m) var(--eui-br-m) 0;border-left:0;width:var(--eui-s-4xl);margin-left:-1px}.eui-19 :host.eui-split-button--disabled,.eui-19 :host.eui-split-button:disabled{pointer-events:none}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSplitButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-split-button', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-content select=\"button\" />\n<ng-content select=\"eui-dropdown\" />\n", styles: [".eui-19 :host.eui-split-button{align-items:center;display:inline-flex;position:relative}.eui-19 :host.eui-split-button ::ng-deep button{border-radius:var(--eui-br-m) 0 0 var(--eui-br-m);cursor:pointer}.eui-19 :host.eui-split-button ::ng-deep button:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-19 :host.eui-split-button ::ng-deep button:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 :host.eui-split-button ::ng-deep button [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-19 :host.eui-split-button ::ng-deep .eui-dropdown:before{content:\"\";position:absolute;border:1px solid var(--eui-c-divider);top:25%;height:50%;margin-left:-1px}.eui-19 :host.eui-split-button ::ng-deep .eui-dropdown button{border-radius:0 var(--eui-br-m) var(--eui-br-m) 0;border-left:0;width:var(--eui-s-4xl);margin-left:-1px}.eui-19 :host.eui-split-button--disabled,.eui-19 :host.eui-split-button:disabled{pointer-events:none}\n"] }]
        }], propDecorators: { cssClasses: [{
                type: HostBinding,
                args: ['class']
            }] } });

/**
 * @description
 * This module provides the EuiSplitButtonComponent which is used to create
 * split buttons with various styles and functionalities.
 *
 * @deprecated Use {@link EUI_SPLIT_BUTTON} instead.
 */
class EuiSplitButtonModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSplitButtonModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.12", ngImport: i0, type: EuiSplitButtonModule, imports: [EuiSplitButtonComponent], exports: [EuiSplitButtonComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSplitButtonModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiSplitButtonModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [EuiSplitButtonComponent],
                    exports: [EuiSplitButtonComponent],
                }]
        }] });

const EUI_SPLIT_BUTTON = [
    EuiSplitButtonComponent,
];
// export { EuiSplitButtonComponent as EuiSplitButton } from './eui-split-button.component';

/**
 * Generated bundle index. Do not edit.
 */

export { EUI_SPLIT_BUTTON, EuiSplitButtonComponent, EuiSplitButtonModule };
//# sourceMappingURL=eui-components-eui-split-button.mjs.map
