import * as i0 from '@angular/core';
import { inject, Component, booleanAttribute, Input, ChangeDetectionStrategy, ViewEncapsulation, HostBinding, ElementRef, EventEmitter, ChangeDetectorRef, HostListener, forwardRef, ContentChild, Output, Directive, Pipe, Renderer2, NgModule } from '@angular/core';
import * as i1$1 from '@angular/forms';
import { FormGroup, FormControl, Validators, ReactiveFormsModule, NgControl, FormsModule } from '@angular/forms';
import * as i1 from '@eui/components/externals/quill';
import { LoaderService, QuillModule } from '@eui/components/externals/quill';
export * from '@eui/components/externals/quill';
import * as i3 from '@ngx-translate/core';
import { TranslateModule } from '@ngx-translate/core';
import { coerceBooleanProperty, coerceNumberProperty } from '@angular/cdk/coercion';
import { takeUntil, startWith } from 'rxjs/operators';
import { Subject } from 'rxjs';
import Delta from 'quill-delta';
import { DIALOG_COMPONENT_CONFIG, EuiDialogService, EuiDialogConfig, EuiDialogModule } from '@eui/components/eui-dialog';
import { EuiInputTextComponent, EuiInputTextModule } from '@eui/components/eui-input-text';
import { NgClass, NgStyle, CommonModule } from '@angular/common';
import { EuiTooltipDirective, EuiTooltipDirectiveModule } from '@eui/components/directives';
import * as i4 from '@eui/components/eui-icon';
import { EUI_ICON, EuiIconModule } from '@eui/components/eui-icon';
import { DomSanitizer } from '@angular/platform-browser';

const urlValidator = (control) => {
    const isHttp = control.value.substr(0, 7) === 'http://';
    const isHttps = control.value.substr(0, 8) === 'https://';
    return !isHttp && !isHttps ? { isUrlValid: false } : null;
};
class EuiEditorImageDialogComponent {
    constructor() {
        this.destroy$ = new Subject();
        this.config = inject(DIALOG_COMPONENT_CONFIG);
    }
    ngOnInit() {
        this.form = new FormGroup({
            url: new FormControl('', [Validators.required, urlValidator]),
        });
        this.form.valueChanges.pipe(takeUntil(this.destroy$)).subscribe(() => {
            this.config.onFormValueChange(this.form);
        });
    }
    ngOnDestroy() {
        this.destroy$.next(true);
        this.destroy$.unsubscribe();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorImageDialogComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiEditorImageDialogComponent, isStandalone: true, selector: "ng-component", ngImport: i0, template: "<form [formGroup]=\"form\">\n    <input euiInputText formControlName=\"url\" />\n</form>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i1$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1$1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "directive", type: i1$1.FormControlName, selector: "[formControlName]", inputs: ["formControlName", "disabled", "ngModel"], outputs: ["ngModelChange"] }, { kind: "component", type: EuiInputTextComponent, selector: "input[euiInputText]", inputs: ["isInvalid"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorImageDialogComponent, decorators: [{
            type: Component,
            args: [{ imports: [
                        ReactiveFormsModule,
                        EuiInputTextComponent,
                    ], template: "<form [formGroup]=\"form\">\n    <input euiInputText formControlName=\"url\" />\n</form>\n" }]
        }] });

class EuiEditorCountersComponent {
    constructor() {
        this.charactersLabel = 'characters';
        this.wordsLabel = 'words';
        this.isMaxLengthValid = true;
        this.hasCharactersCounter = true;
        this.hasWordsCounter = true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorCountersComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.12", type: EuiEditorCountersComponent, isStandalone: true, selector: "eui-editor-counters", inputs: { charactersCounter: "charactersCounter", charactersLabel: "charactersLabel", wordsCounter: "wordsCounter", wordsLabel: "wordsLabel", isMaxLengthValid: ["isMaxLengthValid", "isMaxLengthValid", booleanAttribute], hasCharactersCounter: ["hasCharactersCounter", "hasCharactersCounter", booleanAttribute], hasWordsCounter: ["hasWordsCounter", "hasWordsCounter", booleanAttribute] }, ngImport: i0, template: "<button class=\"editor-counters\">\n    @if ( hasCharactersCounter ) {\n    <div class=\"editor-counters-chars-container\">\n        <span class=\"chars-counter\" [class.chars-counter--error]=\"!isMaxLengthValid\">{{ charactersCounter }}</span>\n        <span class=\"chars-label\">{{ charactersLabel }}</span>\n    </div>\n    }\n    @if ( hasWordsCounter ) {\n    <div class=\"editor-counters-words-container\">\n        <span class=\"words-counter\">{{ wordsCounter }}</span>\n        <span class=\"words-label\">{{ wordsLabel }}</span>\n    </div>\n    }\n</button>\n", changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorCountersComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-editor-counters', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, template: "<button class=\"editor-counters\">\n    @if ( hasCharactersCounter ) {\n    <div class=\"editor-counters-chars-container\">\n        <span class=\"chars-counter\" [class.chars-counter--error]=\"!isMaxLengthValid\">{{ charactersCounter }}</span>\n        <span class=\"chars-label\">{{ charactersLabel }}</span>\n    </div>\n    }\n    @if ( hasWordsCounter ) {\n    <div class=\"editor-counters-words-container\">\n        <span class=\"words-counter\">{{ wordsCounter }}</span>\n        <span class=\"words-label\">{{ wordsLabel }}</span>\n    </div>\n    }\n</button>\n" }]
        }], propDecorators: { charactersCounter: [{
                type: Input
            }], charactersLabel: [{
                type: Input
            }], wordsCounter: [{
                type: Input
            }], wordsLabel: [{
                type: Input
            }], isMaxLengthValid: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasCharactersCounter: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }], hasWordsCounter: [{
                type: Input,
                args: [{ transform: booleanAttribute }]
            }] } });

class EuiEditorHtmlViewComponent {
    constructor() {
        this.string = 'eui-editor__html-view';
        this.content = '';
        this.theme = 'snow';
        this.innerHTML = '';
        this.themeClass = 'ql-snow';
        this.sanitizer = inject(DomSanitizer);
    }
    ngOnChanges(changes) {
        if (changes && changes.content && changes.content?.currentValue) {
            this.innerHTML = this.sanitizer.bypassSecurityTrustHtml(changes.content.currentValue);
        }
        else {
            this.innerHTML = '';
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorHtmlViewComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiEditorHtmlViewComponent, isStandalone: true, selector: "eui-editor-html-view", inputs: { content: "content", theme: "theme" }, host: { properties: { "class": "this.string" } }, usesOnChanges: true, ngImport: i0, template: "<div #editor class=\"ql-container\" [ngClass]=\"themeClass\">\n    <div class=\"ql-editor\" [innerHTML]=\"innerHTML\"></div>\n</div>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorHtmlViewComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-editor-html-view', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, imports: [NgClass], template: "<div #editor class=\"ql-container\" [ngClass]=\"themeClass\">\n    <div class=\"ql-editor\" [innerHTML]=\"innerHTML\"></div>\n</div>\n" }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }], content: [{
                type: Input
            }], theme: [{
                type: Input
            }] } });

const QuillType$1 = window['Quill'];
class EuiEditorJsonViewComponent {
    constructor() {
        this.string = 'eui-editor__json-view';
        this.theme = 'snow';
        this.elementRef = inject(ElementRef);
        this.valueSetter = (quillEditor, value) => {
            let content = value;
            try {
                content = JSON.parse(value);
            }
            catch (e) {
                console.warn('JSON parse error!');
            }
            quillEditor?.setContents(content);
        };
    }
    ngOnChanges(changes) {
        if (changes && changes.content && changes.content?.currentValue) {
            this.valueSetter(this.quillEditor, changes.content.currentValue);
        }
    }
    ngAfterViewInit() {
        this.elementRef.nativeElement.insertAdjacentHTML('afterbegin', '<div quill-view-element></div>');
        this.editorElem = this.elementRef.nativeElement.querySelector('[quill-view-element]');
        const Quill = window['Quill'];
        this.quillEditor = new Quill(this.editorElem, {
            debug: false,
            formats: null,
            modules: { toolbar: false },
            readOnly: true,
            strict: true,
            theme: 'snow',
        });
        if (this.content) {
            this.valueSetter(this.quillEditor, this.content);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorJsonViewComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "19.2.12", type: EuiEditorJsonViewComponent, isStandalone: true, selector: "eui-editor-json-view", inputs: { theme: "theme", content: "content" }, host: { properties: { "class": "this.string" } }, usesOnChanges: true, ngImport: i0, template: '', isInline: true, changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorJsonViewComponent, decorators: [{
            type: Component,
            args: [{
                    // eslint-disable-next-line
                    selector: 'eui-editor-json-view',
                    template: '',
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                }]
        }], propDecorators: { string: [{
                type: HostBinding,
                args: ['class']
            }], theme: [{
                type: Input
            }], content: [{
                type: Input
            }] } });

// eslint-disable-next-line @typescript-eslint/naming-convention,no-underscore-dangle,id-denylist,id-match
const QuillType = window['Quill'];
// eslint-disable-next-line prefer-const
let QuillBetterTable$1 = window['quillBetterTable'];
class EuiEditorComponent {
    get class() {
        return [
            'eui-editor',
            this.isReadOnly ? 'eui-editor--readonly' : '',
            this.isReadOnly && this.value ? '' : 'eui-editor--empty',
            !this.isReadOnly ? 'eui-editor-wrapper' : '',
        ].join(' ').trim();
    }
    get readonly() {
        return this.isReadOnly ? 'readonly' : null;
    }
    get isReadOnly() {
        return this._isReadOnly;
    }
    set isReadOnly(value) {
        this._isReadOnly = coerceBooleanProperty(value);
    }
    get showCounters() {
        return this._showCounters;
    }
    set showCounters(value) {
        this._showCounters = coerceBooleanProperty(value);
    }
    get isEnabledOnFocus() {
        return this._isEnabledOnFocus;
    }
    set isEnabledOnFocus(value) {
        this._isEnabledOnFocus = coerceBooleanProperty(value);
    }
    get isMinimalToolbar() {
        return this._isMinimalToolbar;
    }
    set isMinimalToolbar(value) {
        this._isMinimalToolbar = coerceBooleanProperty(value);
    }
    get isInvalid() {
        return this._isInvalid;
    }
    set isInvalid(value) {
        this._isInvalid = coerceBooleanProperty(value);
    }
    constructor() {
        this.e2eAttr = 'eui-editor';
        this.placeholder = '';
        this.format = 'html';
        this.theme = 'snow';
        this.debug = false;
        this.customToolbarPosition = 'top';
        this.tabindex = '0';
        // NEW OUTPUTS => eUI13+ only
        this.editorCreate = new EventEmitter();
        this.editorChange = new EventEmitter();
        this.contentChange = new EventEmitter();
        this.selectionChange = new EventEmitter();
        this.focus = new EventEmitter();
        this.blur = new EventEmitter();
        this.charactersCountChange = new EventEmitter();
        this.wordsCountChange = new EventEmitter();
        this.value = '';
        this.charactersCount = 0;
        this.wordsCount = 0;
        this.bytesCount = 0;
        this.isFocused = false;
        this.formControl = new FormControl();
        this.readyToRender = false;
        this._isReadOnly = false;
        this._showCounters = true;
        this._isEnabledOnFocus = false;
        this._isMinimalToolbar = false;
        this._isInvalid = false;
        this.minimalToolbarConfig = [
            { name: 'headings' },
            { name: 'bold' },
            { name: 'italic' },
            { name: 'underline' },
            { name: 'fontColor' },
            { name: 'textAlign' },
            { name: 'link' },
            { name: 'image' },
            { name: 'imageUrl' },
            { name: 'clean' },
            { name: 'delete' },
            { name: 'undo' },
            { name: 'redo' },
            { name: 'counters' },
        ];
        this.defaultToolbarConfig = [
            { name: 'headings', label: 'Style - Apply an HTML tag or CSS class to the selected text', options: [1, 2, 3, 4, 5, 6] },
            { name: 'font', label: 'Font - Change the font face' },
            { name: 'bold', label: 'Bold (Ctrl + B) - Make the selected text bold' },
            { name: 'italic', label: 'Italic (Ctrl + I) - Italicize the selected text' },
            { name: 'underline', label: 'Underline (Ctrl + U) - Underline the selected text' },
            { name: 'strike', label: 'Strikethrough - Draw a line to the middle of the selected text' },
            { name: 'fontColor', label: 'Font Color - Change the text color' },
            { name: 'fontBackground', label: 'Font Background - Change the text background color' },
            { name: 'subscript', label: 'Subscript - Create ssmall letters below the text baseline' },
            { name: 'superscript', label: 'Superscript - Create small letters above the line of the text' },
            { name: 'textAlign', label: 'Text Align - Align the text to the selected position: left (default), center, right or justify' },
            { name: 'orderedList', label: 'Numbering - Start an ordered list' },
            { name: 'bulletList', label: 'Bullets - Start a bulleted list' },
            { name: 'indentLess', label: 'Decrease Indent - Decrease the indent level of the paragraph' },
            { name: 'indentMore', label: 'Increase Indent - Increase the indent level of the paragraph' },
            { name: 'blockquote', label: 'Blockquote - Create a quoted block of the selected text' },
            { name: 'codeBlock', label: 'Insert Code Block - Insert a code block at the cursor row position' },
            { name: 'link', label: 'Insert Hyperlink (Ctrl + K) - Create a link to a Web page, a picture, an e-mail address or a program' },
            { name: 'image', label: 'Insert Picture - Insert a picture from a file' },
            { name: 'imageUrl', label: 'Insert Picture from URL - Insert a picture from a remote URL', dialogMessage: 'Enter image link URL' },
            { name: 'video', label: 'Insert Video - Insert a video from a file' },
            { name: 'table', label: 'Insert Table - Insert a 3x3 rows/cols table' },
            { name: 'clean', label: 'Remove Styles - Remove the styles of the selected text' },
            { name: 'delete', label: "Delete content - Permanently deletes editor's contents" },
            { name: 'undo', label: 'Undo (Ctrl + Z) - Cancels the previous action' },
            { name: 'redo', label: 'Redo (Ctrl + Y) - Do the next history action again' },
            {
                name: 'counters',
                label: 'Counters - Characters and words counters (stripped Html)',
                options: [
                    { name: 'characters', label: 'Characters' },
                    { name: 'words', label: 'Words' },
                ],
            },
        ];
        this.destroy$ = new Subject();
        this.euiDialogService = inject(EuiDialogService);
        this.cdr = inject(ChangeDetectorRef);
        this.ngControl = inject(NgControl);
        this.loader = inject(LoaderService);
        this._internalChange = false; // Add this property to the class
        this.onChange = () => { };
        this.onTouch = () => { };
        this.ngControl.valueAccessor = this;
    }
    ngOnChanges(c) {
        if (!c.isReadOnly?.currentValue) {
            this.calculateCounters(this.value);
        }
    }
    ngOnInit() {
        this.loader.load().subscribe({
            complete: () => {
                this.readyToRender = true;
                this.ngControl.statusChanges.pipe(startWith(this.ngControl.control.status), takeUntil(this.destroy$)).subscribe((status) => {
                    this.isInvalid = status !== 'VALID';
                });
                this.generatedId = this.id ? this.id : 'eui-editor-' + (Math.floor(Math.random() * 1000000) + 1).toString();
                this.toolbarConfig = {};
                if (!this.customToolbarConfig && !this.isMinimalToolbar) {
                    this.defaultToolbarConfig.forEach((t) => {
                        this.toolbarConfig = {
                            ...this.toolbarConfig,
                            [t.name]: { label: t.label, options: t.options, dialogMessage: t.dialogMessage },
                        };
                    });
                }
                if (this.customToolbarConfig && !this.isMinimalToolbar) {
                    this.customToolbarConfig.forEach((t) => {
                        const label = !t.label ? this.defaultToolbarConfig.find((c) => c.name === t.name).label : t.label;
                        let options = !t.options ? this.defaultToolbarConfig.find((c) => c.name === t.name).options : t.options;
                        const d = !t.dialogMessage ? this.defaultToolbarConfig.find((c) => c.name === t.name).dialogMessage : t.dialogMessage;
                        if (t.name === 'counters') {
                            if (!t.options) {
                                options = this.defaultToolbarConfig.find((c) => c.name === t.name).options;
                            }
                            else {
                                options = t.options.map((option) => {
                                    const optionLabel = option.label
                                        ? option.label
                                        : this.defaultToolbarConfig
                                            .find((dtc) => dtc.name === 'counters')
                                            .options.find((o) => o.name === option.name).label;
                                    return { name: option.name, label: optionLabel };
                                });
                            }
                        }
                        this.toolbarConfig = {
                            ...this.toolbarConfig,
                            [t.name]: { label, options, dialogMessage: d },
                        };
                    });
                }
                if (this.isMinimalToolbar) {
                    this.minimalToolbarConfig.forEach((t) => {
                        const label = !t.label ? this.defaultToolbarConfig.find((c) => c.name === t.name).label : t.label;
                        const options = !t.options ? this.defaultToolbarConfig.find((c) => c.name === t.name).options : t.options;
                        const d = !t.dialogMessage ? this.defaultToolbarConfig.find((c) => c.name === t.name).dialogMessage : t.dialogMessage;
                        this.toolbarConfig = {
                            ...this.toolbarConfig,
                            [t.name]: { label, options, dialogMessage: d },
                        };
                    });
                }
                this.cdr.markForCheck();
            }
        });
    }
    ngOnDestroy() {
        this.destroy$.next(true);
        this.destroy$.unsubscribe();
    }
    enableEditorOnFocus() {
        if (this.isEnabledOnFocus && this.isReadOnly) {
            this.isReadOnly = false;
        }
    }
    imageUrlHandler() {
        let imageUrlDialogForm = null;
        this.euiDialogService.openDialog(new EuiDialogConfig({
            title: this.toolbarConfig.imageUrl.dialogMessage,
            isHandleCloseOnAccept: true,
            bodyComponent: {
                component: EuiEditorImageDialogComponent,
                config: {
                    onFormValueChange: (form) => {
                        imageUrlDialogForm = form;
                    },
                },
            },
            accept: () => {
                if (imageUrlDialogForm && imageUrlDialogForm.valid) {
                    this.euiDialogService.closeDialog();
                    const range = this.quill.getSelection() || { index: 0, length: 0 };
                    this.quill.insertEmbed(range.index, 'image', imageUrlDialogForm.get('url').value, 'user');
                }
            },
        }));
    }
    editorUndo() {
        this.quill['history'].undo();
    }
    editorRedo() {
        this.quill['history'].redo();
    }
    editorDeleteContent() {
        const config = new EuiDialogConfig({
            title: 'Delete content',
            content: "<p>Are you sure you want to delete editor's content?</p>",
            hasCloseButton: false,
            accept: () => {
                this.quill.setContents(null);
            },
        });
        this.euiDialogService.openDialog(config);
    }
    insertTable() {
        this.tableModule.insertTable(3, 3);
    }
    get hasImageFeature() {
        return this.euiEditorCustomToolbar
            ? this.euiEditorCustomToolbar?.elementRef.nativeElement.querySelector('.ql-image')
            : !!this.toolbarConfig?.image;
    }
    _onEditorCreated(quill) {
        this.quill = quill;
        if (this.isEnabledOnFocus) {
            this.quill.focus();
        }
        if (this.format === 'html') {
            const delta = this.quill.clipboard.convert({ html: this.value });
            this.formControl.patchValue(delta);
            this.quill.setContents(delta);
        }
        if (this.format === 'json') {
            this.formControl.patchValue(this.value);
            this.quill.setContents(JSON.parse(this.value));
        }
        if (!this.hasImageFeature) {
            quill.clipboard.addMatcher('IMG', (element, delta) => new Delta().insert(''));
            quill.clipboard.addMatcher('PICTURE', (element, delta) => new Delta().insert(''));
        }
        this.editorCreate.emit(quill);
    }
    _onEditorChanged(event) {
        console.warn('onEditorChanged() event is DEPRECATED please use contentChange() event instead.');
        this.editorChange.emit(event);
    }
    _onContentChanged(event) {
        if (this.format === 'html') {
            this.value = event.html;
            this.calculateCounters(this.value);
            // Only call onChange if it's not an internal change
            if (!this._internalChange) {
                this.onChange(this.htmlEntitiesDecode(this.value));
            }
        }
        if (this.format === 'json') {
            if (event.text !== '\n') {
                this.value = event.content;
                this.calculateCounters(event.text);
                this.jsonToHtmlContent = this.htmlEntitiesDecode(JSON.stringify(this.value));
                // Only call onChange if it's not an internal change
                if (!this._internalChange) {
                    this.onChange(this.jsonToHtmlContent);
                }
            }
            else {
                this.value = null;
                this.calculateCounters('');
                this.jsonToHtmlContent = '';
                // Only call onChange if it's not an internal change
                if (!this._internalChange) {
                    this.onChange(null);
                }
            }
        }
        this.contentChange.emit(event); // New emitter
        this._onEditorChanged(event); // Sync with editor change event since it's duplicated event
    }
    _onSelectionChanged(event) {
        this.selectionChange.emit(event);
    }
    _onFocus(event) {
        this.isFocused = true;
        this.focus.emit(event);
    }
    _onBlur(event) {
        this.isFocused = false;
        this.onTouch();
        this.blur.emit(event);
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouch = fn;
    }
    writeValue(value) {
        // Store the value
        this.value = value || null;
        this.jsonToHtmlContent = this.value;
        // Skip triggering onChange during writeValue operations
        if (this.quill) {
            // Use a flag to prevent triggering onChange in _onContentChanged
            this._internalChange = true;
            if (this.format === 'html') {
                const delta = this.quill.clipboard.convert({ html: this.value });
                this.formControl.patchValue(delta, { emitEvent: false });
                this.quill.setContents(delta);
            }
            if (this.format === 'json' && this.value) {
                this.formControl.patchValue(this.value, { emitEvent: false });
                // this.quill.setContents(JSON.parse(this.value));
            }
            this.calculateCounters(this.value);
            // Reset the flag after a short delay to allow Quill to complete its operations
            setTimeout(() => {
                this._internalChange = false;
            });
        }
    }
    get tableModule() {
        return this.quill.getModule('better-table');
    }
    htmlEntitiesDecode(content) {
        let c = content;
        if (c) {
            c = c.replace('&amp;', '&');
            c = c.replace('&nbsp;', ' ');
        }
        return c;
    }
    get hasCharactersCounter() {
        return this.toolbarConfig.counters.options.find((o) => o.name === 'characters');
    }
    get charactersCounterLabel() {
        return this.toolbarConfig.counters.options.find((o) => o.name === 'characters')?.label;
    }
    get hasWordsCounter() {
        return this.toolbarConfig.counters.options.find((o) => o.name === 'words');
    }
    get wordsCounterLabel() {
        return this.toolbarConfig.counters.options.find((o) => o.name === 'words')?.label;
    }
    calculateCounters(content) {
        let text;
        const regex = /[\s\n]+/;
        if (this.format === 'html') {
            if (content && content.length > 0) {
                text = this.stripHtml(content);
                this.charactersCount = text.length;
                text = content.replace(/<\/(p|div|br|li|h[1-6])>/gi, ' ').replace(/<[^>]+>/g, '');
                this.wordsCount = !text ? 0 : text.trim().split(regex).filter(t => t !== '').length;
            }
            else {
                this.charactersCount = 0;
                this.wordsCount = 0;
                this.bytesCount = 0;
            }
        }
        if (this.format === 'json') {
            if (content && this.quill) {
                text = this.stripHtml(this.quill.root.innerHTML);
                this.charactersCount = text.length;
                text = this.quill.root.innerHTML.replace(/<\/(p|div|br|li|h[1-6])>/gi, ' ').replace(/<[^>]+>/g, '');
                this.wordsCount = !text ? 0 : text.trim().split(regex).filter(t => t !== '').length;
            }
            else {
                this.charactersCount = 0;
                this.wordsCount = 0;
                this.bytesCount = 0;
            }
        }
        this.charactersCountChange.emit(this.charactersCount);
        this.wordsCountChange.emit(this.wordsCount);
    }
    stripHtml(content) {
        const regex = /(<([^>]+)>)/gm;
        const contentToReplace = content.replace(regex, '');
        return contentToReplace.replace(/[\u200B-\u200D\uFEFF]/g, '');
    }
    cleanHtml(content) {
        const contentToReplace = content.replace(/<[^>]*>/g, '');
        return contentToReplace.replace(/[\u200B-\u200D\uFEFF]/g, '');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "19.2.12", type: EuiEditorComponent, isStandalone: true, selector: "eui-editor", inputs: { e2eAttr: "e2eAttr", id: "id", placeholder: "placeholder", format: "format", theme: "theme", debug: "debug", customToolbarPosition: "customToolbarPosition", tabindex: "tabindex", modules: "modules", formats: "formats", customToolbarConfig: "customToolbarConfig", height: "height", isReadOnly: "isReadOnly", showCounters: "showCounters", isEnabledOnFocus: "isEnabledOnFocus", isMinimalToolbar: "isMinimalToolbar" }, outputs: { editorCreate: "editorCreate", editorChange: "editorChange", contentChange: "contentChange", selectionChange: "selectionChange", focus: "focus", blur: "blur", charactersCountChange: "charactersCountChange", wordsCountChange: "wordsCountChange" }, host: { listeners: { "click": "enableEditorOnFocus()", "focusin": "enableEditorOnFocus()" }, properties: { "class": "this.class", "attr.tabindex": "this.tabindex", "style.height": "this.height", "class.eui-editor": "this.true", "attr.readonly": "this.readonly", "attr.aria-invalid": "this.isInvalid" } }, providers: [
            // TODO: Check to change the providing way. Provide with injector reference
            EuiDialogService,
        ], queries: [{ propertyName: "euiEditorCustomToolbar", first: true, predicate: i0.forwardRef(() => EuiEditorCustomToolbarTagDirective), descendants: true }], usesOnChanges: true, ngImport: i0, template: "@if (readyToRender) {\n<!-- NOTE: We need to create the editor instance even for readonly mode.\n     This is because we rely on the editor to format HTML/JSON content\n     into a properly structured HTML output that can't be done another way.\n     Future improvement: Consider completely replacing Quill with a\n     markdown-only editor, which would be a better solution. -->\n    <quill-editor\n        [ngStyle]=\"{display: isReadOnly ? 'none' : null}\"\n        [id]=\"generatedId\"\n        class=\"{{ class | classFilter }}\"\n        [class.eui-editor--focused]=\"isFocused\"\n        [format]=\"format\"\n        [formats]=\"formats\"\n        [sanitize]=\"true\"\n        [modules]=\"modules\"\n        [theme]=\"theme\"\n        [placeholder]=\"placeholder\"\n        [customToolbarPosition]=\"customToolbarPosition\"\n        [formControl]=\"formControl\"\n        [debug]=\"debug\"\n        [tabindex]=\"tabindex\"\n        [preserveWhitespace]=\"true\"\n        [hasImageFeature]=\"hasImageFeature\"\n        (onEditorCreated)=\"_onEditorCreated($event)\"\n        (onEditorChanged)=\"_onEditorChanged($event)\"\n        (onContentChanged)=\"_onContentChanged($event)\"\n        (onSelectionChanged)=\"_onSelectionChanged($event)\"\n        (onFocus)=\"_onFocus($event)\"\n        (onBlur)=\"_onBlur($event)\">\n        @if (!euiEditorCustomToolbar) {\n        <div quill-editor-toolbar class=\"eui-u-flex-gap-s\">\n            @if (toolbarConfig.headings) {\n            <div\n                class=\"ql-formats\"\n                role=\"application\"\n                aria-label=\"Select headings style\"\n                euiTooltip=\"{{ toolbarConfig.headings.label | translate }}\">\n                <select class=\"ql-header\" [attr.aria-label]=\"toolbarConfig.headings.label | translate\">\n                    @for (value of toolbarConfig.headings.options; track value) {\n                        <option value=\"{{ value }}\">Heading {{ value }}</option>\n                    }\n                    <option selected>Normal</option>\n                </select>\n            </div>\n            }\n            @if (toolbarConfig.font) {\n            <div\n                class=\"ql-formats\"\n                role=\"application\"\n                aria-label=\"Select font style\"\n                euiTooltip=\"{{ toolbarConfig.font.label | translate }}\">\n                <select class=\"ql-font\" [attr.aria-label]=\"toolbarConfig.font.label | translate\">\n                    <option selected>Sans Serif</option>\n                    <option value=\"serif\">Serif</option>\n                    <option value=\"monospace\">Monospace</option>\n                </select>\n            </div>\n            }\n            @if (toolbarConfig.bold || toolbarConfig.italic || toolbarConfig.underline || toolbarConfig.strike) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.bold) {\n                <button\n                    class=\"ql-bold\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.bold.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.bold.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.italic) {\n                <button\n                    class=\"ql-italic\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.italic.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.italic.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.underline) {\n                <button\n\n                    class=\"ql-underline\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.underline.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.underline.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.strike) {\n                <button\n                    class=\"ql-strike\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.strike.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.strike.label | translate }}\">\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.fontColor || toolbarConfig.fontBackground) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.fontColor) {\n                <span euiTooltip=\"{{ toolbarConfig.fontColor.label | translate }}\">\n                    <select class=\"ql-color\" [attr.aria-label]=\"toolbarConfig.fontColor.label | translate\"></select>\n                </span>\n                }\n                @if (toolbarConfig.fontBackground) {\n                <span euiTooltip=\"{{ toolbarConfig.fontBackground.label | translate }}\">\n                    <select class=\"ql-background\" [attr.aria-label]=\"toolbarConfig.fontBackground.label | translate\"></select>\n                </span>\n                }\n            </div>\n            }\n            @if (toolbarConfig.subscript || toolbarConfig.superscript) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.subscript) {\n                <button\n                    class=\"ql-script\"\n                    value=\"sub\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.subscript.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.subscript.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.superscript) {\n                <button\n                    class=\"ql-script\"\n                    value=\"super\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.superscript.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.superscript.label | translate }}\">\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.textAlign) {\n            <div class=\"ql-formats\">\n                <span euiTooltip=\"{{ toolbarConfig.textAlign.label | translate }}\">\n                    <select class=\"ql-align\" [attr.aria-label]=\"toolbarConfig.textAlign.label | translate\">\n                        <option selected></option>\n                        <option value=\"center\"></option>\n                        <option value=\"right\"></option>\n                        <option value=\"justify\"></option>\n                    </select>\n                </span>\n            </div>\n            }\n            @if (toolbarConfig.orderedList || toolbarConfig.bulletList || toolbarConfig.indentLess || toolbarConfig.indentMore) {\n            <div\n                class=\"ql-formats\">\n                @if (toolbarConfig.orderedList) {\n                <button\n                    class=\"ql-list\"\n                    value=\"ordered\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.orderedList.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.orderedList.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.bulletList) {\n                <button\n                    class=\"ql-list\"\n                    value=\"bullet\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.bulletList.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.bulletList.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.indentLess) {\n                <button\n                    type=\"button\"\n                    class=\"ql-indent\"\n                    value=\"-1\"\n                    [attr.aria-label]=\"toolbarConfig.indentLess.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.indentLess.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.indentMore) {\n                <button\n                    type=\"button\"\n                    class=\"ql-indent\"\n                    value=\"+1\"\n                    [attr.aria-label]=\"toolbarConfig.indentMore.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.indentMore.label | translate }}\">\n                </button>\n                }\n            </div>\n            }\n            @if (\n                    toolbarConfig.blockquote ||\n                    toolbarConfig.codeBlock ||\n                    toolbarConfig.link ||\n                    toolbarConfig.image ||\n                    toolbarConfig.imageUrl ||\n                    toolbarConfig.video ||\n                    toolbarConfig.table\n                ) {\n                <div class=\"ql-formats\">\n                @if (toolbarConfig.blockquote) {\n                <button\n                    class=\"ql-blockquote\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.blockquote.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.blockquote.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.codeBlock) {\n                <button\n                    class=\"ql-code-block\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.codeBlock.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.codeBlock.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.link) {\n                <button\n                    class=\"ql-link\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.link.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.link.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.image) {\n                <button\n                    class=\"ql-image\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.image.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.image.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.imageUrl) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.imageUrl.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.imageUrl.label | translate }}\"\n                    (click)=\"imageUrlHandler()\">\n                    <eui-icon-svg icon=\"eui-ecl-image\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n                @if (toolbarConfig.video) {\n                <button\n                    class=\"ql-video\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.video.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.video.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.table) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.table.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.table.label | translate }}\"\n                    (click)=\"insertTable()\">\n                    <eui-icon-svg icon=\"eui-ecl-spreadsheet\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.clean || toolbarConfig.delete) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.clean) {\n                <button\n                    class=\"ql-clean\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.clean.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.clean.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.delete) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.delete.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.delete.label | translate }}\"\n                    (click)=\"editorDeleteContent()\">\n                    <eui-icon-svg icon=\"trash:outline\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.undo || toolbarConfig.redo) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.undo) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.undo.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.undo.label | translate }}\"\n                    (click)=\"editorUndo()\">\n                    <eui-icon-svg icon=\"arrow-undo:outline\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n                @if (toolbarConfig.redo) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.redo.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.redo.label | translate }}\"\n                    (click)=\"editorRedo()\">\n                    <eui-icon-svg icon=\"arrow-redo:outline\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.counters) {\n            <div class=\"ql-formats\">\n                <eui-editor-counters\n                    [hasCharactersCounter]=\"hasCharactersCounter\"\n                    [charactersCounter]=\"charactersCount\"\n                    [charactersLabel]=\"charactersCounterLabel\"\n                    [hasWordsCounter]=\"hasWordsCounter\"\n                    [wordsCounter]=\"wordsCount\"\n                    [wordsLabel]=\"wordsCounterLabel\"\n                    [attr.aria-label]=\"toolbarConfig.counters.label | translate\"\n                    role=\"button\"\n                    euiTooltip=\"{{ toolbarConfig.counters.label | translate }}\">\n                </eui-editor-counters>\n            </div>\n            }\n        </div>\n        }\n        @if (euiEditorCustomToolbar) {\n        <div quill-editor-toolbar class=\"ql-toolbar ql-snow\">\n            <ng-content select=\"euiEditorCustomToolbar\"></ng-content>\n        </div>\n        }\n    </quill-editor>\n    <!-- READONLY MODE -->\n    @if (isReadOnly && format === 'html') {\n        <eui-editor-html-view\n            [content]=\"value\"\n            [theme]=\"theme\" />\n    }\n    @if (isReadOnly && format === 'json') {\n        <eui-editor-json-view\n            [content]=\"jsonToHtmlContent\"\n            [theme]=\"theme\" />\n    }\n}\n", styles: ["@charset \"UTF-8\";.qlbt-operation-menu .qlbt-operation-color-picker{padding:0 12px 10px!important}.eui-editor{--editor-base-font-size: calc(var(--eui-f-size-m) + 1px);--editor-base-line-height: 1.25;--editor-paragraph-spacer: var(--eui-s-m);--editor-lists-spacer: var(--eui-s-s);--picker-font-size: var(--eui-f-s);display:flex}.eui-editor .ql-container{box-sizing:border-box;font-size:var(--eui-f-size-base);height:100%;margin:0;position:relative;resize:vertical;white-space:pre-wrap;font:var(--eui-f-m);overflow:hidden}.eui-editor .ql-container.ql-snow .ql-tooltip{align-items:center;display:flex;background:var(--eui-c-info-bg);box-shadow:var(--eui-sh-2);left:50%!important;position:absolute;transform:translate(-50%,60%);width:75%}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-hidden{display:none}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-editing{align-items:center;display:flex;left:50%!important;position:absolute;transform:translate(-50%,60%);width:75%}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-editing.ql-hidden{display:none}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-editing input[type=text]{display:inline-block;width:100%}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-flip{z-index:1}.eui-editor .ql-container.ql-snow a.ql-preview{max-width:100%;overflow-x:hidden;text-overflow:ellipsis;vertical-align:top;width:100%}.eui-editor .ql-toolbar{background-color:var(--eui-c-neutral-bg-light);border:var(--eui-bw-xs) solid var(--eui-c-divider);padding:var(--eui-s-s);font:var(--eui-f-m);display:flex;flex-wrap:wrap}.eui-editor .ql-toolbar.ql-snow{box-sizing:border-box}.eui-editor .ql-toolbar.ql-snow .ql-formats{align-items:center;background-color:transparent;border:var(--eui-bw-xs) solid var(--eui-c-divider);border-radius:var(--eui-br-m);display:inline-flex;font:var(--eui-f-m);margin-bottom:0;margin-right:0;vertical-align:middle}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker{align-items:center;color:var(--eui-c-neutral);display:inline-flex;height:var(--eui-s-2xl);position:relative;vertical-align:middle}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker:hover{background-color:var(--eui-c-neutral-bg-light);color:var(--eui-c-info)}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker .ql-picker-label{align-items:center;border-color:transparent;display:flex;font-size:var(--picker-font-size)}.eui-editor .ql-toolbar.ql-snow .ql-formats select{background-color:transparent}.eui-editor .ql-toolbar.ql-snow .ql-formats select:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats select:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats select [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats button{align-items:center;background-color:transparent;border:var(--eui-bw-none) solid var(--eui-c-divider);box-shadow:none;color:var(--eui-c-neutral-light);cursor:pointer;display:inline-flex;height:var(--eui-s-2xl);justify-content:center;padding:var(--eui-s-2xs);width:var(--eui-s-2xl)}.eui-editor .ql-toolbar.ql-snow .ql-formats button:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats button:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats button [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats button:hover{background-color:var(--eui-c-primary-bg);color:var(--eui-c-primary-bg-contrast)}.eui-editor .ql-toolbar.ql-snow .ql-formats button.active,.eui-editor .ql-toolbar.ql-snow .ql-formats button.ql-active{background:var(--eui-c-accent);color:var(--eui-c-accent-contrast)}.eui-editor .ql-toolbar.ql-snow .ql-formats button:first-child{border-radius:var(--eui-br-m) 0 0 var(--eui-br-m)}.eui-editor .ql-toolbar.ql-snow .ql-formats button:last-child{border-radius:0 var(--eui-br-m) var(--eui-br-m) 0}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters{align-items:center;cursor:auto;display:inline-flex;gap:var(--eui-s-xs);padding:0 var(--eui-s-xs);width:auto}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .editor-counters-chars-container,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .editor-counters-words-container{align-items:center;display:flex}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .editor-counters-words-container{border-left:1px solid var(--eui-c-divider);height:60%}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .chars-counter,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .words-counter,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .bytes-counter{color:var(--eui-c-info);font:var(--eui-f-m-bold);margin-right:var(--eui-s-2xs)}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .chars-counter.chars-counter--error,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .words-counter.chars-counter--error,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .bytes-counter.chars-counter--error{color:var(--eui-c-s-danger)}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .words-counter,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .bytes-counter{margin-left:var(--eui-s-xs)}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .chars-label,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .words-label,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .bytes-label{color:var(--eui-c-neutral);font:var(--eui-f-xs-compact)}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-stroke{fill:none;stroke:var(--eui-c-neutral);stroke-linecap:round;stroke-linejoin:round;stroke-width:1px}.eui-editor .ql-toolbar.ql-snow .ql-formats line.ql-color-label.ql-stroke{fill:none;opacity:1;stroke:var(--eui-c-neutral);stroke-linecap:square;stroke-width:var(--eui-s-2xs)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker{height:var(--eui-s-xl);padding:var(--eui-s-2xs) 0;width:calc(7 * var(--eui-s-m))}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item:before{content:\"Normal\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=small]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=small]:before{content:\"Small\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=smaller]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=smaller]:before{content:\"Smaller\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=smallest]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=smallest]:before{content:\"Smallest\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=large]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=large]:before{content:\"Large\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=huge]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=huge]:before{content:\"Huge\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=small]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-size-small{font-size:var(--eui-f-s)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=smaller]:before{font-size:var(--eui-f-xs)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=smallest]:before{font-size:var(--eui-f-size-2xs)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=large]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-size-large{font-size:var(--eui-f-xl)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=huge]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-size-huge{font-size:var(--eui-f-size-4xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker{align-items:center;display:flex}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item:before{content:\"Normal\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"1\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"1\"]:before{content:\"Heading 1\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"2\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"2\"]:before{content:\"Heading 2\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"3\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"3\"]:before{content:\"Heading 3\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"4\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"4\"]:before{content:\"Heading 4\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"5\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"5\"]:before{content:\"Heading 5\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"6\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"6\"]:before{content:\"Heading 6\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"1\"]:before{font:var(--eui-f-4xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"2\"]:before{font:var(--eui-f-3xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"3\"]:before{font:var(--eui-f-2xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"4\"]:before{font:var(--eui-f-xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"5\"]:before{font:var(--eui-f-l)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"6\"]:before{font:var(--eui-f-m)}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker{align-items:center;display:flex}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-label:before,.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item:before{content:\"Sans Serif\"}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-label[data-value=serif]:before,.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=serif]:before{content:\"Serif\"}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-label[data-value=monospace]:before,.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=monospace]:before{content:\"Monospace\"}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=sans-serif]:before{font-family:arial,sans-serif!important}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=serif]:before{font-family:times new roman,serif!important}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=monospace]:before{font-family:courier new,monospace!important}.eui-editor .ql-toolbar.ql-snow .ql-color-picker,.eui-editor .ql-toolbar.ql-snow .ql-icon-picker{height:var(--eui-s-2xl);width:var(--eui-s-2xl)}.eui-editor .ql-toolbar .eui-editor-custom-toolbar{display:inline-flex;margin:0;padding:0;vertical-align:middle;gap:var(--eui-s-s);flex-wrap:wrap}.eui-editor .ql-editor{box-sizing:border-box;height:100%;line-height:var(--editor-base-line-height);outline:none;overflow-y:auto;padding:var(--eui-s-s);-moz-tab-size:4;tab-size:4;text-align:left;white-space:inherit;word-break:normal;word-wrap:break-word;font:var(--eui-f-m)}.eui-editor .ql-editor h1{font:var(--eui-f-4xl)}.eui-editor .ql-editor h2{font:var(--eui-f-3xl)}.eui-editor .ql-editor h3{font:var(--eui-f-2xl)}.eui-editor .ql-editor h4{font:var(--eui-f-xl)}.eui-editor .ql-editor h5{font:var(--eui-f-l)}.eui-editor .ql-editor h6{font:var(--eui-f-m)}.eui-editor .ql-editor .h7{font:var(--eui-f-s)}.eui-editor .ql-editor .h8{font:var(--eui-f-xs)}.eui-editor .ql-editor .h9{font:var(--eui-f-2xs)}.eui-editor .ql-editor p{margin-bottom:var(--editor-paragraph-spacer)}.eui-editor .ql-editor p:first-child{margin-top:0}.eui-editor .ql-editor p:last-child{margin-bottom:0}.eui-editor .ql-editor em,.eui-editor .ql-editor i{font-style:italic!important}.eui-editor .ql-editor strong,.eui-editor .ql-editor b{font-weight:700!important}.eui-editor .ql-editor strong em,.eui-editor .ql-editor strong i,.eui-editor .ql-editor b em,.eui-editor .ql-editor b i{font-style:italic!important;font-weight:700!important}.eui-editor .ql-editor strong em u,.eui-editor .ql-editor strong i u,.eui-editor .ql-editor b em u,.eui-editor .ql-editor b i u{text-decoration:underline!important}.eui-editor .ql-editor blockquote{border-left:var(--eui-s-xs) solid var(--eui-c-neutral-light);margin-bottom:0;margin-top:0;padding-left:var(--eui-s-m)}.eui-editor .ql-editor code,.eui-editor .ql-editor pre{background-color:#f0f0f0;border-radius:var(--eui-br-m)}.eui-editor .ql-editor pre{margin-bottom:var(--eui-s-xs);margin-top:var(--eui-s-xs);padding:var(--eui-s-xs) var(--eui-s-m);white-space:pre-wrap}.eui-editor .ql-editor code{font-size:85%;padding:2px 4px;word-break:break-word}.eui-editor .ql-editor ol,.eui-editor .ql-editor ul{margin-bottom:var(--editor-lists-spacer)}.eui-editor .ql-editor ol{counter-reset:inherit;list-style:none}.eui-editor .ql-editor ol li{padding-left:var(--eui-s-s)}.eui-editor .ql-editor ol li[data-list=bullet]{list-style:none}.eui-editor .ql-editor ol li[data-list=bullet]>.ql-ui:before{content:\"\\2022\";font-size:var(--eui-f-xl);margin-left:calc(-2.125 * var(--eui-s-m));position:absolute;top:calc(-.75 * var(--eui-s-2xs))}.eui-editor .ql-editor ol li[data-list=ordered]{list-style:none}.eui-editor .ql-editor pre.ql-syntax{background-color:var(--eui-c-neutral);color:#f5f5f5;overflow:visible}.eui-editor .ql-editor iframe,.eui-editor .ql-editor img{display:inline-block;height:1;width:1}.eui-editor .ql-editor.ql-blank:before{left:var(--eui-s-m);position:absolute;right:0}.eui-editor .ql-editor p,.eui-editor .ql-editor label,.eui-editor .ql-editor .label,.eui-editor .ql-editor blockquote,.eui-editor .ql-editor abbr,.eui-editor .ql-editor mark,.eui-editor .ql-editor del{font-size:var(--editor-base-font-size)}.eui-editor.eui-editor--focused .ql-container{box-shadow:var(--eui-sh-2)}.eui-editor.eui-editor--focused .ql-container:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-editor.eui-editor--focused .ql-container:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor.eui-editor--focused .ql-container [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor.eui-editor--readonly .ql-container{border:var(--eui-bw-none);resize:none}.eui-editor.eui-editor--readonly .ql-editor{min-height:calc(var(--eui-s-2xl) + 2px);padding:0 0 var(--eui-s-m) 0;white-space:normal}.eui-editor.eui-editor--readonly.eui-editor--empty .ql-container{border:var(--eui-bw-none);outline:1px dashed var(--eui-c-divider)}.eui-editor.eui-editor--readonly.eui-editor--empty .ql-container:hover{outline:1px solid var(--eui-c-neutral-light)}.eui-editor.eui-editor--readonly~.input-maxlength{display:none}.eui-editor-wrapper{position:relative}.eui-editor-wrapper .eui-editor{display:flex;flex-direction:column;height:100%;position:relative;width:100%}.eui-editor-wrapper .eui-editor .ql-container{background-color:var(--eui-c-white);border:var(--eui-bw-xs) solid #ccc;flex-grow:1;min-height:var(--eui-s-5xl);padding:.35rem}.eui-editor-wrapper .eui-editor .ql-container .ngx-quill-view{border:var(--eui-bw-none)}eui-editor{position:relative;width:100%}eui-editor.ng-invalid.ng-touched .eui-editor:not(.eui-editor--readonly) .ql-container{outline:1px solid var(--eui-c-s-danger)}.input-maxlength-wrapper{position:relative;width:100%}.input-maxlength-wrapper .input-maxlength{background-color:var(--eui-c-neutral-bg);border:1px solid var(--eui-c-divider);border-radius:var(--eui-br-m);color:var(--eui-c-text);font:var(--eui-f-xs);padding:0 var(--eui-s-2xs);position:absolute;right:calc(var(--eui-s-xs) * -1);top:calc(var(--eui-s-xs) * -1);z-index:var(--eui-zi-input-maxlength)}.input-maxlength-wrapper .input-maxlength.error{background-color:var(--eui-c-s-danger);border-color:var(--eui-c-s-dangerer);color:var(--eui-c-white)}.eui-editor__html-view,.eui-editor__json-view{width:100%}.ql-container .qlbt-selection-line.qlbt-selection-line-left:before{background-color:#0589f3;border-radius:var(--eui-br-m);content:\"\";height:5px;left:-2px;position:absolute;top:-2px;width:5px}.ql-container .qlbt-selection-line.qlbt-selection-line-right:before{background-color:#0589f3;border-radius:var(--eui-br-m);bottom:-3px;content:\"\";height:5px;position:absolute;right:-2px;width:5px}.quill-better-table-wrapper{overflow-x:auto}table.quill-better-table{border-collapse:collapse;table-layout:fixed}table.quill-better-table td{border:var(--eui-bw-xs) solid #000;padding:2px 5px}.qlbt-operation-menu{background-color:#fff;box-shadow:0 2px 8px #00000026;font-size:14px;overflow:hidden;z-index:100}.qlbt-operation-menu .qlbt-operation-menu-dividing{background-color:#efefef;height:1px}.qlbt-operation-menu .qlbt-operation-menu-subtitle{color:#999;font-size:14px;padding:5px 16px}.qlbt-operation-menu .qlbt-operation-color-picker{align-items:center;background-color:#fff;display:flex;flex-wrap:wrap;overflow:hidden;padding:0 16px 10px}.qlbt-operation-menu .qlbt-operation-color-picker .qlbt-operation-color-picker-item{border:var(--eui-bw-xs) solid #595959;cursor:pointer;height:20px;margin-bottom:5px;margin-right:5px;width:20px}.qlbt-operation-menu .qlbt-operation-menu-item{align-items:center;background-color:#fff;color:#595959;cursor:pointer;display:flex;overflow:hidden;padding:10px 16px;text-overflow:ellipsis}.qlbt-operation-menu .qlbt-operation-menu-item:hover{background-color:#efefef}.qlbt-operation-menu .qlbt-operation-menu-item .qlbt-operation-menu-icon{font-size:0;height:20px;margin-right:8px;width:20px}.qlbt-col-tool{align-items:flex-end;display:flex;height:16px;overflow:hidden;position:absolute;z-index:99}.qlbt-col-tool .qlbt-col-tool-cell{background-color:#fff;border-bottom:1px solid #000;border-right:1px solid #000;border-top:1px solid #000;position:relative}.qlbt-col-tool .qlbt-col-tool-cell:first-child{border-left:1px solid #000}.qlbt-col-tool .qlbt-col-tool-cell-holder{background-color:transparent;bottom:0;cursor:ew-resize;position:absolute;right:-1px;top:0;width:1px;z-index:3}.qlbt-col-tool .qlbt-col-tool-cell-holder:hover{background-color:#0589f3}.qlbt-col-tool .qlbt-col-tool-cell-holder:before{content:\"\";display:block;height:100%;left:-6px;position:absolute;top:0;width:8px}.qlbt-col-tool .qlbt-col-tool-cell-holder:after{content:\"\";display:block;height:100%;position:absolute;right:-6px;top:0;width:8px}\n"], dependencies: [{ kind: "ngmodule", type: i0.forwardRef(() => QuillModule) }, { kind: "component", type: i0.forwardRef(() => i1.QuillEditorComponent), selector: "quill-editor", inputs: ["id", "format", "theme", "modules", "debug", "placeholder", "maxLength", "minLength", "formats", "customToolbarPosition", "styles", "scrollingContainer", "bounds", "customOptions", "trackChanges", "hasImageFeature", "readOnly", "required", "sanitize", "strict", "preserveWhitespace", "valueGetter", "valueSetter"], outputs: ["onEditorCreated", "onContentChanged", "onSelectionChanged", "onFocus", "onBlur"] }, { kind: "directive", type: i0.forwardRef(() => NgStyle), selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: i0.forwardRef(() => ReactiveFormsModule) }, { kind: "directive", type: i0.forwardRef(() => i1$1.NgSelectOption), selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i0.forwardRef(() => i1$1.ɵNgSelectMultipleOption), selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i0.forwardRef(() => i1$1.NgControlStatus), selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i0.forwardRef(() => i1$1.FormControlDirective), selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: i0.forwardRef(() => EuiTooltipDirective), selector: "[euiTooltip]", inputs: ["e2eAttr", "showDelay", "hideDelay", "contentAlignment", "position", "isDisabled", "euiTooltip", "euiTooltipPrimary", "euiTooltipSecondary", "euiTooltipInfo", "euiTooltipSuccess", "euiTooltipWarning", "euiTooltipDanger", "euiTooltipAccent"], exportAs: ["euiTooltip"] }, { kind: "component", type: i0.forwardRef(() => EuiEditorCountersComponent), selector: "eui-editor-counters", inputs: ["charactersCounter", "charactersLabel", "wordsCounter", "wordsLabel", "isMaxLengthValid", "hasCharactersCounter", "hasWordsCounter"] }, { kind: "component", type: i0.forwardRef(() => EuiEditorHtmlViewComponent), selector: "eui-editor-html-view", inputs: ["content", "theme"] }, { kind: "component", type: i0.forwardRef(() => EuiEditorJsonViewComponent), selector: "eui-editor-json-view", inputs: ["theme", "content"] }, { kind: "ngmodule", type: i0.forwardRef(() => TranslateModule) }, { kind: "pipe", type: i0.forwardRef(() => i3.TranslatePipe), name: "translate" }, { kind: "pipe", type: i0.forwardRef(() => ClassFilterPipe), name: "classFilter" }, { kind: "component", type: i0.forwardRef(() => i4.EuiIconSvgComponent), selector: "eui-icon-svg, span[euiIconSvg], i[euiIconSvg]", inputs: ["icon", "fillColor", "set", "size", "style", "iconUrl", "transform", "euiVariant", "aria-label", "ariaHidden", "focusable", "isLoading", "isInputIcon", "euiStart", "euiEnd"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush, encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'eui-editor', encapsulation: ViewEncapsulation.None, changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        // TODO: Check to change the providing way. Provide with injector reference
                        EuiDialogService,
                    ], imports: [
                        QuillModule,
                        NgStyle,
                        ReactiveFormsModule,
                        EuiTooltipDirective,
                        EuiEditorCountersComponent,
                        EuiEditorHtmlViewComponent,
                        EuiEditorJsonViewComponent,
                        TranslateModule,
                        forwardRef(() => ClassFilterPipe),
                        ...EUI_ICON,
                    ], template: "@if (readyToRender) {\n<!-- NOTE: We need to create the editor instance even for readonly mode.\n     This is because we rely on the editor to format HTML/JSON content\n     into a properly structured HTML output that can't be done another way.\n     Future improvement: Consider completely replacing Quill with a\n     markdown-only editor, which would be a better solution. -->\n    <quill-editor\n        [ngStyle]=\"{display: isReadOnly ? 'none' : null}\"\n        [id]=\"generatedId\"\n        class=\"{{ class | classFilter }}\"\n        [class.eui-editor--focused]=\"isFocused\"\n        [format]=\"format\"\n        [formats]=\"formats\"\n        [sanitize]=\"true\"\n        [modules]=\"modules\"\n        [theme]=\"theme\"\n        [placeholder]=\"placeholder\"\n        [customToolbarPosition]=\"customToolbarPosition\"\n        [formControl]=\"formControl\"\n        [debug]=\"debug\"\n        [tabindex]=\"tabindex\"\n        [preserveWhitespace]=\"true\"\n        [hasImageFeature]=\"hasImageFeature\"\n        (onEditorCreated)=\"_onEditorCreated($event)\"\n        (onEditorChanged)=\"_onEditorChanged($event)\"\n        (onContentChanged)=\"_onContentChanged($event)\"\n        (onSelectionChanged)=\"_onSelectionChanged($event)\"\n        (onFocus)=\"_onFocus($event)\"\n        (onBlur)=\"_onBlur($event)\">\n        @if (!euiEditorCustomToolbar) {\n        <div quill-editor-toolbar class=\"eui-u-flex-gap-s\">\n            @if (toolbarConfig.headings) {\n            <div\n                class=\"ql-formats\"\n                role=\"application\"\n                aria-label=\"Select headings style\"\n                euiTooltip=\"{{ toolbarConfig.headings.label | translate }}\">\n                <select class=\"ql-header\" [attr.aria-label]=\"toolbarConfig.headings.label | translate\">\n                    @for (value of toolbarConfig.headings.options; track value) {\n                        <option value=\"{{ value }}\">Heading {{ value }}</option>\n                    }\n                    <option selected>Normal</option>\n                </select>\n            </div>\n            }\n            @if (toolbarConfig.font) {\n            <div\n                class=\"ql-formats\"\n                role=\"application\"\n                aria-label=\"Select font style\"\n                euiTooltip=\"{{ toolbarConfig.font.label | translate }}\">\n                <select class=\"ql-font\" [attr.aria-label]=\"toolbarConfig.font.label | translate\">\n                    <option selected>Sans Serif</option>\n                    <option value=\"serif\">Serif</option>\n                    <option value=\"monospace\">Monospace</option>\n                </select>\n            </div>\n            }\n            @if (toolbarConfig.bold || toolbarConfig.italic || toolbarConfig.underline || toolbarConfig.strike) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.bold) {\n                <button\n                    class=\"ql-bold\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.bold.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.bold.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.italic) {\n                <button\n                    class=\"ql-italic\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.italic.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.italic.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.underline) {\n                <button\n\n                    class=\"ql-underline\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.underline.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.underline.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.strike) {\n                <button\n                    class=\"ql-strike\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.strike.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.strike.label | translate }}\">\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.fontColor || toolbarConfig.fontBackground) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.fontColor) {\n                <span euiTooltip=\"{{ toolbarConfig.fontColor.label | translate }}\">\n                    <select class=\"ql-color\" [attr.aria-label]=\"toolbarConfig.fontColor.label | translate\"></select>\n                </span>\n                }\n                @if (toolbarConfig.fontBackground) {\n                <span euiTooltip=\"{{ toolbarConfig.fontBackground.label | translate }}\">\n                    <select class=\"ql-background\" [attr.aria-label]=\"toolbarConfig.fontBackground.label | translate\"></select>\n                </span>\n                }\n            </div>\n            }\n            @if (toolbarConfig.subscript || toolbarConfig.superscript) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.subscript) {\n                <button\n                    class=\"ql-script\"\n                    value=\"sub\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.subscript.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.subscript.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.superscript) {\n                <button\n                    class=\"ql-script\"\n                    value=\"super\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.superscript.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.superscript.label | translate }}\">\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.textAlign) {\n            <div class=\"ql-formats\">\n                <span euiTooltip=\"{{ toolbarConfig.textAlign.label | translate }}\">\n                    <select class=\"ql-align\" [attr.aria-label]=\"toolbarConfig.textAlign.label | translate\">\n                        <option selected></option>\n                        <option value=\"center\"></option>\n                        <option value=\"right\"></option>\n                        <option value=\"justify\"></option>\n                    </select>\n                </span>\n            </div>\n            }\n            @if (toolbarConfig.orderedList || toolbarConfig.bulletList || toolbarConfig.indentLess || toolbarConfig.indentMore) {\n            <div\n                class=\"ql-formats\">\n                @if (toolbarConfig.orderedList) {\n                <button\n                    class=\"ql-list\"\n                    value=\"ordered\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.orderedList.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.orderedList.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.bulletList) {\n                <button\n                    class=\"ql-list\"\n                    value=\"bullet\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.bulletList.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.bulletList.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.indentLess) {\n                <button\n                    type=\"button\"\n                    class=\"ql-indent\"\n                    value=\"-1\"\n                    [attr.aria-label]=\"toolbarConfig.indentLess.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.indentLess.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.indentMore) {\n                <button\n                    type=\"button\"\n                    class=\"ql-indent\"\n                    value=\"+1\"\n                    [attr.aria-label]=\"toolbarConfig.indentMore.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.indentMore.label | translate }}\">\n                </button>\n                }\n            </div>\n            }\n            @if (\n                    toolbarConfig.blockquote ||\n                    toolbarConfig.codeBlock ||\n                    toolbarConfig.link ||\n                    toolbarConfig.image ||\n                    toolbarConfig.imageUrl ||\n                    toolbarConfig.video ||\n                    toolbarConfig.table\n                ) {\n                <div class=\"ql-formats\">\n                @if (toolbarConfig.blockquote) {\n                <button\n                    class=\"ql-blockquote\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.blockquote.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.blockquote.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.codeBlock) {\n                <button\n                    class=\"ql-code-block\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.codeBlock.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.codeBlock.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.link) {\n                <button\n                    class=\"ql-link\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.link.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.link.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.image) {\n                <button\n                    class=\"ql-image\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.image.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.image.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.imageUrl) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.imageUrl.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.imageUrl.label | translate }}\"\n                    (click)=\"imageUrlHandler()\">\n                    <eui-icon-svg icon=\"eui-ecl-image\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n                @if (toolbarConfig.video) {\n                <button\n                    class=\"ql-video\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.video.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.video.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.table) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.table.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.table.label | translate }}\"\n                    (click)=\"insertTable()\">\n                    <eui-icon-svg icon=\"eui-ecl-spreadsheet\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.clean || toolbarConfig.delete) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.clean) {\n                <button\n                    class=\"ql-clean\"\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.clean.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.clean.label | translate }}\">\n                </button>\n                }\n                @if (toolbarConfig.delete) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.delete.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.delete.label | translate }}\"\n                    (click)=\"editorDeleteContent()\">\n                    <eui-icon-svg icon=\"trash:outline\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.undo || toolbarConfig.redo) {\n            <div class=\"ql-formats\">\n                @if (toolbarConfig.undo) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.undo.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.undo.label | translate }}\"\n                    (click)=\"editorUndo()\">\n                    <eui-icon-svg icon=\"arrow-undo:outline\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n                @if (toolbarConfig.redo) {\n                <button\n                    type=\"button\"\n                    [attr.aria-label]=\"toolbarConfig.redo.label | translate\"\n                    euiTooltip=\"{{ toolbarConfig.redo.label | translate }}\"\n                    (click)=\"editorRedo()\">\n                    <eui-icon-svg icon=\"arrow-redo:outline\" size=\"s\"></eui-icon-svg>\n                </button>\n                }\n            </div>\n            }\n            @if (toolbarConfig.counters) {\n            <div class=\"ql-formats\">\n                <eui-editor-counters\n                    [hasCharactersCounter]=\"hasCharactersCounter\"\n                    [charactersCounter]=\"charactersCount\"\n                    [charactersLabel]=\"charactersCounterLabel\"\n                    [hasWordsCounter]=\"hasWordsCounter\"\n                    [wordsCounter]=\"wordsCount\"\n                    [wordsLabel]=\"wordsCounterLabel\"\n                    [attr.aria-label]=\"toolbarConfig.counters.label | translate\"\n                    role=\"button\"\n                    euiTooltip=\"{{ toolbarConfig.counters.label | translate }}\">\n                </eui-editor-counters>\n            </div>\n            }\n        </div>\n        }\n        @if (euiEditorCustomToolbar) {\n        <div quill-editor-toolbar class=\"ql-toolbar ql-snow\">\n            <ng-content select=\"euiEditorCustomToolbar\"></ng-content>\n        </div>\n        }\n    </quill-editor>\n    <!-- READONLY MODE -->\n    @if (isReadOnly && format === 'html') {\n        <eui-editor-html-view\n            [content]=\"value\"\n            [theme]=\"theme\" />\n    }\n    @if (isReadOnly && format === 'json') {\n        <eui-editor-json-view\n            [content]=\"jsonToHtmlContent\"\n            [theme]=\"theme\" />\n    }\n}\n", styles: ["@charset \"UTF-8\";.qlbt-operation-menu .qlbt-operation-color-picker{padding:0 12px 10px!important}.eui-editor{--editor-base-font-size: calc(var(--eui-f-size-m) + 1px);--editor-base-line-height: 1.25;--editor-paragraph-spacer: var(--eui-s-m);--editor-lists-spacer: var(--eui-s-s);--picker-font-size: var(--eui-f-s);display:flex}.eui-editor .ql-container{box-sizing:border-box;font-size:var(--eui-f-size-base);height:100%;margin:0;position:relative;resize:vertical;white-space:pre-wrap;font:var(--eui-f-m);overflow:hidden}.eui-editor .ql-container.ql-snow .ql-tooltip{align-items:center;display:flex;background:var(--eui-c-info-bg);box-shadow:var(--eui-sh-2);left:50%!important;position:absolute;transform:translate(-50%,60%);width:75%}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-hidden{display:none}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-editing{align-items:center;display:flex;left:50%!important;position:absolute;transform:translate(-50%,60%);width:75%}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-editing.ql-hidden{display:none}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-editing input[type=text]{display:inline-block;width:100%}.eui-editor .ql-container.ql-snow .ql-tooltip.ql-flip{z-index:1}.eui-editor .ql-container.ql-snow a.ql-preview{max-width:100%;overflow-x:hidden;text-overflow:ellipsis;vertical-align:top;width:100%}.eui-editor .ql-toolbar{background-color:var(--eui-c-neutral-bg-light);border:var(--eui-bw-xs) solid var(--eui-c-divider);padding:var(--eui-s-s);font:var(--eui-f-m);display:flex;flex-wrap:wrap}.eui-editor .ql-toolbar.ql-snow{box-sizing:border-box}.eui-editor .ql-toolbar.ql-snow .ql-formats{align-items:center;background-color:transparent;border:var(--eui-bw-xs) solid var(--eui-c-divider);border-radius:var(--eui-br-m);display:inline-flex;font:var(--eui-f-m);margin-bottom:0;margin-right:0;vertical-align:middle}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker{align-items:center;color:var(--eui-c-neutral);display:inline-flex;height:var(--eui-s-2xl);position:relative;vertical-align:middle}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker:hover{background-color:var(--eui-c-neutral-bg-light);color:var(--eui-c-info)}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-picker .ql-picker-label{align-items:center;border-color:transparent;display:flex;font-size:var(--picker-font-size)}.eui-editor .ql-toolbar.ql-snow .ql-formats select{background-color:transparent}.eui-editor .ql-toolbar.ql-snow .ql-formats select:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats select:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats select [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats button{align-items:center;background-color:transparent;border:var(--eui-bw-none) solid var(--eui-c-divider);box-shadow:none;color:var(--eui-c-neutral-light);cursor:pointer;display:inline-flex;height:var(--eui-s-2xl);justify-content:center;padding:var(--eui-s-2xs);width:var(--eui-s-2xl)}.eui-editor .ql-toolbar.ql-snow .ql-formats button:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats button:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats button [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor .ql-toolbar.ql-snow .ql-formats button:hover{background-color:var(--eui-c-primary-bg);color:var(--eui-c-primary-bg-contrast)}.eui-editor .ql-toolbar.ql-snow .ql-formats button.active,.eui-editor .ql-toolbar.ql-snow .ql-formats button.ql-active{background:var(--eui-c-accent);color:var(--eui-c-accent-contrast)}.eui-editor .ql-toolbar.ql-snow .ql-formats button:first-child{border-radius:var(--eui-br-m) 0 0 var(--eui-br-m)}.eui-editor .ql-toolbar.ql-snow .ql-formats button:last-child{border-radius:0 var(--eui-br-m) var(--eui-br-m) 0}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters{align-items:center;cursor:auto;display:inline-flex;gap:var(--eui-s-xs);padding:0 var(--eui-s-xs);width:auto}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .editor-counters-chars-container,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .editor-counters-words-container{align-items:center;display:flex}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .editor-counters-words-container{border-left:1px solid var(--eui-c-divider);height:60%}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .chars-counter,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .words-counter,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .bytes-counter{color:var(--eui-c-info);font:var(--eui-f-m-bold);margin-right:var(--eui-s-2xs)}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .chars-counter.chars-counter--error,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .words-counter.chars-counter--error,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .bytes-counter.chars-counter--error{color:var(--eui-c-s-danger)}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .words-counter,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .bytes-counter{margin-left:var(--eui-s-xs)}.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .chars-label,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .words-label,.eui-editor .ql-toolbar.ql-snow .ql-formats button.editor-counters .bytes-label{color:var(--eui-c-neutral);font:var(--eui-f-xs-compact)}.eui-editor .ql-toolbar.ql-snow .ql-formats .ql-stroke{fill:none;stroke:var(--eui-c-neutral);stroke-linecap:round;stroke-linejoin:round;stroke-width:1px}.eui-editor .ql-toolbar.ql-snow .ql-formats line.ql-color-label.ql-stroke{fill:none;opacity:1;stroke:var(--eui-c-neutral);stroke-linecap:square;stroke-width:var(--eui-s-2xs)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker{height:var(--eui-s-xl);padding:var(--eui-s-2xs) 0;width:calc(7 * var(--eui-s-m))}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item:before{content:\"Normal\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=small]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=small]:before{content:\"Small\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=smaller]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=smaller]:before{content:\"Smaller\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=smallest]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=smallest]:before{content:\"Smallest\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=large]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=large]:before{content:\"Large\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-label[data-value=huge]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=huge]:before{content:\"Huge\"}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=small]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-size-small{font-size:var(--eui-f-s)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=smaller]:before{font-size:var(--eui-f-xs)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=smallest]:before{font-size:var(--eui-f-size-2xs)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=large]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-size-large{font-size:var(--eui-f-xl)}.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-picker-item[data-value=huge]:before,.eui-editor .ql-toolbar.ql-snow .ql-size.ql-picker .ql-size-huge{font-size:var(--eui-f-size-4xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker{align-items:center;display:flex}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item:before{content:\"Normal\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"1\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"1\"]:before{content:\"Heading 1\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"2\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"2\"]:before{content:\"Heading 2\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"3\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"3\"]:before{content:\"Heading 3\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"4\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"4\"]:before{content:\"Heading 4\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"5\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"5\"]:before{content:\"Heading 5\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-label[data-value=\"6\"]:before,.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"6\"]:before{content:\"Heading 6\"}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"1\"]:before{font:var(--eui-f-4xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"2\"]:before{font:var(--eui-f-3xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"3\"]:before{font:var(--eui-f-2xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"4\"]:before{font:var(--eui-f-xl)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"5\"]:before{font:var(--eui-f-l)}.eui-editor .ql-toolbar.ql-snow .ql-header.ql-picker .ql-picker-item[data-value=\"6\"]:before{font:var(--eui-f-m)}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker{align-items:center;display:flex}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-label:before,.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item:before{content:\"Sans Serif\"}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-label[data-value=serif]:before,.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=serif]:before{content:\"Serif\"}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-label[data-value=monospace]:before,.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=monospace]:before{content:\"Monospace\"}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=sans-serif]:before{font-family:arial,sans-serif!important}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=serif]:before{font-family:times new roman,serif!important}.eui-editor .ql-toolbar.ql-snow .ql-font.ql-picker .ql-picker-item[data-value=monospace]:before{font-family:courier new,monospace!important}.eui-editor .ql-toolbar.ql-snow .ql-color-picker,.eui-editor .ql-toolbar.ql-snow .ql-icon-picker{height:var(--eui-s-2xl);width:var(--eui-s-2xl)}.eui-editor .ql-toolbar .eui-editor-custom-toolbar{display:inline-flex;margin:0;padding:0;vertical-align:middle;gap:var(--eui-s-s);flex-wrap:wrap}.eui-editor .ql-editor{box-sizing:border-box;height:100%;line-height:var(--editor-base-line-height);outline:none;overflow-y:auto;padding:var(--eui-s-s);-moz-tab-size:4;tab-size:4;text-align:left;white-space:inherit;word-break:normal;word-wrap:break-word;font:var(--eui-f-m)}.eui-editor .ql-editor h1{font:var(--eui-f-4xl)}.eui-editor .ql-editor h2{font:var(--eui-f-3xl)}.eui-editor .ql-editor h3{font:var(--eui-f-2xl)}.eui-editor .ql-editor h4{font:var(--eui-f-xl)}.eui-editor .ql-editor h5{font:var(--eui-f-l)}.eui-editor .ql-editor h6{font:var(--eui-f-m)}.eui-editor .ql-editor .h7{font:var(--eui-f-s)}.eui-editor .ql-editor .h8{font:var(--eui-f-xs)}.eui-editor .ql-editor .h9{font:var(--eui-f-2xs)}.eui-editor .ql-editor p{margin-bottom:var(--editor-paragraph-spacer)}.eui-editor .ql-editor p:first-child{margin-top:0}.eui-editor .ql-editor p:last-child{margin-bottom:0}.eui-editor .ql-editor em,.eui-editor .ql-editor i{font-style:italic!important}.eui-editor .ql-editor strong,.eui-editor .ql-editor b{font-weight:700!important}.eui-editor .ql-editor strong em,.eui-editor .ql-editor strong i,.eui-editor .ql-editor b em,.eui-editor .ql-editor b i{font-style:italic!important;font-weight:700!important}.eui-editor .ql-editor strong em u,.eui-editor .ql-editor strong i u,.eui-editor .ql-editor b em u,.eui-editor .ql-editor b i u{text-decoration:underline!important}.eui-editor .ql-editor blockquote{border-left:var(--eui-s-xs) solid var(--eui-c-neutral-light);margin-bottom:0;margin-top:0;padding-left:var(--eui-s-m)}.eui-editor .ql-editor code,.eui-editor .ql-editor pre{background-color:#f0f0f0;border-radius:var(--eui-br-m)}.eui-editor .ql-editor pre{margin-bottom:var(--eui-s-xs);margin-top:var(--eui-s-xs);padding:var(--eui-s-xs) var(--eui-s-m);white-space:pre-wrap}.eui-editor .ql-editor code{font-size:85%;padding:2px 4px;word-break:break-word}.eui-editor .ql-editor ol,.eui-editor .ql-editor ul{margin-bottom:var(--editor-lists-spacer)}.eui-editor .ql-editor ol{counter-reset:inherit;list-style:none}.eui-editor .ql-editor ol li{padding-left:var(--eui-s-s)}.eui-editor .ql-editor ol li[data-list=bullet]{list-style:none}.eui-editor .ql-editor ol li[data-list=bullet]>.ql-ui:before{content:\"\\2022\";font-size:var(--eui-f-xl);margin-left:calc(-2.125 * var(--eui-s-m));position:absolute;top:calc(-.75 * var(--eui-s-2xs))}.eui-editor .ql-editor ol li[data-list=ordered]{list-style:none}.eui-editor .ql-editor pre.ql-syntax{background-color:var(--eui-c-neutral);color:#f5f5f5;overflow:visible}.eui-editor .ql-editor iframe,.eui-editor .ql-editor img{display:inline-block;height:1;width:1}.eui-editor .ql-editor.ql-blank:before{left:var(--eui-s-m);position:absolute;right:0}.eui-editor .ql-editor p,.eui-editor .ql-editor label,.eui-editor .ql-editor .label,.eui-editor .ql-editor blockquote,.eui-editor .ql-editor abbr,.eui-editor .ql-editor mark,.eui-editor .ql-editor del{font-size:var(--editor-base-font-size)}.eui-editor.eui-editor--focused .ql-container{box-shadow:var(--eui-sh-2)}.eui-editor.eui-editor--focused .ql-container:focus:not([readonly]){outline:2px solid var(--eui-c-focus)!important;outline-offset:-2px!important;transition:none}.eui-editor.eui-editor--focused .ql-container:focus-visible:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor.eui-editor--focused .ql-container [tabindex=\"0\"]:focus:not([readonly]){outline:2px solid var(--eui-c-focus-visible)!important;outline-offset:-2px!important;transition:none}.eui-editor.eui-editor--readonly .ql-container{border:var(--eui-bw-none);resize:none}.eui-editor.eui-editor--readonly .ql-editor{min-height:calc(var(--eui-s-2xl) + 2px);padding:0 0 var(--eui-s-m) 0;white-space:normal}.eui-editor.eui-editor--readonly.eui-editor--empty .ql-container{border:var(--eui-bw-none);outline:1px dashed var(--eui-c-divider)}.eui-editor.eui-editor--readonly.eui-editor--empty .ql-container:hover{outline:1px solid var(--eui-c-neutral-light)}.eui-editor.eui-editor--readonly~.input-maxlength{display:none}.eui-editor-wrapper{position:relative}.eui-editor-wrapper .eui-editor{display:flex;flex-direction:column;height:100%;position:relative;width:100%}.eui-editor-wrapper .eui-editor .ql-container{background-color:var(--eui-c-white);border:var(--eui-bw-xs) solid #ccc;flex-grow:1;min-height:var(--eui-s-5xl);padding:.35rem}.eui-editor-wrapper .eui-editor .ql-container .ngx-quill-view{border:var(--eui-bw-none)}eui-editor{position:relative;width:100%}eui-editor.ng-invalid.ng-touched .eui-editor:not(.eui-editor--readonly) .ql-container{outline:1px solid var(--eui-c-s-danger)}.input-maxlength-wrapper{position:relative;width:100%}.input-maxlength-wrapper .input-maxlength{background-color:var(--eui-c-neutral-bg);border:1px solid var(--eui-c-divider);border-radius:var(--eui-br-m);color:var(--eui-c-text);font:var(--eui-f-xs);padding:0 var(--eui-s-2xs);position:absolute;right:calc(var(--eui-s-xs) * -1);top:calc(var(--eui-s-xs) * -1);z-index:var(--eui-zi-input-maxlength)}.input-maxlength-wrapper .input-maxlength.error{background-color:var(--eui-c-s-danger);border-color:var(--eui-c-s-dangerer);color:var(--eui-c-white)}.eui-editor__html-view,.eui-editor__json-view{width:100%}.ql-container .qlbt-selection-line.qlbt-selection-line-left:before{background-color:#0589f3;border-radius:var(--eui-br-m);content:\"\";height:5px;left:-2px;position:absolute;top:-2px;width:5px}.ql-container .qlbt-selection-line.qlbt-selection-line-right:before{background-color:#0589f3;border-radius:var(--eui-br-m);bottom:-3px;content:\"\";height:5px;position:absolute;right:-2px;width:5px}.quill-better-table-wrapper{overflow-x:auto}table.quill-better-table{border-collapse:collapse;table-layout:fixed}table.quill-better-table td{border:var(--eui-bw-xs) solid #000;padding:2px 5px}.qlbt-operation-menu{background-color:#fff;box-shadow:0 2px 8px #00000026;font-size:14px;overflow:hidden;z-index:100}.qlbt-operation-menu .qlbt-operation-menu-dividing{background-color:#efefef;height:1px}.qlbt-operation-menu .qlbt-operation-menu-subtitle{color:#999;font-size:14px;padding:5px 16px}.qlbt-operation-menu .qlbt-operation-color-picker{align-items:center;background-color:#fff;display:flex;flex-wrap:wrap;overflow:hidden;padding:0 16px 10px}.qlbt-operation-menu .qlbt-operation-color-picker .qlbt-operation-color-picker-item{border:var(--eui-bw-xs) solid #595959;cursor:pointer;height:20px;margin-bottom:5px;margin-right:5px;width:20px}.qlbt-operation-menu .qlbt-operation-menu-item{align-items:center;background-color:#fff;color:#595959;cursor:pointer;display:flex;overflow:hidden;padding:10px 16px;text-overflow:ellipsis}.qlbt-operation-menu .qlbt-operation-menu-item:hover{background-color:#efefef}.qlbt-operation-menu .qlbt-operation-menu-item .qlbt-operation-menu-icon{font-size:0;height:20px;margin-right:8px;width:20px}.qlbt-col-tool{align-items:flex-end;display:flex;height:16px;overflow:hidden;position:absolute;z-index:99}.qlbt-col-tool .qlbt-col-tool-cell{background-color:#fff;border-bottom:1px solid #000;border-right:1px solid #000;border-top:1px solid #000;position:relative}.qlbt-col-tool .qlbt-col-tool-cell:first-child{border-left:1px solid #000}.qlbt-col-tool .qlbt-col-tool-cell-holder{background-color:transparent;bottom:0;cursor:ew-resize;position:absolute;right:-1px;top:0;width:1px;z-index:3}.qlbt-col-tool .qlbt-col-tool-cell-holder:hover{background-color:#0589f3}.qlbt-col-tool .qlbt-col-tool-cell-holder:before{content:\"\";display:block;height:100%;left:-6px;position:absolute;top:0;width:8px}.qlbt-col-tool .qlbt-col-tool-cell-holder:after{content:\"\";display:block;height:100%;position:absolute;right:-6px;top:0;width:8px}\n"] }]
        }], ctorParameters: () => [], propDecorators: { class: [{
                type: HostBinding,
                args: ['class']
            }], e2eAttr: [{
                type: Input
            }], id: [{
                type: Input
            }], placeholder: [{
                type: Input
            }], format: [{
                type: Input
            }], theme: [{
                type: Input
            }], debug: [{
                type: Input
            }], customToolbarPosition: [{
                type: Input
            }], tabindex: [{
                type: HostBinding,
                args: ['attr.tabindex']
            }, {
                type: Input
            }], modules: [{
                type: Input
            }], formats: [{
                type: Input
            }], customToolbarConfig: [{
                type: Input
            }], height: [{
                type: HostBinding,
                args: ['style.height']
            }, {
                type: Input
            }], editorCreate: [{
                type: Output
            }], editorChange: [{
                type: Output
            }], contentChange: [{
                type: Output
            }], selectionChange: [{
                type: Output
            }], focus: [{
                type: Output
            }], blur: [{
                type: Output
            }], charactersCountChange: [{
                type: Output
            }], wordsCountChange: [{
                type: Output
            }], true: [{
                type: HostBinding,
                args: ['class.eui-editor']
            }], readonly: [{
                type: HostBinding,
                args: ['attr.readonly']
            }], euiEditorCustomToolbar: [{
                type: ContentChild,
                args: [forwardRef(() => EuiEditorCustomToolbarTagDirective), { static: false }]
            }], isReadOnly: [{
                type: Input
            }], showCounters: [{
                type: Input
            }], isEnabledOnFocus: [{
                type: Input
            }], isMinimalToolbar: [{
                type: Input
            }], isInvalid: [{
                type: HostBinding,
                args: ['attr.aria-invalid']
            }], enableEditorOnFocus: [{
                type: HostListener,
                args: ['click']
            }, {
                type: HostListener,
                args: ['focusin']
            }] } });
/* eslint-disable */
class EuiEditorCustomToolbarTagDirective {
    constructor() {
        this.elementRef = inject(ElementRef);
        this.elementClass = 'eui-editor-custom-toolbar';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorCustomToolbarTagDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.12", type: EuiEditorCustomToolbarTagDirective, isStandalone: true, selector: "euiEditorCustomToolbar", host: { properties: { "class": "this.elementClass" } }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorCustomToolbarTagDirective, decorators: [{
            type: Directive,
            args: [{ selector: 'euiEditorCustomToolbar', }]
        }], propDecorators: { elementClass: [{
                type: HostBinding,
                args: ['class']
            }] } });
/* eslint-enable */
/**
 * Pipe to remove classes from the editor
 */
class ClassFilterPipe {
    transform(value) {
        return value
            .replace(/eui-editor-wrapper/g, '')
            .replace(/eui-editor--readonly/g, '')
            .replace(/eui-editor--empty/g, '');
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: ClassFilterPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "19.2.12", ngImport: i0, type: ClassFilterPipe, isStandalone: true, name: "classFilter" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: ClassFilterPipe, decorators: [{
            type: Pipe,
            args: [{ name: 'classFilter', }]
        }] });

class EuiEditorMaxlengthDirective {
    constructor() {
        this.format = 'html';
        this._isShowMaxlength = true;
        this.el = inject(ElementRef);
        this.renderer = inject(Renderer2);
        this.control = inject(NgControl, { self: true });
    }
    get euiEditorMaxlength() {
        return this._euiEditorMaxlength;
    }
    set euiEditorMaxlength(value) {
        this._euiEditorMaxlength = coerceNumberProperty(value);
    }
    get isShowMaxlength() {
        return this._isShowMaxlength;
    }
    set isShowMaxlength(value) {
        this._isShowMaxlength = coerceBooleanProperty(value);
    }
    ngOnChanges(changes) {
        if (changes['isShowMaxlength'] && this.maxLengthSpan) {
            if (this.isShowMaxlength) {
                this.createMaxLengthBox();
                this.refreshValue();
            }
            else {
                this.destroyMaxLengthBox();
            }
        }
    }
    ngAfterContentInit() {
        if (this.euiEditorMaxlength) {
            this.createMaxLengthBox();
            this.refreshValue();
        }
        if (this.control?.valueChanges) {
            this.valueChangesSubscription = this.control.valueChanges.subscribe(() => {
                this.refreshValue();
            });
        }
    }
    ngOnDestroy() {
        this.destroyMaxLengthBox();
        if (this.valueChangesSubscription) {
            this.valueChangesSubscription.unsubscribe();
        }
    }
    refreshValue() {
        let valueLength = 0;
        let remainingLength = 0;
        if (this.format === 'html') {
            const regex = /(<([^>]+)>)/gi;
            const tagsStrippedContent = this.control.value ? this.control.value.replace(regex, '') : '';
            valueLength = tagsStrippedContent.length;
            remainingLength = this.euiEditorMaxlength - valueLength;
        }
        else {
            const content = this.control.value && this.control.value !== ''
                ? JSON.parse(this.control.value)
                    .ops.filter((c) => typeof c.insert === 'string')
                    .map((c) => c.insert.replace(/\n/g, ''))
                : [''];
            const jsonStrippedContent = content.join('');
            valueLength = jsonStrippedContent.length;
            remainingLength = this.euiEditorMaxlength - valueLength;
        }
        if (remainingLength < 0 && this.maxLengthSpan) {
            this.maxLengthSpan.classList.add('error');
            this.maxLengthSpan.innerHTML = '0';
        }
        else {
            if (remainingLength >= 0 && this.maxLengthSpan) {
                this.maxLengthSpan.innerHTML = (this.euiEditorMaxlength - valueLength).toString();
                this.maxLengthSpan.classList.remove('error');
            }
        }
    }
    createMaxLengthBox() {
        this.maxLengthSpan = this.renderer.createElement('span');
        this.renderer.addClass(this.maxLengthSpan, 'input-maxlength');
        this.renderer.setAttribute(this.maxLengthSpan, 'innerHTML', this.euiEditorMaxlength.toString());
        const nativeElement = this.el.nativeElement;
        if (nativeElement != null) {
            this.renderer.setStyle(nativeElement, 'width', '100%');
            const parent = nativeElement.parentNode;
            if (parent != null && this.isShowMaxlength) {
                this.wrapper = this.renderer.createElement('div');
                this.renderer.addClass(this.wrapper, 'input-maxlength-wrapper');
                parent.replaceChild(this.wrapper, nativeElement);
                this.renderer.appendChild(this.wrapper, nativeElement);
                this.renderer.appendChild(this.wrapper, this.maxLengthSpan);
            }
        }
    }
    destroyMaxLengthBox() {
        if (this.maxLengthSpan) {
            this.renderer.removeChild(this.maxLengthSpan.parentElement, this.maxLengthSpan);
        }
        if (this.wrapper) {
            const parent = this.wrapper.parentNode;
            const nativeElement = this.el.nativeElement;
            parent.replaceChild(nativeElement, this.wrapper);
            this.renderer.removeChild(this.wrapper.parentElement, this.wrapper);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorMaxlengthDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "19.2.12", type: EuiEditorMaxlengthDirective, isStandalone: true, selector: "[formControlName][euiEditorMaxlength]", inputs: { format: "format", euiEditorMaxlength: "euiEditorMaxlength", isShowMaxlength: "isShowMaxlength" }, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorMaxlengthDirective, decorators: [{
            type: Directive,
            args: [{
                    /* eslint-disable-next-line */
                    selector: '[formControlName][euiEditorMaxlength]',
                }]
        }], propDecorators: { format: [{
                type: Input
            }], euiEditorMaxlength: [{
                type: Input
            }], isShowMaxlength: [{
                type: Input
            }] } });

const isJson = (value) => {
    try {
        JSON.parse(value);
    }
    catch (e) {
        return false;
    }
    return true;
};
const byteLength = (value) => {
    // returns the byte length of an utf8 string
    let s = value.length;
    for (let i = value.length - 1; i >= 0; i--) {
        const code = value.charCodeAt(i);
        if (code > 0x7f && code <= 0x7ff) {
            s++;
        }
        else if (code > 0x7ff && code <= 0xffff) {
            s += 2;
        }
        if (code >= 0xdc00 && code <= 0xdfff) {
            i--;
        }
    }
    return s;
};
/**
 * @description
 * Validator that requires the length of the editor's content, out of HTML tags or JSON structure, to be greater than or equal
 * to the provided minimum length.
 *
 * @usageNotes
 * Validate that the editor has a minimum of 5 characters:
 *
 * ```typescript
 * const editor = new FormControl('ng', euiEditorMinLength(5));
 * console.log(editor.errors); // { minlength: { minLength: 5, actual: 2 } }
 * ```
 *
 * @returns A validator function that returns an error map with the
 * `minlength` if the validation check fails, otherwise `null`.
 */
const euiEditorMinLength = (minLength) => (control) => {
    if (control.value) {
        let actual = 0;
        if (isJson(control.value)) {
            const content = JSON.parse(control.value)
                .ops.filter((c) => typeof c.insert === 'string')
                .map((c) => c.insert.replace(/\n/g, ''));
            const jsonStrippedContent = content.join('');
            actual = jsonStrippedContent.length;
        }
        else {
            const regex = /(<([^>]+)>)/gi;
            const tagsStrippedContent = control.value.replace(regex, '');
            actual = tagsStrippedContent.length;
        }
        return actual < minLength ? { minLength: { minLength, actual } } : null;
    }
};
/**
 * @description
 * Validator that requires the length of the editor's content, out of HTML tags or JSON structure, to be less than or equal
 * to the provided maximum length.
 *
 * @usageNotes
 * Validate that the editor has a maximum of 10 characters:
 *
 * ```typescript
 * const editor = new FormControl('ng angular reactive', euiEditorMaxLength(10));
 * console.log(editor.errors); // { maxLength: { maxLength: 10, actual: 19 } }
 * ```
 *
 * @returns A validator function that returns an error map with the
 * `maxlength` if the validation check fails, otherwise `null`.
 */
const euiEditorMaxLength = (maxLength) => (control) => {
    if (control.value) {
        let actual = 0;
        if (isJson(control.value)) {
            const content = JSON.parse(control.value)
                .ops.filter((c) => typeof c.insert === 'string')
                .map((c) => c.insert.replace(/\n/g, ''));
            const jsonStrippedContent = content.join('');
            actual = jsonStrippedContent.length;
        }
        else {
            const regex = /(<([^>]+)>)/gi;
            const tagsStrippedContent = control.value.replace(regex, '');
            actual = tagsStrippedContent.length;
        }
        return actual > maxLength ? { maxLength: { maxLength, actual } } : null;
    }
};
/**
 * @description
 * Validator that requires the number of words in the editor, out of HTML tags or JSON structure, to be greater than or equal
 * to the provided minimum number.
 *
 * @usageNotes
 * Validate that the editor has a minimum of 5 words:
 *
 * ```typescript
 * const editor = new FormControl('ng angular', euiEditorMinWords(5));
 * console.log(editor.errors); // { minWords: { minWords: 5, actual: 2 } }
 * ```
 *
 * @returns A validator function that returns an error map with the
 * `minWords` if the validation check fails, otherwise `null`.
 */
const euiEditorMinWords = (minWords) => (control) => {
    const regex = /[\s\n]+/;
    if (control.value) {
        let actual = 0;
        if (isJson(control.value)) {
            const content = JSON.parse(control.value)
                .ops.filter((c) => typeof c.insert === 'string')
                .map((c) => c.insert);
            const jsonStrippedContent = content.join('');
            actual = jsonStrippedContent.replace(/\n/g, ' ').split(/\s+/).filter(t => t !== '').length;
        }
        else {
            const text = control.value.replace(/[\u200B-\u200D\uFEFF]/g, '').replace(/<\/(p|div|br|li|h[1-6])>/gi, ' ').replace(/<[^>]+>/g, '');
            actual = !text ? 0 : text.trim().split(regex).filter(t => t !== '').length;
        }
        return actual < minWords ? { minWords: { minWords, actual } } : null;
    }
};
/**
 * @description
 * Validator that requires the number of words in the editor, out of HTML tags or JSON structure, to be less than or equal
 * to the provided maximum number.
 *
 * @usageNotes
 * Validate that the editor has a maximum of 10 words:
 *
 * ```typescript
 * const editor = new FormControl('ng angular reactive forms editor wysiwyg eui ec europa npm node', euiEditorMaxWords(10));
 * console.log(editor.errors); // { maxWords: { maxWords: 10, actual: 11 } }
 * ```
 *
 * @returns A validator function that returns an error map with the
 * `maxWords` if the validation check fails, otherwise `null`.
 */
const euiEditorMaxWords = (maxWords) => (control) => {
    const regex = /[\s\n]+/;
    if (control.value) {
        let actual = 0;
        if (isJson(control.value)) {
            const content = JSON.parse(control.value)
                .ops.filter((c) => typeof c.insert === 'string')
                .map((c) => c.insert);
            const jsonStrippedContent = content.join('');
            actual = jsonStrippedContent.replace(/\n/g, ' ').split(/\s+/).filter(t => t !== '').length;
        }
        else {
            const text = control.value.replace(/[\u200B-\u200D\uFEFF]/g, '').replace(/<\/(p|div|br|li|h[1-6])>/gi, ' ').replace(/<[^>]+>/g, '');
            actual = !text ? 0 : text.trim().split(regex).filter(t => t !== '').length;
        }
        return actual > maxWords ? { maxWords: { maxWords, actual } } : null;
    }
};
/**
 * @description
 * Validator that requires the number of bytes in the editor, with HTML tags or JSON structure, to be greater than or equal
 * to the provided minimum number.
 *
 * @usageNotes
 * Validate that the editor has a minimum of 20 bytes:
 *
 * ```typescript
 * const editor = new FormControl('<p>europa.eu</p>', euiEditorMinBytes(20));
 * console.log(editor.errors); // { minBytes: { minBytes: 20, actual: 16 } }
 * ```
 *
 * @returns A validator function that returns an error map with the
 * `minBytes` if the validation check fails, otherwise `null`.
 */
const euiEditorMinBytes = (minBytes) => (control) => {
    if (control.value) {
        let actual = 0;
        const m = encodeURIComponent(control.value).match(/%[89ABab]/g);
        actual = control.value.length + (m ? m.length : 0);
        return actual < minBytes ? { minBytes: { minBytes, actual } } : null;
    }
};
/**
 * @description
 * Validator that requires the number of bytes in the editor, with HTML tags or JSON structure, to be less than or equal
 * to the provided minimum number.
 *
 * @usageNotes
 * Validate that the editor has a maximum of 20 bytes:
 *
 * ```typescript
 * const editor = new FormControl('<p>europa.eu site</p>', euiEditorMinBytes(20));
 * console.log(editor.errors); // { maxBytes: { maxBytes: 20, actual: 21 } }
 * ```
 *
 * @returns A validator function that returns an error map with the
 * `maxBytes` if the validation check fails, otherwise `null`.
 */
const euiEditorMaxBytes = (maxBytes) => (control) => {
    if (control.value) {
        let actual = 0;
        if (isJson(control.value)) {
            actual = byteLength(control.value);
        }
        else {
            const m = encodeURIComponent(control.value).match(/%[89ABab]/g);
            actual = control.value.length + (m ? m.length : 0);
        }
        return actual > maxBytes ? { maxBytes: { maxBytes, actual } } : null;
    }
};

// In case of dynamic loading this will not be available at this stage.
// Thus the config for BetterTable keyboardBindings needs to be set at a later
// stage. Same as the registration.
const QuillBetterTable = window['quillBetterTable'];
const quillConfig = {
    modules: {
        table: false,
        'better-table': {
            operationMenu: {
                items: {
                    unmergeCells: {
                        text: 'Another unmerge cells name',
                    },
                },
                color: {
                    colors: [
                        '#000000',
                        '#e60000',
                        '#ff9900',
                        '#ffff00',
                        '#008a00',
                        '#0066cc',
                        '#9933ff',
                        '#ffffff',
                        '#facccc',
                        '#ffebcc',
                        '#ffffcc',
                        '#cce8cc',
                        '#cce0f5',
                        '#ebd6ff',
                        '#bbbbbb',
                        '#f06666',
                        '#ffc266',
                        '#ffff66',
                        '#66b966',
                        '#66a3e0',
                        '#c285ff',
                        '#888888',
                        '#a10000',
                        '#b26b00',
                        '#b2b200',
                        '#006100',
                        '#0047b2',
                        '#6b24b2',
                        '#444444',
                        '#5c0000',
                        '#663d00',
                        '#666600',
                        '#003700',
                        '#002966',
                        '#3d1466',
                    ],
                    text: 'Background Colors',
                },
            },
        },
    },
};
if (QuillBetterTable) {
    quillConfig.modules.keyboard = {
        bindings: QuillBetterTable?.keyboardBindings,
    };
}
class EuiEditorModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorModule, imports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            EuiTooltipDirectiveModule, i1.QuillModule, EuiDialogModule,
            EuiIconModule,
            EuiInputTextModule,
            EuiEditorComponent,
            EuiEditorJsonViewComponent,
            EuiEditorHtmlViewComponent,
            EuiEditorCountersComponent,
            EuiEditorImageDialogComponent,
            EuiEditorMaxlengthDirective,
            EuiEditorCustomToolbarTagDirective,
            ClassFilterPipe], exports: [EuiEditorComponent, EuiEditorMaxlengthDirective, EuiEditorCustomToolbarTagDirective, EuiEditorCountersComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorModule, imports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            EuiTooltipDirectiveModule,
            QuillModule.forRoot(quillConfig),
            EuiDialogModule,
            EuiIconModule,
            EuiInputTextModule,
            EuiEditorComponent,
            EuiEditorImageDialogComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiEditorModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        EuiTooltipDirectiveModule,
                        QuillModule.forRoot(quillConfig),
                        EuiDialogModule,
                        EuiIconModule,
                        EuiInputTextModule,
                        EuiEditorComponent,
                        EuiEditorJsonViewComponent,
                        EuiEditorHtmlViewComponent,
                        EuiEditorCountersComponent,
                        EuiEditorImageDialogComponent,
                        EuiEditorMaxlengthDirective,
                        EuiEditorCustomToolbarTagDirective,
                        ClassFilterPipe,
                    ],
                    exports: [EuiEditorComponent, EuiEditorMaxlengthDirective, EuiEditorCustomToolbarTagDirective, EuiEditorCountersComponent],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ClassFilterPipe, EuiEditorComponent, EuiEditorCountersComponent, EuiEditorCustomToolbarTagDirective, EuiEditorMaxlengthDirective, EuiEditorModule, euiEditorMaxBytes, euiEditorMaxLength, euiEditorMaxWords, euiEditorMinBytes, euiEditorMinLength, euiEditorMinWords };
//# sourceMappingURL=eui-components-externals-eui-editor.mjs.map
