import * as i0 from '@angular/core';
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { RouterModule } from '@angular/router';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { EuiLayoutModule } from '@eui/components/layout';
import { EuiBadgeModule } from '@eui/components/eui-badge';
import { EuiIconToggleModule } from '@eui/components/eui-icon-toggle';
import { EuiLabelModule } from '@eui/components/eui-label';
import { EuiButtonModule } from '@eui/components/eui-button';
import { EuiButtonGroupModule } from '@eui/components/eui-button-group';
import { EuiDashboardButtonModule } from '@eui/components/eui-dashboard-button';
import { EuiDashboardCardModule } from '@eui/components/eui-dashboard-card';
import { EuiSlideToggleModule } from '@eui/components/eui-slide-toggle';
import { EuiBlockDocumentModule } from '@eui/components/eui-block-document';
import { EuiBlockContentModule } from '@eui/components/eui-block-content';
import { EuiFeedbackMessageModule } from '@eui/components/eui-feedback-message';
import { EuiFieldsetModule } from '@eui/components/eui-fieldset';
import { EuiProgressCircleModule } from '@eui/components/eui-progress-circle';
import { EuiDisableContentModule } from '@eui/components/eui-disable-content';
import { EuiTimebarModule } from '@eui/components/eui-timebar';
import { EuiSidebarMenuModule } from '@eui/components/eui-sidebar-menu';
import { EuiProgressBarModule } from '@eui/components/eui-progress-bar';
import { EuiSkeletonModule } from '@eui/components/eui-skeleton';
import { EuiInputNumberModule } from '@eui/components/eui-input-number';
import { EuiInputCheckboxModule } from '@eui/components/eui-input-checkbox';
import { EuiInputRadioModule } from '@eui/components/eui-input-radio';
import { EuiInputTextModule } from '@eui/components/eui-input-text';
import { EuiAutocompleteModule } from '@eui/components/eui-autocomplete';
import { EuiCardModule } from '@eui/components/eui-card';
import { EuiChipModule } from '@eui/components/eui-chip';
import { EuiChipListModule } from '@eui/components/eui-chip-list';
import { EuiAlertModule } from '@eui/components/eui-alert';
import { EuiTreeListModule } from '@eui/components/eui-tree-list';
import { EuiAvatarModule } from '@eui/components/eui-avatar';
import { EuiUserProfileModule } from '@eui/components/eui-user-profile';
import { EuiAccordionModule } from '@eui/components/eui-accordion';
import { EuiSplitButtonModule } from '@eui/components/eui-split-button';
import { EuiBreadcrumbModule } from '@eui/components/eui-breadcrumb';
import { EuiIconButtonExpanderModule } from '@eui/components/eui-icon-button-expander';
import { EuiIconModule } from '@eui/components/eui-icon';
import { EuiIconInputModule } from '@eui/components/eui-icon-input';
import { EuiIconButtonModule } from '@eui/components/eui-icon-button';
import { EuiIconStateModule } from '@eui/components/eui-icon-state';
import { EuiDateRangeSelectorModule } from '@eui/components/eui-date-range-selector';
import { EuiSelectModule } from '@eui/components/eui-select';
import { EuiTextAreaModule } from '@eui/components/eui-textarea';
import { EuiInputGroupModule } from '@eui/components/eui-input-group';
import { EuiTimepickerModule } from '@eui/components/eui-timepicker';
import { EuiDatepickerModule } from '@eui/components/eui-datepicker';
import { EuiDimmerModule } from '@eui/components/eui-dimmer';
import { EuiPageModule } from '@eui/components/eui-page';
import { EuiWizardModule } from '@eui/components/eui-wizard';
import { EuiTimelineModule } from '@eui/components/eui-timeline';
import { EuiDiscussionThreadModule } from '@eui/components/eui-discussion-thread';
import { EuiPopoverModule } from '@eui/components/eui-popover';
import { EuiListModule } from '@eui/components/eui-list';
import { EuiIconColorModule } from '@eui/components/eui-icon-color';
import { EuiLanguageSelectorModule } from '@eui/components/eui-language-selector';
import { EuiNavbarModule } from '@eui/components/eui-navbar';
import { EuiMenuModule } from '@eui/components/eui-menu';
import { EuiOverlayModule } from '@eui/components/eui-overlay';
import { EuiTabsModule } from '@eui/components/eui-tabs';
import { EuiPaginatorModule } from '@eui/components/eui-paginator';
import { EuiDialogModule } from '@eui/components/eui-dialog';
import { EuiDropdownModule } from '@eui/components/eui-dropdown';
import { EuiTableModule } from '@eui/components/eui-table';
import { EuiTableV2Module } from '@eui/components/eui-table-v2';
import { EuiFileUploadModule } from '@eui/components/eui-file-upload';
import { EuiGrowlModule } from '@eui/components/eui-growl';
import { EuiMessageBoxModule } from '@eui/components/eui-message-box';
import { EuiTreeModule } from '@eui/components/eui-tree';
import { EuiTemplateDirectiveModule, EuiTooltipDirectiveModule, EuiMaxLengthDirectiveModule, EuiSmoothScrollDirectiveModule, EuiScrollHandlerDirectiveModule, EuiHasPermissionDirectiveModule, EuiResizableDirectiveModule } from '@eui/components/directives';
import { EuiTruncatePipeModule } from '@eui/components/pipes';

const MODULES = [
    EuiLayoutModule,
    EuiOverlayModule,
    EuiTemplateDirectiveModule,
    EuiTooltipDirectiveModule,
    EuiInputNumberModule,
    EuiMaxLengthDirectiveModule,
    EuiSmoothScrollDirectiveModule,
    EuiScrollHandlerDirectiveModule,
    EuiHasPermissionDirectiveModule,
    EuiResizableDirectiveModule,
    EuiPageModule,
    EuiDimmerModule,
    EuiBadgeModule,
    EuiIconModule,
    EuiLabelModule,
    EuiIconToggleModule,
    EuiAlertModule,
    EuiAutocompleteModule,
    EuiBlockDocumentModule,
    EuiBlockContentModule,
    EuiButtonModule,
    EuiCardModule,
    EuiChipModule,
    EuiChipListModule,
    EuiDashboardButtonModule,
    EuiDashboardCardModule,
    EuiDatepickerModule,
    EuiDateRangeSelectorModule,
    EuiSlideToggleModule,
    EuiPopoverModule,
    EuiFeedbackMessageModule,
    EuiTimepickerModule,
    EuiInputCheckboxModule,
    EuiSelectModule,
    EuiInputRadioModule,
    EuiInputTextModule,
    EuiTextAreaModule,
    EuiInputGroupModule,
    EuiFieldsetModule,
    EuiButtonGroupModule,
    EuiProgressCircleModule,
    EuiDisableContentModule,
    EuiWizardModule,
    EuiTimelineModule,
    EuiTimebarModule,
    EuiDiscussionThreadModule,
    EuiSidebarMenuModule,
    EuiProgressBarModule,
    EuiTreeListModule,
    EuiAvatarModule,
    EuiSkeletonModule,
    EuiUserProfileModule,
    EuiAccordionModule,
    EuiSplitButtonModule,
    EuiBreadcrumbModule,
    EuiIconButtonExpanderModule,
    EuiIconInputModule,
    EuiIconButtonModule,
    EuiIconStateModule,
    EuiDropdownModule,
    EuiDialogModule,
    EuiGrowlModule,
    EuiTabsModule,
    EuiMenuModule,
    EuiMessageBoxModule,
    EuiListModule,
    EuiTableModule,
    EuiTableV2Module,
    EuiFileUploadModule,
    EuiTreeModule,
    EuiTruncatePipeModule,
    EuiPaginatorModule,
    EuiLanguageSelectorModule,
    EuiIconColorModule,
    EuiNavbarModule,
];
class EuiAllModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiAllModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "19.2.12", ngImport: i0, type: EuiAllModule, imports: [CommonModule, RouterModule, ReactiveFormsModule, FormsModule, EuiLayoutModule,
            EuiOverlayModule,
            EuiTemplateDirectiveModule,
            EuiTooltipDirectiveModule,
            EuiInputNumberModule,
            EuiMaxLengthDirectiveModule,
            EuiSmoothScrollDirectiveModule,
            EuiScrollHandlerDirectiveModule,
            EuiHasPermissionDirectiveModule,
            EuiResizableDirectiveModule,
            EuiPageModule,
            EuiDimmerModule,
            EuiBadgeModule,
            EuiIconModule,
            EuiLabelModule,
            EuiIconToggleModule,
            EuiAlertModule,
            EuiAutocompleteModule,
            EuiBlockDocumentModule,
            EuiBlockContentModule,
            EuiButtonModule,
            EuiCardModule,
            EuiChipModule,
            EuiChipListModule,
            EuiDashboardButtonModule,
            EuiDashboardCardModule,
            EuiDatepickerModule,
            EuiDateRangeSelectorModule,
            EuiSlideToggleModule,
            EuiPopoverModule,
            EuiFeedbackMessageModule,
            EuiTimepickerModule,
            EuiInputCheckboxModule,
            EuiSelectModule,
            EuiInputRadioModule,
            EuiInputTextModule,
            EuiTextAreaModule,
            EuiInputGroupModule,
            EuiFieldsetModule,
            EuiButtonGroupModule,
            EuiProgressCircleModule,
            EuiDisableContentModule,
            EuiWizardModule,
            EuiTimelineModule,
            EuiTimebarModule,
            EuiDiscussionThreadModule,
            EuiSidebarMenuModule,
            EuiProgressBarModule,
            EuiTreeListModule,
            EuiAvatarModule,
            EuiSkeletonModule,
            EuiUserProfileModule,
            EuiAccordionModule,
            EuiSplitButtonModule,
            EuiBreadcrumbModule,
            EuiIconButtonExpanderModule,
            EuiIconInputModule,
            EuiIconButtonModule,
            EuiIconStateModule,
            EuiDropdownModule,
            EuiDialogModule,
            EuiGrowlModule,
            EuiTabsModule,
            EuiMenuModule,
            EuiMessageBoxModule,
            EuiListModule,
            EuiTableModule,
            EuiTableV2Module,
            EuiFileUploadModule,
            EuiTreeModule,
            EuiTruncatePipeModule,
            EuiPaginatorModule,
            EuiLanguageSelectorModule,
            EuiIconColorModule,
            EuiNavbarModule], exports: [EuiLayoutModule,
            EuiOverlayModule,
            EuiTemplateDirectiveModule,
            EuiTooltipDirectiveModule,
            EuiInputNumberModule,
            EuiMaxLengthDirectiveModule,
            EuiSmoothScrollDirectiveModule,
            EuiScrollHandlerDirectiveModule,
            EuiHasPermissionDirectiveModule,
            EuiResizableDirectiveModule,
            EuiPageModule,
            EuiDimmerModule,
            EuiBadgeModule,
            EuiIconModule,
            EuiLabelModule,
            EuiIconToggleModule,
            EuiAlertModule,
            EuiAutocompleteModule,
            EuiBlockDocumentModule,
            EuiBlockContentModule,
            EuiButtonModule,
            EuiCardModule,
            EuiChipModule,
            EuiChipListModule,
            EuiDashboardButtonModule,
            EuiDashboardCardModule,
            EuiDatepickerModule,
            EuiDateRangeSelectorModule,
            EuiSlideToggleModule,
            EuiPopoverModule,
            EuiFeedbackMessageModule,
            EuiTimepickerModule,
            EuiInputCheckboxModule,
            EuiSelectModule,
            EuiInputRadioModule,
            EuiInputTextModule,
            EuiTextAreaModule,
            EuiInputGroupModule,
            EuiFieldsetModule,
            EuiButtonGroupModule,
            EuiProgressCircleModule,
            EuiDisableContentModule,
            EuiWizardModule,
            EuiTimelineModule,
            EuiTimebarModule,
            EuiDiscussionThreadModule,
            EuiSidebarMenuModule,
            EuiProgressBarModule,
            EuiTreeListModule,
            EuiAvatarModule,
            EuiSkeletonModule,
            EuiUserProfileModule,
            EuiAccordionModule,
            EuiSplitButtonModule,
            EuiBreadcrumbModule,
            EuiIconButtonExpanderModule,
            EuiIconInputModule,
            EuiIconButtonModule,
            EuiIconStateModule,
            EuiDropdownModule,
            EuiDialogModule,
            EuiGrowlModule,
            EuiTabsModule,
            EuiMenuModule,
            EuiMessageBoxModule,
            EuiListModule,
            EuiTableModule,
            EuiTableV2Module,
            EuiFileUploadModule,
            EuiTreeModule,
            EuiTruncatePipeModule,
            EuiPaginatorModule,
            EuiLanguageSelectorModule,
            EuiIconColorModule,
            EuiNavbarModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiAllModule, imports: [CommonModule, RouterModule, ReactiveFormsModule, FormsModule, MODULES, EuiLayoutModule,
            EuiOverlayModule,
            EuiTemplateDirectiveModule,
            EuiTooltipDirectiveModule,
            EuiInputNumberModule,
            EuiMaxLengthDirectiveModule,
            EuiSmoothScrollDirectiveModule,
            EuiScrollHandlerDirectiveModule,
            EuiHasPermissionDirectiveModule,
            EuiResizableDirectiveModule,
            EuiPageModule,
            EuiDimmerModule,
            EuiBadgeModule,
            EuiIconModule,
            EuiLabelModule,
            EuiIconToggleModule,
            EuiAlertModule,
            EuiAutocompleteModule,
            EuiBlockDocumentModule,
            EuiBlockContentModule,
            EuiButtonModule,
            EuiCardModule,
            EuiChipModule,
            EuiChipListModule,
            EuiDashboardButtonModule,
            EuiDashboardCardModule,
            EuiDatepickerModule,
            EuiDateRangeSelectorModule,
            EuiSlideToggleModule,
            EuiPopoverModule,
            EuiFeedbackMessageModule,
            EuiTimepickerModule,
            EuiInputCheckboxModule,
            EuiSelectModule,
            EuiInputRadioModule,
            EuiInputTextModule,
            EuiTextAreaModule,
            EuiInputGroupModule,
            EuiFieldsetModule,
            EuiButtonGroupModule,
            EuiProgressCircleModule,
            EuiDisableContentModule,
            EuiWizardModule,
            EuiTimelineModule,
            EuiTimebarModule,
            EuiDiscussionThreadModule,
            EuiSidebarMenuModule,
            EuiProgressBarModule,
            EuiTreeListModule,
            EuiAvatarModule,
            EuiSkeletonModule,
            EuiUserProfileModule,
            EuiAccordionModule,
            EuiSplitButtonModule,
            EuiBreadcrumbModule,
            EuiIconButtonExpanderModule,
            EuiIconInputModule,
            EuiIconButtonModule,
            EuiIconStateModule,
            EuiDropdownModule,
            EuiDialogModule,
            EuiGrowlModule,
            EuiTabsModule,
            EuiMenuModule,
            EuiMessageBoxModule,
            EuiListModule,
            EuiTableModule,
            EuiTableV2Module,
            EuiFileUploadModule,
            EuiTreeModule,
            EuiTruncatePipeModule,
            EuiPaginatorModule,
            EuiLanguageSelectorModule,
            EuiIconColorModule,
            EuiNavbarModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "19.2.12", ngImport: i0, type: EuiAllModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, RouterModule, ReactiveFormsModule, FormsModule, ...MODULES],
                    exports: [...MODULES],
                }]
        }] });

// ROOT MODULE

/**
 * Generated bundle index. Do not edit.
 */

export { EuiAllModule };
//# sourceMappingURL=eui-components.mjs.map
