import { EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { UxLinkLegacy } from '@eui/base';
import { NotificationMetadata } from './eui-notification-item.component';
import * as i0 from "@angular/core";
export declare class EuiNotificationsComponent implements OnInit, OnChanges {
    refreshClick: EventEmitter<void>;
    notificationsClick: EventEmitter<void>;
    viewAllClick: EventEmitter<void>;
    settingsClick: EventEmitter<MouseEvent>;
    markAllAsReadClick: EventEmitter<MouseEvent>;
    noNotificationFoundClick: EventEmitter<void>;
    itemClick: EventEmitter<UxLinkLegacy<NotificationMetadata>>;
    itemMarkAsReadClick: EventEmitter<UxLinkLegacy<NotificationMetadata>>;
    isOverlayActive: boolean;
    currentDayNotifications: any[];
    oldestNotifications: any[];
    unreadNotifications: any[];
    today: Date;
    string: string;
    count: number;
    items: any[];
    unreadLabel: string;
    totalLabel: string;
    markAsReadLabel: string;
    markAsUnReadLabel: string;
    markAllAsReadLabel: string;
    settingsLabel: string;
    refreshLabel: string;
    viewAllNotificationsLabel: string;
    headerTitleLabel: string;
    noNotificationFoundLabel: string;
    nbUnreadCount: number;
    dateFormat: string;
    noNotificationFoundLink: boolean;
    isShowMarkAsRead: boolean;
    isShowViewAllAction: boolean;
    isHidePanelOnViewAllAction: boolean;
    customUnreadCount: boolean;
    isShowMarkAllAsReadButton: boolean;
    isShowSettingsButton: boolean;
    isShowRefreshButton: boolean;
    onClicked(event: MouseEvent | Event): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    onRefresh(event: Event): void;
    onItemClick(link: UxLinkLegacy<NotificationMetadata>): void;
    onViewAllClick(event: Event): void;
    onNoNotificationFoundClick(): void;
    onItemMarkAsRead(link: UxLinkLegacy<NotificationMetadata>): void;
    onMarkAllAsRead(e: MouseEvent): void;
    onSettings(e: MouseEvent): void;
    protected trackByFn(index: number, item: UxLinkLegacy<NotificationMetadata>): string;
    protected updateActiveState(isActive: boolean): void;
    protected getAriaLabel(): string;
    private _getUnreadCount;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiNotificationsComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiNotificationsComponent, "eui-notifications", never, { "count": { "alias": "count"; "required": false; }; "items": { "alias": "items"; "required": false; }; "unreadLabel": { "alias": "unreadLabel"; "required": false; }; "totalLabel": { "alias": "totalLabel"; "required": false; }; "markAsReadLabel": { "alias": "markAsReadLabel"; "required": false; }; "markAsUnReadLabel": { "alias": "markAsUnReadLabel"; "required": false; }; "markAllAsReadLabel": { "alias": "markAllAsReadLabel"; "required": false; }; "settingsLabel": { "alias": "settingsLabel"; "required": false; }; "refreshLabel": { "alias": "refreshLabel"; "required": false; }; "viewAllNotificationsLabel": { "alias": "viewAllNotificationsLabel"; "required": false; }; "headerTitleLabel": { "alias": "headerTitleLabel"; "required": false; }; "noNotificationFoundLabel": { "alias": "noNotificationFoundLabel"; "required": false; }; "nbUnreadCount": { "alias": "nbUnreadCount"; "required": false; }; "dateFormat": { "alias": "dateFormat"; "required": false; }; "noNotificationFoundLink": { "alias": "noNotificationFoundLink"; "required": false; }; "isShowMarkAsRead": { "alias": "isShowMarkAsRead"; "required": false; }; "isShowViewAllAction": { "alias": "isShowViewAllAction"; "required": false; }; "isHidePanelOnViewAllAction": { "alias": "isHidePanelOnViewAllAction"; "required": false; }; "customUnreadCount": { "alias": "customUnreadCount"; "required": false; }; "isShowMarkAllAsReadButton": { "alias": "isShowMarkAllAsReadButton"; "required": false; }; "isShowSettingsButton": { "alias": "isShowSettingsButton"; "required": false; }; "isShowRefreshButton": { "alias": "isShowRefreshButton"; "required": false; }; }, { "refreshClick": "refreshClick"; "notificationsClick": "notificationsClick"; "viewAllClick": "viewAllClick"; "settingsClick": "settingsClick"; "markAllAsReadClick": "markAllAsReadClick"; "noNotificationFoundClick": "noNotificationFoundClick"; "itemClick": "itemClick"; "itemMarkAsReadClick": "itemMarkAsReadClick"; }, never, never, true, never>;
    static ngAcceptInputType_noNotificationFoundLink: unknown;
    static ngAcceptInputType_isShowMarkAsRead: unknown;
    static ngAcceptInputType_isShowViewAllAction: unknown;
    static ngAcceptInputType_isHidePanelOnViewAllAction: unknown;
    static ngAcceptInputType_customUnreadCount: unknown;
    static ngAcceptInputType_isShowMarkAllAsReadButton: unknown;
    static ngAcceptInputType_isShowSettingsButton: unknown;
    static ngAcceptInputType_isShowRefreshButton: unknown;
}
//# sourceMappingURL=eui-notifications.component.d.ts.map