import { SimpleChanges, OnInit, OnDestroy, EventEmitter, OnChanges } from '@angular/core';
import { EuiAppShellService } from '@eui/core';
import { EuiMenuItem } from '@eui/components/eui-menu';
import * as i0 from "@angular/core";
export interface ToolbarItem<M = unknown> extends EuiMenuItem<M> {
    isHome?: boolean;
    isSeparator?: boolean;
    children?: ToolbarItem<M>[];
}
export declare class EuiToolbarMenuComponent<Item extends ToolbarItem = ToolbarItem> implements OnInit, OnDestroy, OnChanges {
    get cssClasses(): string;
    items: Item[];
    menuItemClick: EventEmitter<ToolbarItem<unknown>>;
    isdropdownOpen: boolean;
    asService: EuiAppShellService;
    private subs;
    private cd;
    private document;
    constructor();
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onLinkClick(link: ToolbarItem): void;
    onKeyDown(event: KeyboardEvent, link: ToolbarItem): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiToolbarMenuComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiToolbarMenuComponent<any>, "eui-toolbar-menu", never, { "items": { "alias": "items"; "required": false; }; }, { "menuItemClick": "menuItemClick"; }, never, never, true, never>;
}
//# sourceMappingURL=toolbar-menu.component.d.ts.map