import { EventEmitter, TemplateRef, AfterViewInit, QueryList, AfterContentInit } from '@angular/core';
import { EuiAutoCompleteItem } from '@eui/components/eui-autocomplete';
import { EuiTemplateDirective } from '@eui/components/directives';
import { EuiAppShellService } from '@eui/core';
import * as i0 from "@angular/core";
export declare class EuiToolbarSearchComponent implements AfterViewInit, AfterContentInit {
    get cssClasses(): string;
    isInputFocus: boolean;
    searchTerm: string;
    searchInput: string;
    resultItemTemplate: TemplateRef<{
        $implicit: EuiAutoCompleteItem;
    }>;
    placeholderLabel: string;
    panelWidth: string;
    searchResults: EuiAutoCompleteItem[];
    isAutocomplete: boolean;
    isInputText: boolean;
    hasSearchButton: boolean;
    hasExpandAnimation: boolean;
    search: EventEmitter<string>;
    selectionChange: EventEmitter<EuiAutoCompleteItem[]>;
    searchClick: EventEmitter<string>;
    inputFocus: EventEmitter<Event>;
    inputBlur: EventEmitter<Event>;
    templates: QueryList<EuiTemplateDirective>;
    protected asService: EuiAppShellService;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    onSelectionChange(items: EuiAutoCompleteItem[]): void;
    onInputFocus(event: Event): void;
    onInputBlur(event: Event): void;
    onSearch(e: string): void;
    onSearchInput(e: KeyboardEvent): void;
    onSearchClick(isIconOnly: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<EuiToolbarSearchComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EuiToolbarSearchComponent, "eui-toolbar-search", never, { "placeholderLabel": { "alias": "placeholderLabel"; "required": false; }; "panelWidth": { "alias": "panelWidth"; "required": false; }; "searchResults": { "alias": "searchResults"; "required": false; }; "isAutocomplete": { "alias": "isAutocomplete"; "required": false; }; "isInputText": { "alias": "isInputText"; "required": false; }; "hasSearchButton": { "alias": "hasSearchButton"; "required": false; }; "hasExpandAnimation": { "alias": "hasExpandAnimation"; "required": false; }; }, { "search": "search"; "selectionChange": "selectionChange"; "searchClick": "searchClick"; "inputFocus": "inputFocus"; "inputBlur": "inputBlur"; }, ["templates"], never, true, never>;
    static ngAcceptInputType_isAutocomplete: unknown;
    static ngAcceptInputType_isInputText: unknown;
    static ngAcceptInputType_hasSearchButton: unknown;
    static ngAcceptInputType_hasExpandAnimation: unknown;
}
//# sourceMappingURL=toolbar-search.component.d.ts.map